import * as i0 from '@angular/core';
import { InjectionToken, EventEmitter, Injectable, Directive, Input, ViewChild, ViewContainerRef, Component, Output, HostListener, Inject, NgModule } from '@angular/core';
import { Subject, fromEvent } from 'rxjs';
import * as i3 from 'ng-devui';
import { FormLayout, CascaderComponent, FormModule, TextInputModule, LayoutModule, TabsModule, TextareaModule, ToggleModule, SelectModule, InputNumberModule, ButtonModule, ModalModule, AlertModule, CheckBoxModule, RadioModule, DatepickerModule, TimePickerModule, UploadModule, RateModule, ProgressModule, ToastModule, DatepickerProModule, SliderModule, TransferModule, CascaderModule } from 'ng-devui';
import { js_beautify } from 'js-beautify';
import * as i1 from '@angular/common/http';
import { HttpClientModule } from '@angular/common/http';
import * as i4 from '@angular/common';
import { DOCUMENT, CommonModule } from '@angular/common';
import { UUID } from 'angular2-uuid';
import * as i5 from '@angular/forms';
import { FormControl, FormGroup, FormsModule, ReactiveFormsModule } from '@angular/forms';
import * as ClassicEditor from '@ckeditor/ckeditor5-build-classic';
import * as i4$1 from '@ckeditor/ckeditor5-angular';
import { CKEditorModule } from '@ckeditor/ckeditor5-angular';
import 'codemirror/mode/javascript/javascript';
import 'codemirror/addon/lint/lint';
import 'codemirror/addon/lint/javascript-lint';
import { JSHINT } from 'jshint';
import * as i1$1 from '@ctrl/ngx-codemirror';
import { CodemirrorModule } from '@ctrl/ngx-codemirror';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { BrowserModule } from '@angular/platform-browser';

const FORM_ALERT = new InjectionToken("form-alert");
const FORM_CHECKBOX = new InjectionToken("form-checkbox");
const FORM_COUNTER = new InjectionToken("form-counter");
const FORM_DATE = new InjectionToken("form-date");
const FORM_DIVIDER = new InjectionToken("form-divider");
const FORM_INPUT = new InjectionToken("form-input");
const FORM_LAYOUT = new InjectionToken("form-layout");
const FORM_RADIO = new InjectionToken("form-radio");
const FORM_RATE = new InjectionToken("form-rate");
const FORM_RICHINPUT = new InjectionToken("form-richinput");
const FORM_SELECT = new InjectionToken("form-select");
const FORM_SLIDER = new InjectionToken("form-slider");
const FORM_SPACE = new InjectionToken("form-space");
const FORM_TIME = new InjectionToken("form-time");
const FORM_TOGGLE = new InjectionToken("form-toggle");
const FORM_TRANSFER = new InjectionToken("form-transfer");
const FORM_TREE = new InjectionToken("form-tree");
const FORM_UPLOAD = new InjectionToken("form-upload");

class ControlBuilder {
    constructor(control, data) {
        this.control = control;
        this.data = data;
    }
}

var ControlType;
(function (ControlType) {
    ControlType["Input"] = "Input";
    ControlType["Select"] = "select";
    ControlType["Check"] = "check";
    ControlType["Radio"] = "radio";
    ControlType["Toggle"] = "toggle";
    ControlType["Date"] = "date";
    ControlType["Range"] = "range";
    ControlType["Time"] = "time";
    ControlType["RichIput"] = "richInput";
    ControlType["Upload"] = "upload";
    ControlType["Alert"] = "alert";
    ControlType["Label"] = "label";
    ControlType["Divider"] = "divider";
    ControlType["Space"] = "space";
    ControlType["Rate"] = "rate";
    ControlType["Counter"] = "counter";
    ControlType["Row"] = "row";
    ControlType["Slide"] = "slide";
    ControlType["Transfer"] = "transfer";
    ControlType["Tree"] = "tree";
})(ControlType || (ControlType = {}));

const CommonDefault = {
    required: false,
    help: false,
    mode: "op",
    disabled: false
};
const INPUTDEFAULT = Object.assign({ label: "文本框", controltype: ControlType.Input, defaultvalue: "", placeholder: "" }, CommonDefault);
const DATEDEFAULT = Object.assign({ label: "日期选择", controltype: ControlType.Date, defaultvalue: "", datetype: "date", showtime: false, dateFormat: "y/MM/dd", placeholder: "y/MM/dd" }, CommonDefault);
const TIMEDEFAULT = Object.assign({ label: "时间选择", controltype: ControlType.Time, defaultvalue: "", format: "hh:mm:ss", placeholder: "hh:mm:ss" }, CommonDefault);
const RICHINPUTDEFAULT = Object.assign({ label: "富文本框", controltype: ControlType.RichIput, height: 200, defaultvalue: "" }, CommonDefault);
const COUNTERDEFAULT = Object.assign({ label: "计数器", controltype: ControlType.Counter, defaultvalue: 0, min: 0, max: 200, step: 1, unit: "" }, CommonDefault);
const LAYOUTDEFAULT = Object.assign({ label: "布局", controltype: ControlType.Row }, CommonDefault);
const RATEDEFAULT = Object.assign({ label: "评分", controltype: ControlType.Rate, defaultvalue: 0, allowhalf: false }, CommonDefault);
const TOGGLEDEFAULT = Object.assign({ label: "开关", controltype: ControlType.Toggle }, CommonDefault);
const DIVIDERDEFAULT = Object.assign({ label: "请输入", controltype: ControlType.Divider, align: "is-center", alignvalue: { label: "居中", value: "is-center" } }, CommonDefault);
const CANVASDEFAULT = {
    layout: FormLayout.Vertical,
    labelAlign: "",
    labelSize: "start"
};
const SELECTDEFAULT = Object.assign({ label: "下拉框", controltype: ControlType.Select, defaultvalue: "", placeholder: "请选择", options: [
        { "label": "label1", "value": "value1" },
        { "label": "label2", "value": "value2" }
    ], filter: "value", dataType: "static", postdata: {
        url: "",
        method: "GET",
        data: {},
        head: {},
        function: js_beautify("function (res){return res.data;}")
    }, multiple: false }, CommonDefault);
const ALERTDEFAULT = Object.assign({ label: "请填写", controltype: ControlType.Alert, alerttype: "info", closeable: false }, CommonDefault);
const CHECKDEFAULT = Object.assign({ label: "多选框", controltype: ControlType.Check, direction: "row", isshowtitle: true, options: [
        { "label": "label1", "value": "value1", disabled: true },
        { "label": "label2", "value": "value2" }
    ], filter: "value", dataType: "static", postdata: {
        url: "",
        method: "GET",
        data: {},
        head: {},
        function: js_beautify("function (res){return res.data;}")
    } }, CommonDefault);
const RADIODEFAULT = Object.assign({ label: "多选框", controltype: ControlType.Radio, direction: "row", isshowtitle: true, options: [
        "label1",
        "label"
    ], dataType: "static", postdata: {
        url: "",
        method: "GET",
        data: {},
        head: {},
        function: js_beautify("function (res){return res.data;}")
    } }, CommonDefault);
const SPACEDEFAULT = Object.assign({ controltype: ControlType.Space, height: 20 }, CommonDefault);
const UPLOADDEFAULT = Object.assign({ label: "上传", controltype: ControlType.Upload, fileOptions: {
        accept: '.png,.zip',
        multiple: false
    }, uploadOptions: {
        uri: '/upload',
        headers: {},
        additionalParameter: {},
        maximumSize: 0.5,
        method: 'POST',
        fileFieldName: 'dFile',
        withCredentials: true,
        responseType: 'json'
    }, uploadedFiles: [], filePath: "name", uploadtype: "single" }, CommonDefault);
const SLIDEDEFAULT = Object.assign({ label: "滑块", controltype: ControlType.Slide, defaultvalue: 0, min: 0, max: 200, step: 1 }, CommonDefault);
const TRANSFERDEFAULT = Object.assign({ label: "穿梭框", controltype: ControlType.Transfer, options: [
        { name: 'Option1(tranfer disabled)', value: 1, id: 1 },
        { name: 'Option2', value: 2, id: 2 },
        { name: 'Option3', value: 3, id: 3, disabled: true },
        { name: 'Option4', value: 3, id: 4 },
        { name: 'Option5', value: 3, id: 5 },
        { name: 'Option6', value: 3, id: 6 },
        { name: 'Option7', value: 3, id: 7 },
        { name: 'Option8', value: 3, id: 8 },
        { name: 'Option9', value: 3, id: 9 },
        { name: 'Option10', value: 3, id: 10, disabled: true },
        { name: 'Option11', value: 3, id: 11 },
        { name: 'Option12', value: 3, id: 12 },
        { name: 'Option13', value: 3, id: 13 },
        { name: 'Option14', value: 3, id: 14 },
        { name: 'Option15', value: 3, id: 15 },
        { name: 'Option16', value: 3, id: 16 },
        { name: 'Option17', value: 3, id: 17 },
        { name: 'Option18', value: 3, id: 18 },
        { name: 'Option19', value: 3, id: 19 },
    ], defaultvalue: [], dataType: "static", postdata: {
        url: "",
        method: "GET",
        data: {},
        head: {},
        function: js_beautify("function (res){return res.data;}")
    }, source: "源头", target: "目标" }, CommonDefault);
const TREEDEFAULT = Object.assign({ label: "树形选择框", controltype: ControlType.Tree, placeholder: "请选择", defaultvalue: null, dataType: "static", options: [
        {
            label: 'option1',
            value: 1,
        },
        {
            label: 'option2',
            value: 2,
        },
        {
            label: 'option3',
            value: 3,
            children: [],
            isLeaf: true,
            disabled: true
        }
    ], postdata: {
        url: "",
        method: "GET",
        data: {},
        head: {},
        function: js_beautify("function (res){return res.data;}")
    } }, CommonDefault);
const MAINCONTAINER = "mainarea";

class CommonService {
    constructor(http, inject) {
        this.http = http;
        this.inject = inject;
        this.importCompSubject = new Subject();
        this.importObservable = this.importCompSubject.asObservable();
        this.followComSubject = new Subject();
        this.followObservable = this.followComSubject.asObservable();
        this.cancelEvent = new EventEmitter();
        this.showShadowSubject = new Subject();
        this.showShadowObservable = this.showShadowSubject.asObservable();
        this.formItemClickSubject = new Subject();
        this.formItemClickObservable = this.formItemClickSubject.asObservable();
        this.removeItemClickSubject = new Subject();
        this.removeItemClickObservable = this.removeItemClickSubject.asObservable();
        this.moveSubject = new Subject();
        this.moveObservable = this.moveSubject.asObservable();
        this.changeFormLayout = new EventEmitter();
        this.attiEvent = new EventEmitter();
        this.testEvent = new EventEmitter();
        this.boxLayout = [];
    }
    setImportComp(control) {
        this.importCompSubject.next(control);
    }
    setFollowComp(follow) {
        this.followComSubject.next(follow);
    }
    setShowShadows(showInfo) {
        this.showShadowSubject.next(showInfo);
    }
    setFormItemClick(itemName) {
        this.formItemClickSubject.next(itemName);
    }
    setRemoveItemClick(itemName) {
        this.removeItemClickSubject.next(itemName);
    }
    setMoveSubject(itemName) {
        this.moveSubject.next(itemName);
    }
    buildControl(data) {
        let child;
        switch (data.controltype) {
            case ControlType.Input:
                child = new ControlBuilder(this.inject.get(FORM_INPUT).constructor, data);
                break;
            case ControlType.RichIput:
                child = new ControlBuilder(this.inject.get(FORM_RICHINPUT).constructor, data);
                break;
            case ControlType.Counter:
                child = new ControlBuilder(this.inject.get(FORM_COUNTER).constructor, data);
                break;
            case ControlType.Toggle:
                child = new ControlBuilder(this.inject.get(FORM_TOGGLE).constructor, data);
                break;
            case ControlType.Row:
                child = new ControlBuilder(this.inject.get(FORM_LAYOUT).constructor, data);
                break;
            case ControlType.Select:
                child = new ControlBuilder(this.inject.get(FORM_SELECT).constructor, data);
                break;
            case ControlType.Alert:
                child = new ControlBuilder(this.inject.get(FORM_ALERT).constructor, data);
                break;
            case ControlType.Check:
                child = new ControlBuilder(this.inject.get(FORM_CHECKBOX).constructor, data);
                break;
            case ControlType.Radio:
                child = new ControlBuilder(this.inject.get(FORM_RADIO).constructor, data);
                break;
            case ControlType.Date:
                child = new ControlBuilder(this.inject.get(FORM_DATE).constructor, data);
                break;
            case ControlType.Time:
                child = new ControlBuilder(this.inject.get(FORM_TIME).constructor, data);
                break;
            case ControlType.Rate:
                child = new ControlBuilder(this.inject.get(FORM_RATE).constructor, data);
                break;
            case ControlType.Space:
                child = new ControlBuilder(this.inject.get(FORM_SPACE).constructor, data);
                break;
            case ControlType.Divider:
                child = new ControlBuilder(this.inject.get(FORM_DIVIDER).constructor, data);
                break;
            case ControlType.Upload:
                child = new ControlBuilder(this.inject.get(FORM_UPLOAD).constructor, data);
                break;
            case ControlType.Transfer:
                child = new ControlBuilder(this.inject.get(FORM_TRANSFER).constructor, data);
                break;
            case ControlType.Tree:
                child = new ControlBuilder(this.inject.get(FORM_TREE).constructor, data);
                break;
            case ControlType.Slide:
                child = new ControlBuilder(this.inject.get(FORM_SLIDER).constructor, data);
                break;
            default:
                child = new ControlBuilder(this.inject.get(FORM_INPUT).constructor, data);
                break;
        }
        return child;
    }
    clearData() {
        this.shadow = null;
        this.orginControlId = null;
        this.previousPosition = null;
        this.boxId = null;
    }
    getPreviewData(mode = "detail") {
        return this.changeBoxInfoToShowBox(this.boxLayout, mode);
    }
    createComponent(boxs, view, mode, name = "") {
        if (mode == "op") {
            var layout = name == MAINCONTAINER ? this.boxLayout : this.findlayout(this.boxLayout, name).boxInfos;
        }
        boxs.forEach((o, index) => {
            const data = Object.assign({}, o.data);
            data.mode = mode;
            const child = this.buildControl(data);
            const componentRef = view.createComponent(child.control);
            componentRef.instance.data = child.data;
            if (componentRef.instance.data.controltype == ControlType.Select) {
                this.addSelectValid(componentRef);
            }
            if (componentRef.instance.control && this.formGroup) {
                this.formGroup.addControl(componentRef.instance.data.name, componentRef.instance.control);
            }
            const controlname = componentRef.instance.data.controlname;
            if (this.colloctData && controlname && controlname != "") {
                this.colloctData[controlname] = componentRef.instance.data;
            }
            if (data.controltype == ControlType.Row && o.layout) {
                componentRef.instance.originallayouts = o.layout;
            }
            if (mode == "op") {
                var box = { boxid: data.name, comp: componentRef };
                if (data.controltype == ControlType.Row && o.layout) {
                    box.selected = data.selected;
                    box.layout = [];
                    o.layout.forEach((value, key) => {
                        box.layout.push({ name: key, boxInfos: [] });
                    });
                }
                layout.push(box);
            }
            componentRef.changeDetectorRef.detectChanges();
            view.insert(componentRef.hostView, index);
        });
    }
    getTheData(data, queryString = "") {
        var obj = null;
        if (data.dataType == "interface" && data.postdata
            && data.postdata.url != "" && data.postdata.function != "") {
            if (queryString != "") {
                data.postdata.url = data.postdata.url.format(queryString);
            }
            const options = {
                headers: data.postdata.head,
                params: data.postdata.data,
            };
            switch (data.postdata.method) {
                case "GET":
                    obj = this.http.get(data.postdata.url, options);
                    break;
                case "POST":
                    obj = this.http.post(data.postdata.url, options);
                    break;
                case "PUT":
                    obj = this.http.put(data.postdata.url, options);
                    break;
                case "DELETE":
                    obj = this.http.delete(data.postdata.url, options);
                    break;
                default:
                    break;
            }
        }
        return obj;
    }
    changeBoxInfoToShowBox(inputBoxs, mode = "detail") {
        var showInfos = [];
        for (let i = 0; i < inputBoxs.length; i++) {
            const box = inputBoxs[i];
            const showInfo = {
                boxid: box.boxid,
                data: Object.assign({}, box.comp.instance.data)
            };
            if (mode == "detail") {
                delete showInfo.data["mode"];
            }
            if (box.layout) {
                showInfo.layout = new Map();
                for (let j = 0; j < box.layout.length; j++) {
                    const interBox = box.layout[j];
                    showInfo.layout.set(interBox.name, this.changeBoxInfoToShowBox(interBox.boxInfos, mode));
                }
            }
            showInfos.push(showInfo);
        }
        return showInfos;
    }
    addSelectValid(control) {
        const valid = control.instance.data.rules.validators;
        if (valid) {
            const indexs = [];
            for (let index = 0; index < valid.length; index++) {
                if (Object.hasOwnProperty.bind(valid[index])("maxOptions") || Object.hasOwnProperty.bind(valid[index])("minOptions")) {
                    if (indexs.length == 1) {
                        indexs.push(index - 1);
                    }
                    else {
                        indexs.push(index);
                    }
                }
            }
            indexs.forEach(o => {
                valid.splice(o, 1);
            });
            for (let index = 0; index < valid.length; index++) {
                if (Object.hasOwnProperty.bind(valid[index])("max")) {
                    valid.push({ "maxOptions": control.instance.maxOptions(parseInt(valid[index]["max"])) });
                }
                if (Object.hasOwnProperty.bind(valid[index])("min")) {
                    valid.push({ "minOptions": control.instance.minOptions(parseInt(valid[index]["min"])) });
                }
            }
        }
    }
    replacer(key, value) {
        if (value instanceof Map) {
            return {
                dataType: 'Map',
                value: Array.from(value.entries()),
            };
        }
        else {
            return value;
        }
    }
    reviver(key, value) {
        if (typeof value === 'object' && value !== null) {
            if (value.dataType === 'Map') {
                return new Map(value.value);
            }
        }
        return value;
    }
    findlayout(parentLayout, name) {
        var boxs = parentLayout.filter(o => o.layout);
        if (boxs) {
            for (let i = 0; i < boxs.length; i++) {
                const element = boxs[i].layout.find(x => x.name == name);
                if (element) {
                    return element;
                }
                else {
                    for (let j = 0; j < boxs[i].layout.length; j++) {
                        const one = this.findlayout(boxs[i].layout[j].boxInfos, name);
                        if (one) {
                            return one;
                        }
                    }
                }
            }
        }
        return null;
    }
}
CommonService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: CommonService, deps: [{ token: i1.HttpClient }, { token: i0.Injector }], target: i0.ɵɵFactoryTarget.Injectable });
CommonService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: CommonService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: CommonService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i1.HttpClient }, { type: i0.Injector }]; } });
String.prototype.format = function (...patterns) {
    var s = this;
    for (let index = 0; index < patterns.length; index++) {
        s = s.replace(new RegExp('\\{' + index + '\\}', 'g'), patterns[index]);
    }
    return s;
};

class BaseControl {
    constructor(commonService) {
        this._commonService = commonService;
    }
    onClick(e) {
        this.data.itemselected = e;
        this._commonService.attiEvent.emit(this.data);
    }
}
BaseControl.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: BaseControl, deps: [{ token: CommonService }], target: i0.ɵɵFactoryTarget.Directive });
BaseControl.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.6", type: BaseControl, inputs: { data: "data" }, viewQueries: [{ propertyName: "box", first: true, predicate: ["box"], descendants: true }], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: BaseControl, decorators: [{
            type: Directive
        }], ctorParameters: function () { return [{ type: CommonService }]; }, propDecorators: { data: [{
                type: Input
            }], box: [{
                type: ViewChild,
                args: ["box"]
            }] } });

class FormBoxComponent {
    constructor(commonService) {
        this.commonService = commonService;
        this.dragClass = "";
        this.addcss = "";
        this.canMove = false;
        this.controlclick = new EventEmitter();
        this.additionalcss = "";
        this.showOptions = false;
        this.areaname = "";
    }
    ngOnInit() {
        this.commonService.showShadowObservable.subscribe(o => {
            if (this.controltype != ControlType.Row || o.name == this.name) {
                this.isShow = o.isshow;
            }
        });
        this.commonService.formItemClickObservable.subscribe(o => {
            if (o == this.name) {
                this.showOptions = !this.showOptions;
                this.addcss = this.showOptions ? "selected" : "";
            }
            else {
                this.showOptions = false;
                this.addcss = "";
            }
        });
        this.commonService.followObservable.subscribe(o => {
            if (this.dragClass == "drag-fade") {
                this.areaname = o.name;
            }
        });
    }
    ondragstart(ev) {
        ev.stopPropagation();
        ev.dataTransfer.effectAllowed = "move";
        this.dragClass = "drag-fade";
        this.commonService.orginControlId = this.name;
        this.commonService.setShowShadows({ isshow: true, name: this.name });
    }
    ondragend(ev) {
        ev.stopPropagation();
        this.dragClass = "";
        this.commonService.setShowShadows({ isshow: false, name: this.name });
        this.commonService.cancelEvent.emit(this.areaname);
        this.canMove = false;
    }
    onClick(ev) {
        ev.stopPropagation();
        this.commonService.setFormItemClick(this.name);
        this.controlclick.emit(this.showOptions);
    }
    onMousedown(ev) {
        ev.stopPropagation();
        this.canMove = true;
    }
    onRemoveClick(ev) {
        ev.stopPropagation();
        this.commonService.setRemoveItemClick(this.name);
    }
}
FormBoxComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormBoxComponent, deps: [{ token: CommonService }], target: i0.ɵɵFactoryTarget.Component });
FormBoxComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormBoxComponent, selector: "form-box", inputs: { mainCarry: "mainCarry", name: "name", controltype: "controltype", additionalcss: "additionalcss" }, outputs: { controlclick: "controlclick" }, viewQueries: [{ propertyName: "moveIcon", first: true, predicate: ["move"], descendants: true, static: true }, { propertyName: "miancontrol", first: true, predicate: ["miancontrol"], descendants: true, read: ViewContainerRef }, { propertyName: "beforeshadow", first: true, predicate: ["beforeshadow"], descendants: true, read: ViewContainerRef }, { propertyName: "aftershadow", first: true, predicate: ["aftershadow"], descendants: true, read: ViewContainerRef }], ngImport: i0, template: "<div [draggable]=\"canMove\" (dragstart)=\"ondragstart($event)\" [ngClass]=\"dragClass\" (dragend)=\"ondragend($event)\" (click)=\"onClick($event)\">\r\n    <div class=\"control-border\">\r\n       <ng-container #beforeshadow></ng-container>\r\n       <div class = \"control-area\" [ngClass]=\"[addcss,additionalcss]\">\r\n          <ng-container #miancontrol [ngTemplateOutlet]=\"mainCarry\"></ng-container>\r\n          <div *ngIf=\"showOptions\">\r\n            <div class=\"control-move\" (mousedown)=\"onMousedown($event)\"><i class=\"fc-icon icon-move font-color control-icon\"></i></div>\r\n            <div class=\"control-remove\" (click)=\"onRemoveClick($event)\"><i class=\"fc-icon icon-delete control-icon\"></i></div>\r\n          </div>\r\n       </div>\r\n       <ng-container #aftershadow></ng-container>\r\n       <div [attr.data-box-id]=\"name\" [attr.data-box-type]=\"controltype\" class=\"drag-shadow\" *ngIf=\"isShow\"></div>\r\n    </div>\r\n</div>\r\n ", styles: [".control-border{position:relative}.control-area{position:relative;margin-bottom:5px;padding:10px 10px 0;border:2px dashed var(--devui-brand-hover, #7693f5);border-radius:5px}.selected,.control-area:hover{border:2px solid var(--devui-brand, #5e7ce0)}.drag-shadow-hide{display:none}.drag-fade{background-color:var(--devui-initial, #e9edfa);border-radius:5px}.drag-shadow{position:absolute;width:100%;top:0px;left:0px;bottom:0px;z-index:999}.control-move{cursor:move;position:absolute;top:-1px;left:-1px;width:20px;height:21px;border-bottom-right-radius:5px;border-top-left-radius:5px;background-color:var(--devui-brand, #5e7ce0);text-align:center;display:flex;justify-content:center;align-content:center;padding-top:4px}.control-remove{position:absolute;right:-2px;bottom:-2px;cursor:pointer;width:22px;text-align:center;border-bottom-right-radius:5px;background-color:var(--devui-danger, #f66f6a)}.control-icon{font-size:14px}.font-color{color:#fff}.add-control-area{padding:0}\n"], directives: [{ type: i4.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i4.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormBoxComponent, decorators: [{
            type: Component,
            args: [{ selector: 'form-box', template: "<div [draggable]=\"canMove\" (dragstart)=\"ondragstart($event)\" [ngClass]=\"dragClass\" (dragend)=\"ondragend($event)\" (click)=\"onClick($event)\">\r\n    <div class=\"control-border\">\r\n       <ng-container #beforeshadow></ng-container>\r\n       <div class = \"control-area\" [ngClass]=\"[addcss,additionalcss]\">\r\n          <ng-container #miancontrol [ngTemplateOutlet]=\"mainCarry\"></ng-container>\r\n          <div *ngIf=\"showOptions\">\r\n            <div class=\"control-move\" (mousedown)=\"onMousedown($event)\"><i class=\"fc-icon icon-move font-color control-icon\"></i></div>\r\n            <div class=\"control-remove\" (click)=\"onRemoveClick($event)\"><i class=\"fc-icon icon-delete control-icon\"></i></div>\r\n          </div>\r\n       </div>\r\n       <ng-container #aftershadow></ng-container>\r\n       <div [attr.data-box-id]=\"name\" [attr.data-box-type]=\"controltype\" class=\"drag-shadow\" *ngIf=\"isShow\"></div>\r\n    </div>\r\n</div>\r\n ", styles: [".control-border{position:relative}.control-area{position:relative;margin-bottom:5px;padding:10px 10px 0;border:2px dashed var(--devui-brand-hover, #7693f5);border-radius:5px}.selected,.control-area:hover{border:2px solid var(--devui-brand, #5e7ce0)}.drag-shadow-hide{display:none}.drag-fade{background-color:var(--devui-initial, #e9edfa);border-radius:5px}.drag-shadow{position:absolute;width:100%;top:0px;left:0px;bottom:0px;z-index:999}.control-move{cursor:move;position:absolute;top:-1px;left:-1px;width:20px;height:21px;border-bottom-right-radius:5px;border-top-left-radius:5px;background-color:var(--devui-brand, #5e7ce0);text-align:center;display:flex;justify-content:center;align-content:center;padding-top:4px}.control-remove{position:absolute;right:-2px;bottom:-2px;cursor:pointer;width:22px;text-align:center;border-bottom-right-radius:5px;background-color:var(--devui-danger, #f66f6a)}.control-icon{font-size:14px}.font-color{color:#fff}.add-control-area{padding:0}\n"] }]
        }], ctorParameters: function () { return [{ type: CommonService }]; }, propDecorators: { moveIcon: [{
                type: ViewChild,
                args: ["move", { static: true }]
            }], mainCarry: [{
                type: Input
            }], name: [{
                type: Input
            }], controltype: [{
                type: Input
            }], controlclick: [{
                type: Output
            }], additionalcss: [{
                type: Input
            }], miancontrol: [{
                type: ViewChild,
                args: ["miancontrol", { read: ViewContainerRef }]
            }], beforeshadow: [{
                type: ViewChild,
                args: ["beforeshadow", { read: ViewContainerRef }]
            }], aftershadow: [{
                type: ViewChild,
                args: ["aftershadow", { read: ViewContainerRef }]
            }] } });

class FormAlertComponent extends BaseControl {
    constructor(commonService) {
        super(commonService);
        this.commonService = commonService;
    }
    ngOnInit() {
    }
}
FormAlertComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormAlertComponent, deps: [{ token: CommonService }], target: i0.ɵɵFactoryTarget.Component });
FormAlertComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormAlertComponent, selector: "form-alert", usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n<ng-template #detail>\r\n    <d-form-item style=\"margin-bottom:10px;\">\r\n        <d-alert [type]=\"data.alerttype\" [closeable]=\"data.closeable\">{{data.label}}</d-alert>\r\n    </d-form-item>\r\n</ng-template>", styles: [""], components: [{ type: FormBoxComponent, selector: "form-box", inputs: ["mainCarry", "name", "controltype", "additionalcss"], outputs: ["controlclick"] }, { type: i3.FormItemComponent, selector: "d-form-item", inputs: ["dFeedbackType", "dHasFeedback"] }, { type: i3.AlertComponent, selector: "d-alert", inputs: ["type", "cssClass", "closeable", "content", "showIcon", "dismissTime"], outputs: ["closeEvent"] }], directives: [{ type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormAlertComponent, decorators: [{
            type: Component,
            args: [{ selector: 'form-alert', template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n<ng-template #detail>\r\n    <d-form-item style=\"margin-bottom:10px;\">\r\n        <d-alert [type]=\"data.alerttype\" [closeable]=\"data.closeable\">{{data.label}}</d-alert>\r\n    </d-form-item>\r\n</ng-template>", styles: [""] }]
        }], ctorParameters: function () { return [{ type: CommonService }]; } });

class FormDragTemplateDirective {
    constructor(viewContainerRef, templateRef) {
        this.viewContainerRef = viewContainerRef;
        this.templateRef = templateRef;
    }
}
FormDragTemplateDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormDragTemplateDirective, deps: [{ token: i0.ViewContainerRef }, { token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
FormDragTemplateDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.6", type: FormDragTemplateDirective, selector: "[formdragtemplate]", ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormDragTemplateDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[formdragtemplate]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ViewContainerRef }, { type: i0.TemplateRef }]; } });

class FormDropDirective {
    constructor(el, commonService) {
        this.el = el;
        this.commonService = commonService;
    }
    onDrop(e) {
        e.stopPropagation();
        if (e.dataTransfer.effectAllowed == "all") {
            if (e.dataTransfer.getData("controlinfo")) {
                const data = JSON.parse(e.dataTransfer.getData("controlinfo"));
                this.commonService.setImportComp({
                    control: data,
                    name: this.el.nativeElement.dataset.boxId
                });
            }
        }
        else if (this.commonService.boxId) {
            this.commonService.setMoveSubject(this.commonService.boxId);
        }
        else {
            this.commonService.clearData();
        }
    }
    onDragenter(e) {
        e.preventDefault();
    }
    onDragover(e) {
        e.preventDefault();
        e.stopPropagation();
        var boxId = e.target.dataset.boxId;
        if (boxId && boxId != "shadowbox") {
            const followItem = { targetboxid: boxId, position: "none" };
            if (this.commonService.previousPosition) {
                if (this.commonService.previousPosition.y < e.y) {
                    followItem.position = "after";
                }
                else if (this.commonService.previousPosition.y > e.y) {
                    followItem.position = "before";
                }
            }
            else {
                followItem.position = "before";
            }
            this.commonService.previousPosition = { x: e.x, y: e.y };
            if (followItem.position == "none") {
                return;
            }
            if (this.commonService.orginControlId) {
                if (this.commonService.orginControlId === boxId) {
                    return;
                }
                followItem.orginBoxid = this.commonService.orginControlId;
            }
            this.commonService.setFollowComp({
                follow: followItem,
                name: this.el.nativeElement.dataset.boxId
            });
        }
    }
}
FormDropDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormDropDirective, deps: [{ token: i0.ElementRef }, { token: CommonService }], target: i0.ɵɵFactoryTarget.Directive });
FormDropDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.6", type: FormDropDirective, selector: "[formdrop]", host: { listeners: { "drop": "onDrop($event)", "dragenter": "onDragenter($event)", "dragover": "onDragover($event)" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormDropDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[formdrop]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: CommonService }]; }, propDecorators: { onDrop: [{
                type: HostListener,
                args: ["drop", ['$event']]
            }], onDragenter: [{
                type: HostListener,
                args: ["dragenter", ['$event']]
            }], onDragover: [{
                type: HostListener,
                args: ["dragover", ['$event']]
            }] } });

class FormAreaComponent {
    constructor(commonService, el, inject) {
        this.commonService = commonService;
        this.el = el;
        this.inject = inject;
        this.mode = "op";
        this.showOptions = false;
        this.onaddrow = new EventEmitter();
        this.onremoverow = new EventEmitter();
    }
    get realLayOut() {
        return this.findTheReallayout(this.commonService.boxLayout, this.name);
    }
    ngOnInit() {
        this.ismain = this.name == MAINCONTAINER;
        if (this.mode != "op") {
            return;
        }
        this.commonService.formItemClickObservable.subscribe(o => {
            this.realLayOut.forEach(x => {
                if (x.boxid == o) {
                    x.selected = !x.selected;
                }
                else {
                    x.selected = false;
                }
            });
            if (o == this.name) {
                this.showOptions = !this.showOptions;
            }
            else {
                this.showOptions = false;
            }
        });
        this.commonService.importObservable.subscribe(o => {
            if (o && o.name == this.name) {
                const compName = UUID.UUID();
                const child = this.createComponent(compName, o.control);
                const index = this.findCompIndex(this.commonService.shadow);
                const componentRef = this.template.viewContainerRef.createComponent(child.control);
                componentRef.instance.data = child.data;
                this.template.viewContainerRef.insert(componentRef.hostView, index);
                const boxInfo = { boxid: compName, comp: componentRef };
                if (o.control.control == ControlType.Row) {
                    boxInfo.layout = [
                        {
                            name: child.data.defaultvalue[0].name,
                            boxInfos: []
                        }
                    ];
                }
                this.realLayOut.splice(index, 0, boxInfo);
            }
        });
        this.commonService.moveObservable.subscribe(o => {
            if (o == this.name && this.commonService.orginControlId) {
                const orginef = this.removeTheView(this.commonService.boxLayout, this.commonService.orginControlId);
                if (orginef) {
                    const index = this.findCompIndex(orginef.comp.hostView);
                    if (index > -1) {
                        this.template.viewContainerRef.insert(orginef.comp.hostView, index);
                        this.realLayOut.splice(index, 0, orginef);
                    }
                }
            }
        });
        this.commonService.followObservable.subscribe(o => {
            if (o.name == this.name) {
                this.commonService.boxId = this.name;
                const ef = this.realLayOut.find(x => x.boxid == o.follow.targetboxid);
                let orginef;
                if (o.follow.orginBoxid) {
                    orginef = this.getTheView(this.commonService.boxLayout, o.follow.orginBoxid).comp;
                }
                if (!this.commonService.shadow && !o.follow.orginBoxid) {
                    this.commonService.shadow = this.template.viewContainerRef.createEmbeddedView(this.ismain ? this.template.templateRef : this.commonService.mainshadow);
                }
                const movecomp = (orginef === null || orginef === void 0 ? void 0 : orginef.hostView) || this.commonService.shadow;
                if (ef) {
                    if (o.follow.position == "before") {
                        ef.comp.instance.box.beforeshadow.move(movecomp, 0);
                    }
                    else {
                        if (this.realLayOut.indexOf(ef) == (this.realLayOut.length - 1)) {
                            this.aftershadow.move(movecomp, 0);
                        }
                        else {
                            ef.comp.instance.box.aftershadow.move(movecomp, 0);
                        }
                    }
                }
                else {
                    this.aftershadow.move(movecomp, 0);
                }
            }
        });
        this.commonService.cancelEvent.subscribe(o => {
            if (o == this.name) {
                this.cancelShadow();
            }
        });
        this.commonService.removeItemClickObservable.subscribe(o => {
            const item = this.realLayOut.find(x => x.boxid == o);
            if (item) {
                this.realLayOut.splice(this.realLayOut.indexOf(item), 1);
                this.template.viewContainerRef.remove(this.template.viewContainerRef.indexOf(item.comp.hostView));
            }
        });
    }
    ngAfterViewInit() {
        if (this.mode == "op") {
            if (this.ismain) {
                this.commonService.mainshadow = this.template.templateRef;
            }
            else {
                fromEvent(this.el.nativeElement, "click").subscribe(e => {
                    e.stopPropagation();
                    this.commonService.setFormItemClick(this.name);
                    this.commonService.attiEvent.emit();
                });
            }
        }
        if (this.originalLayout) {
            this.commonService.createComponent(this.originalLayout, this.template.viewContainerRef, this.mode, this.name);
        }
    }
    createComponent(name, controlInfo) {
        let child;
        switch (controlInfo.control) {
            case ControlType.Input:
                child = new ControlBuilder(this.inject.get(FORM_INPUT).constructor, Object.assign(Object.assign({ name: name, controlname: name }, INPUTDEFAULT), { rules: { validators: [] } }));
                break;
            case ControlType.RichIput:
                child = new ControlBuilder(this.inject.get(FORM_RICHINPUT).constructor, Object.assign(Object.assign({ name: name, controlname: name }, RICHINPUTDEFAULT), { rules: { validators: [] } }));
                break;
            case ControlType.Counter:
                child = new ControlBuilder(this.inject.get(FORM_COUNTER).constructor, Object.assign(Object.assign({ name: name, controlname: name }, COUNTERDEFAULT), { rules: { validators: [] } }));
                break;
            case ControlType.Toggle:
                child = new ControlBuilder(this.inject.get(FORM_TOGGLE).constructor, Object.assign({ name: name, controlname: name }, TOGGLEDEFAULT));
                break;
            case ControlType.Select:
                child = new ControlBuilder(this.inject.get(FORM_SELECT).constructor, Object.assign(Object.assign({ name: name, controlname: name }, SELECTDEFAULT), { rules: { validators: [] } }));
                break;
            case ControlType.Alert:
                child = new ControlBuilder(this.inject.get(FORM_ALERT).constructor, Object.assign({ name: name }, ALERTDEFAULT));
                break;
            case ControlType.Check:
                child = new ControlBuilder(this.inject.get(FORM_CHECKBOX).constructor, Object.assign(Object.assign({ name: name, controlname: name }, CHECKDEFAULT), { rules: { validators: [] } }));
                break;
            case ControlType.Radio:
                child = new ControlBuilder(this.inject.get(FORM_RADIO).constructor, Object.assign(Object.assign({ name: name, controlname: name }, RADIODEFAULT), { rules: { validators: [] } }));
                break;
            case ControlType.Date:
                child = new ControlBuilder(this.inject.get(FORM_DATE).constructor, Object.assign(Object.assign({ name: name, controlname: name }, DATEDEFAULT), { rules: { validators: [] } }));
                break;
            case ControlType.Time:
                child = new ControlBuilder(this.inject.get(FORM_TIME).constructor, Object.assign(Object.assign({ name: name, controlname: name }, TIMEDEFAULT), { rules: { validators: [] } }));
                break;
            case ControlType.Rate:
                child = new ControlBuilder(this.inject.get(FORM_RATE).constructor, Object.assign(Object.assign({ name: name, controlname: name }, RATEDEFAULT), { rules: { validators: [] } }));
                break;
            case ControlType.Space:
                child = new ControlBuilder(this.inject.get(FORM_SPACE).constructor, Object.assign({ name: name }, SPACEDEFAULT));
                break;
            case ControlType.Divider:
                child = new ControlBuilder(this.inject.get(FORM_DIVIDER).constructor, Object.assign({ name: name }, DIVIDERDEFAULT));
                break;
            case ControlType.Upload:
                child = new ControlBuilder(this.inject.get(FORM_UPLOAD).constructor, Object.assign(Object.assign({ name: name, controlname: name }, UPLOADDEFAULT), { rules: { validators: [] } }));
                break;
            case ControlType.Transfer:
                child = new ControlBuilder(this.inject.get(FORM_TRANSFER).constructor, Object.assign({ name: name, controlname: name }, TRANSFERDEFAULT));
                break;
            case ControlType.Row:
                child = new ControlBuilder(this.inject.get(FORM_LAYOUT).constructor, Object.assign(Object.assign({ name: name }, LAYOUTDEFAULT), { defaultvalue: [{ name: UUID.UUID(), selected: false, boxInfos: [] }] }));
                break;
            case ControlType.Tree:
                child = new ControlBuilder(this.inject.get(FORM_TREE).constructor, Object.assign({ name: name, controlname: name }, TREEDEFAULT));
                break;
            case ControlType.Slide:
                child = new ControlBuilder(this.inject.get(FORM_SLIDER).constructor, Object.assign(Object.assign({ name: name, controlname: name }, SLIDEDEFAULT), { rules: { validators: [] } }));
                break;
            default:
                child = new ControlBuilder(this.inject.get(FORM_INPUT).constructor, { name: name });
                break;
        }
        return child;
    }
    findCompIndex(comp) {
        let index = -1;
        if (this.aftershadow.indexOf(comp) >= 0) {
            index = this.template.viewContainerRef.length;
        }
        else {
            this.realLayOut.forEach(v => {
                if (v.comp.hostView != comp) {
                    if (v.comp.instance.box.beforeshadow.indexOf(comp) >= 0) {
                        index = this.template.viewContainerRef.indexOf(v.comp.hostView);
                        return;
                    }
                    else if (v.comp.instance.box.aftershadow.indexOf(comp) >= 0) {
                        index = this.template.viewContainerRef.indexOf(v.comp.hostView) + 1;
                        return;
                    }
                }
            });
        }
        return index;
    }
    cancelShadow() {
        if (this.commonService.shadow) {
            if (this.aftershadow.indexOf(this.commonService.shadow) >= 0) {
                this.aftershadow.clear();
            }
            else {
                this.realLayOut.forEach(v => {
                    if (v.comp.instance.box.beforeshadow.indexOf(this.commonService.shadow) >= 0) {
                        v.comp.instance.box.beforeshadow.clear();
                        return;
                    }
                    if (v.comp.instance.box.aftershadow.indexOf(this.commonService.shadow) >= 0) {
                        v.comp.instance.box.aftershadow.clear();
                        return;
                    }
                });
            }
        }
        this.commonService.clearData();
    }
    findTheReallayout(parentLayout, name) {
        if (this.ismain) {
            return parentLayout;
        }
        let box;
        for (let i = 0; i < parentLayout.length; i++) {
            box = this.findTheRealArea(parentLayout[i], name);
            if (box) {
                break;
            }
        }
        return box ? box.boxInfos : [];
    }
    findTheRealArea(parentBox, name) {
        if (!parentBox.layout) {
            return null;
        }
        var findBox = parentBox.layout.find(o => o.name == name);
        if (findBox) {
            return findBox;
        }
        else {
            for (let i = 0; i < parentBox.layout.length; i++) {
                const element = parentBox.layout[i];
                for (let j = 0; j < element.boxInfos.length; j++) {
                    findBox = this.findTheRealArea(element.boxInfos[j], name);
                    if (findBox) {
                        return findBox;
                    }
                }
            }
        }
        return findBox;
    }
    getTheView(layout, boxid) {
        const view = layout.find(o => o.boxid == boxid);
        if (view) {
            return view;
        }
        else {
            for (let i = 0; i < layout.length; i++) {
                const element = layout[i];
                if (element.layout) {
                    for (let j = 0; j < element.layout.length; j++) {
                        const box = this.getTheView(element.layout[j].boxInfos, boxid);
                        if (box) {
                            return box;
                        }
                    }
                }
            }
        }
        return view;
    }
    removeTheView(layout, boxid) {
        let index = -1;
        for (let i = 0; i < layout.length; i++) {
            if (layout[i].boxid == boxid) {
                index = i;
                break;
            }
        }
        if (index == -1) {
            for (let i = 0; i < layout.length; i++) {
                if (layout[i].layout) {
                    for (let j = 0; j < layout[i].layout.length; j++) {
                        const box = this.removeTheView(layout[i].layout[j].boxInfos, boxid);
                        if (box) {
                            return box;
                        }
                    }
                }
            }
        }
        else {
            return layout.splice(index, 1)[0];
        }
        return null;
    }
    addRow(e) {
        e.stopPropagation();
        this.onaddrow.emit(true);
    }
    removeRow(e) {
        e.stopPropagation();
        this.onremoverow.emit(this.name);
    }
}
FormAreaComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormAreaComponent, deps: [{ token: CommonService }, { token: i0.ElementRef }, { token: i0.Injector }], target: i0.ɵɵFactoryTarget.Component });
FormAreaComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormAreaComponent, selector: "form-area", inputs: { name: "name", mode: "mode", originalLayout: "originalLayout" }, outputs: { onaddrow: "onaddrow", onremoverow: "onremoverow" }, viewQueries: [{ propertyName: "template", first: true, predicate: FormDragTemplateDirective, descendants: true }, { propertyName: "aftershadow", first: true, predicate: ["aftershadow"], descendants: true, read: ViewContainerRef }], ngImport: i0, template: "<ng-container *ngIf = \"mode=='op'; else detail\">\r\n    <div class=\"all-canvas\" formdrop [attr.data-box-id]=\"name\">\r\n        <ng-template formdragtemplate>\r\n            <div *ngIf=\"ismain\" data-box-id=\"shadowbox\">\r\n                <div class=\"shadow\"></div>\r\n            </div>\r\n        </ng-template>\r\n        <div style=\"flex-grow: 1;\" data-box-id=\"mainarea\">\r\n            <ng-container #aftershadow></ng-container>\r\n        </div>\r\n    </div>\r\n    <div *ngIf=\"!ismain\" style=\"height: 16px;\" [attr.data-box-id]=\"name\">\r\n        <div [attr.data-box-id]=\"name\" style=\"flex-direction: row-reverse;margin-right: -2px;\" [ngStyle]=\"{'display':showOptions ? 'flex':'none'}\">\r\n            <div [attr.data-box-id]=\"name\" class=\"control-remove\" (click)=\"removeRow($event)\"><i class=\"fc-icon icon-delete control-icon\"></i></div>\r\n            <div [attr.data-box-id]=\"name\" class=\"control-add\" (click)=\"addRow($event)\"><i class=\"fc-icon icon-add font-color control-icon\"></i></div>\r\n        </div>\r\n    </div>    \r\n</ng-container>\r\n<ng-template #detail>\r\n    <div class=\"all-canvas\" [attr.data-box-id]=\"name\">\r\n        <ng-template formdragtemplate>  \r\n        </ng-template>\r\n    </div>\r\n</ng-template>\r\n", styles: [".all-canvas{min-height:80px;flex:1;background:#fff;display:flex;flex-flow:column;height:100%}.shadow{margin:10px;height:10px;border:2px solid var(--devui-brand, #5e7ce0);border-radius:5px}.control-remove{cursor:pointer;width:20px;text-align:center;border-bottom-right-radius:5px;background-color:var(--devui-danger, #f66f6a)}.control-add{cursor:pointer;width:22px;text-align:center;background-color:var(--devui-brand, #5e7ce0)}.control-icon{font-size:14px}.font-color{color:#fff}[hidden]{display:none}\n"], directives: [{ type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: FormDropDirective, selector: "[formdrop]" }, { type: FormDragTemplateDirective, selector: "[formdragtemplate]" }, { type: i4.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormAreaComponent, decorators: [{
            type: Component,
            args: [{ selector: 'form-area', template: "<ng-container *ngIf = \"mode=='op'; else detail\">\r\n    <div class=\"all-canvas\" formdrop [attr.data-box-id]=\"name\">\r\n        <ng-template formdragtemplate>\r\n            <div *ngIf=\"ismain\" data-box-id=\"shadowbox\">\r\n                <div class=\"shadow\"></div>\r\n            </div>\r\n        </ng-template>\r\n        <div style=\"flex-grow: 1;\" data-box-id=\"mainarea\">\r\n            <ng-container #aftershadow></ng-container>\r\n        </div>\r\n    </div>\r\n    <div *ngIf=\"!ismain\" style=\"height: 16px;\" [attr.data-box-id]=\"name\">\r\n        <div [attr.data-box-id]=\"name\" style=\"flex-direction: row-reverse;margin-right: -2px;\" [ngStyle]=\"{'display':showOptions ? 'flex':'none'}\">\r\n            <div [attr.data-box-id]=\"name\" class=\"control-remove\" (click)=\"removeRow($event)\"><i class=\"fc-icon icon-delete control-icon\"></i></div>\r\n            <div [attr.data-box-id]=\"name\" class=\"control-add\" (click)=\"addRow($event)\"><i class=\"fc-icon icon-add font-color control-icon\"></i></div>\r\n        </div>\r\n    </div>    \r\n</ng-container>\r\n<ng-template #detail>\r\n    <div class=\"all-canvas\" [attr.data-box-id]=\"name\">\r\n        <ng-template formdragtemplate>  \r\n        </ng-template>\r\n    </div>\r\n</ng-template>\r\n", styles: [".all-canvas{min-height:80px;flex:1;background:#fff;display:flex;flex-flow:column;height:100%}.shadow{margin:10px;height:10px;border:2px solid var(--devui-brand, #5e7ce0);border-radius:5px}.control-remove{cursor:pointer;width:20px;text-align:center;border-bottom-right-radius:5px;background-color:var(--devui-danger, #f66f6a)}.control-add{cursor:pointer;width:22px;text-align:center;background-color:var(--devui-brand, #5e7ce0)}.control-icon{font-size:14px}.font-color{color:#fff}[hidden]{display:none}\n"] }]
        }], ctorParameters: function () { return [{ type: CommonService }, { type: i0.ElementRef }, { type: i0.Injector }]; }, propDecorators: { template: [{
                type: ViewChild,
                args: [FormDragTemplateDirective, { static: false }]
            }], aftershadow: [{
                type: ViewChild,
                args: ["aftershadow", { read: ViewContainerRef }]
            }], name: [{
                type: Input,
                args: ["name"]
            }], mode: [{
                type: Input,
                args: ["mode"]
            }], originalLayout: [{
                type: Input,
                args: ["originalLayout"]
            }], onaddrow: [{
                type: Output
            }], onremoverow: [{
                type: Output
            }] } });

class FormCheckboxComponent extends BaseControl {
    constructor(commonService) {
        super(commonService);
        this.commonService = commonService;
        this.control = new FormControl();
    }
    ngOnInit() {
        this.getData();
        this.commonService.testEvent.subscribe(o => {
            if (o == this.data.name) {
                this.getData();
            }
        });
    }
    getData() {
        var _a;
        (_a = this.commonService.getTheData(this.data)) === null || _a === void 0 ? void 0 : _a.subscribe(o => {
            var res = null;
            eval("res =" + this.data.postdata.function);
            this.data.options = res(o);
        });
    }
}
FormCheckboxComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormCheckboxComponent, deps: [{ token: CommonService }], target: i0.ɵɵFactoryTarget.Component });
FormCheckboxComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormCheckboxComponent, selector: "form-checkbox", usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n<ng-template #detail>\r\n    <d-form-item>\r\n        <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n        <d-form-control>\r\n            <d-checkbox-group \r\n            [formControl]=\"control\"\r\n            [(ngModel)]=\"data.defaultvalue\" \r\n            [disabled]=\"data.disabled\" \r\n            [attr.name]=\"data.controlname\"\r\n            [filterKey]=\"data.filter\" \r\n            [options]=\"data.options\" \r\n            [direction]=\"data.direction\" \r\n            [isShowTitle]=\"data.isshowtitle\" \r\n            [dValidateRules]=\"data.rules\">\r\n            </d-checkbox-group>\r\n        </d-form-control>\r\n    </d-form-item>\r\n</ng-template>", styles: [""], components: [{ type: FormBoxComponent, selector: "form-box", inputs: ["mainCarry", "name", "controltype", "additionalcss"], outputs: ["controlclick"] }, { type: i3.FormItemComponent, selector: "d-form-item", inputs: ["dFeedbackType", "dHasFeedback"] }, { type: i3.FormLabelComponent, selector: "d-form-label", inputs: ["required", "hasHelp", "helpTips"] }, { type: i3.FormControlComponent, selector: "d-form-control", inputs: ["extraInfo", "feedbackStatus", "suffixTemplate"] }, { type: i3.CheckBoxGroupComponent, selector: "d-checkbox-group", inputs: ["name", "itemWidth", "color", "direction", "isShowTitle", "disabled", "options", "filterKey", "labelTemplate", "showAnimation", "beforeChange"], outputs: ["change"] }], directives: [{ type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i5.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i5.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { type: i3.DFormControlRuleDirective, selector: "[dValidateRules][formControlName],[dValidateRules][ngModel],[dValidateRules][formControl]", inputs: ["dValidateRules", "dValidatePopConfig"], outputs: ["dRulesStatusChange"], exportAs: ["dValidateRules"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormCheckboxComponent, decorators: [{
            type: Component,
            args: [{ selector: 'form-checkbox', template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n<ng-template #detail>\r\n    <d-form-item>\r\n        <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n        <d-form-control>\r\n            <d-checkbox-group \r\n            [formControl]=\"control\"\r\n            [(ngModel)]=\"data.defaultvalue\" \r\n            [disabled]=\"data.disabled\" \r\n            [attr.name]=\"data.controlname\"\r\n            [filterKey]=\"data.filter\" \r\n            [options]=\"data.options\" \r\n            [direction]=\"data.direction\" \r\n            [isShowTitle]=\"data.isshowtitle\" \r\n            [dValidateRules]=\"data.rules\">\r\n            </d-checkbox-group>\r\n        </d-form-control>\r\n    </d-form-item>\r\n</ng-template>", styles: [""] }]
        }], ctorParameters: function () { return [{ type: CommonService }]; } });

class FormCounterComponent extends BaseControl {
    constructor(commonService) {
        super(commonService);
        this.commonService = commonService;
    }
    ngOnInit() {
    }
}
FormCounterComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormCounterComponent, deps: [{ token: CommonService }], target: i0.ɵɵFactoryTarget.Component });
FormCounterComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormCounterComponent, selector: "form-counter", usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n  <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n<ng-template #detail>\r\n    <d-form-item>\r\n        <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n        <d-form-control>\r\n          <div class=\"unit-class\">\r\n            <d-input-number\r\n                [attr.name]=\"data.controlname\" \r\n                [min]=\"data.min\"\r\n                [max]=\"data.max\"\r\n                [step]=\"data.step\"\r\n                [(ngModel)]=\"data.defaultvalue\"\r\n                [disabled]=\"data.disabled\"\r\n                [dValidateRules]=\"data.rules\"\r\n            ></d-input-number>\r\n            <div class=\"unit-alg\">{{data.unit}}</div>\r\n          </div>\r\n        </d-form-control>\r\n      </d-form-item>\r\n</ng-template>", styles: [".unit-class{display:flex;flex-direction:row}.unit-alg{line-height:2.2;padding-left:5px}\n"], components: [{ type: FormBoxComponent, selector: "form-box", inputs: ["mainCarry", "name", "controltype", "additionalcss"], outputs: ["controlclick"] }, { type: i3.FormItemComponent, selector: "d-form-item", inputs: ["dFeedbackType", "dHasFeedback"] }, { type: i3.FormLabelComponent, selector: "d-form-label", inputs: ["required", "hasHelp", "helpTips"] }, { type: i3.FormControlComponent, selector: "d-form-control", inputs: ["extraInfo", "feedbackStatus", "suffixTemplate"] }, { type: i3.InputNumberComponent, selector: "d-input-number", inputs: ["step", "disabled", "size", "decimalLimit", "autoFocus", "allowEmpty", "placeholder", "maxLength", "reg", "min", "max"], outputs: ["afterValueChanged", "whileValueChanging"] }], directives: [{ type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i5.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i5.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { type: i3.DFormControlRuleDirective, selector: "[dValidateRules][formControlName],[dValidateRules][ngModel],[dValidateRules][formControl]", inputs: ["dValidateRules", "dValidatePopConfig"], outputs: ["dRulesStatusChange"], exportAs: ["dValidateRules"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormCounterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'form-counter', template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n  <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n<ng-template #detail>\r\n    <d-form-item>\r\n        <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n        <d-form-control>\r\n          <div class=\"unit-class\">\r\n            <d-input-number\r\n                [attr.name]=\"data.controlname\" \r\n                [min]=\"data.min\"\r\n                [max]=\"data.max\"\r\n                [step]=\"data.step\"\r\n                [(ngModel)]=\"data.defaultvalue\"\r\n                [disabled]=\"data.disabled\"\r\n                [dValidateRules]=\"data.rules\"\r\n            ></d-input-number>\r\n            <div class=\"unit-alg\">{{data.unit}}</div>\r\n          </div>\r\n        </d-form-control>\r\n      </d-form-item>\r\n</ng-template>", styles: [".unit-class{display:flex;flex-direction:row}.unit-alg{line-height:2.2;padding-left:5px}\n"] }]
        }], ctorParameters: function () { return [{ type: CommonService }]; } });

class FormDateComponent extends BaseControl {
    constructor(commonService) {
        super(commonService);
        this.commonService = commonService;
        this.control = new FormControl();
    }
    ngOnInit() {
    }
}
FormDateComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormDateComponent, deps: [{ token: CommonService }], target: i0.ɵɵFactoryTarget.Component });
FormDateComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormDateComponent, selector: "form-date", usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n  <ng-template #detail>\r\n      <d-form-item>\r\n          <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n          <d-form-control>\r\n            <ng-container *ngIf=\"data.datetype=='date'; else datarange\">\r\n              <d-datepicker-pro \r\n                [formControl]=\"control\"\r\n                [attr.name]=\"data.controlname\"\r\n                [(ngModel)]=\"data.defaultvalue\" \r\n                [showTime] = \"data.showtime\" \r\n                [appendToBody]=\"true\"\r\n                [dValidateRules]=\"data.rules\"\r\n                [format]=\"data.dateFormat\"></d-datepicker-pro>\r\n            </ng-container>\r\n              \r\n            <ng-template #datarange>\r\n                <d-range-datepicker-pro\r\n                  [formControl]=\"control\"\r\n                  [attr.name]=\"data.controlname\"\r\n                  [appendToBody]=\"true\"\r\n                  [(ngModel)]=\"data.defaultvalue\"\r\n                  [showTime]=\"data.showtime\"\r\n                  [dValidateRules]=\"data.rules\"\r\n                ></d-range-datepicker-pro>\r\n            </ng-template>\r\n          </d-form-control>\r\n        </d-form-item>\r\n  </ng-template>", styles: ["div.box{padding:10px;font-size:var(--devui-font-size, 12px);color:var(--devui-brand, #5e7ce0);line-height:24px}a.date-link{text-decoration:none;color:inherit;cursor:pointer}a.date-link+a.date-link{margin-left:15px}a.date-link:hover{color:var(--devui-link-active, #344899)}.devui-input-group:not(:last-child){margin-bottom:20px}.devui-input-group-addon{width:1%;vertical-align:middle}.devui-input-group{width:320px}.devui-input-group-addon:hover{color:var(--devui-brand-active, #526ecc)}.close-icon-wrapper{padding:0}.icon-close{border-right:1px solid var(--devui-dividing-line, #dfe1e6);padding-right:10px;cursor:pointer}.custom-css-class{font-weight:700}\n"], components: [{ type: FormBoxComponent, selector: "form-box", inputs: ["mainCarry", "name", "controltype", "additionalcss"], outputs: ["controlclick"] }, { type: i3.FormItemComponent, selector: "d-form-item", inputs: ["dFeedbackType", "dHasFeedback"] }, { type: i3.FormLabelComponent, selector: "d-form-label", inputs: ["required", "hasHelp", "helpTips"] }, { type: i3.FormControlComponent, selector: "d-form-control", inputs: ["extraInfo", "feedbackStatus", "suffixTemplate"] }, { type: i3.DatepickerProComponent, selector: "d-datepicker-pro", inputs: ["mode", "showTime", "disabled", "autoOpen", "format", "cssClass", "showAnimation", "appendToBody", "width", "calenderRange", "minDate", "maxDate", "markedRangeDateList", "markedDateList"], outputs: ["dropdownToggle", "confirmEvent"] }, { type: i3.RangeDatepickerProComponent, selector: "d-range-datepicker-pro", inputs: ["mode", "showTime", "disabled", "autoOpen", "format", "locale", "cssClass", "splitter", "width", "startIndexOfWeek", "appendToBody", "calenderRange", "minDate", "maxDate", "markedRangeDateList", "markedDateList"], outputs: ["dropdownToggle", "confirmEvent"] }], directives: [{ type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i5.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i5.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { type: i3.DFormControlRuleDirective, selector: "[dValidateRules][formControlName],[dValidateRules][ngModel],[dValidateRules][formControl]", inputs: ["dValidateRules", "dValidatePopConfig"], outputs: ["dRulesStatusChange"], exportAs: ["dValidateRules"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormDateComponent, decorators: [{
            type: Component,
            args: [{ selector: 'form-date', template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n  <ng-template #detail>\r\n      <d-form-item>\r\n          <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n          <d-form-control>\r\n            <ng-container *ngIf=\"data.datetype=='date'; else datarange\">\r\n              <d-datepicker-pro \r\n                [formControl]=\"control\"\r\n                [attr.name]=\"data.controlname\"\r\n                [(ngModel)]=\"data.defaultvalue\" \r\n                [showTime] = \"data.showtime\" \r\n                [appendToBody]=\"true\"\r\n                [dValidateRules]=\"data.rules\"\r\n                [format]=\"data.dateFormat\"></d-datepicker-pro>\r\n            </ng-container>\r\n              \r\n            <ng-template #datarange>\r\n                <d-range-datepicker-pro\r\n                  [formControl]=\"control\"\r\n                  [attr.name]=\"data.controlname\"\r\n                  [appendToBody]=\"true\"\r\n                  [(ngModel)]=\"data.defaultvalue\"\r\n                  [showTime]=\"data.showtime\"\r\n                  [dValidateRules]=\"data.rules\"\r\n                ></d-range-datepicker-pro>\r\n            </ng-template>\r\n          </d-form-control>\r\n        </d-form-item>\r\n  </ng-template>", styles: ["div.box{padding:10px;font-size:var(--devui-font-size, 12px);color:var(--devui-brand, #5e7ce0);line-height:24px}a.date-link{text-decoration:none;color:inherit;cursor:pointer}a.date-link+a.date-link{margin-left:15px}a.date-link:hover{color:var(--devui-link-active, #344899)}.devui-input-group:not(:last-child){margin-bottom:20px}.devui-input-group-addon{width:1%;vertical-align:middle}.devui-input-group{width:320px}.devui-input-group-addon:hover{color:var(--devui-brand-active, #526ecc)}.close-icon-wrapper{padding:0}.icon-close{border-right:1px solid var(--devui-dividing-line, #dfe1e6);padding-right:10px;cursor:pointer}.custom-css-class{font-weight:700}\n"] }]
        }], ctorParameters: function () { return [{ type: CommonService }]; } });

class FormDividerComponent extends BaseControl {
    constructor(commonService) {
        super(commonService);
        this.commonService = commonService;
    }
    ngOnInit() {
    }
}
FormDividerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormDividerComponent, deps: [{ token: CommonService }], target: i0.ɵɵFactoryTarget.Component });
FormDividerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormDividerComponent, selector: "form-divider", usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n<ng-template #detail>\r\n      <d-form-item style=\"margin: 0px;\">\r\n          <d-form-control>\r\n            <div class=\"form-divider form-divider-horizontal\">\r\n                <div class=\"form-divider__text\" [ngClass]=\"data.align\">{{data.label}}</div>\r\n            </div>\r\n          </d-form-control>\r\n        </d-form-item>\r\n  </ng-template>", styles: [".form-divider{background-color:#dcdfe6;position:relative}.form-divider-horizontal{display:block;height:1px;width:100%;margin:24px 0}.form-divider__text{position:absolute;background-color:#fff;padding:0 20px;color:#303133}.form-divider__text.is-center{left:50%;transform:translate(-50%) translateY(-50%)}.form-divider__text.is-right{right:20px;transform:translateY(-50%)}.form-divider__text.is-left{left:20px;transform:translateY(-50%)}\n"], components: [{ type: FormBoxComponent, selector: "form-box", inputs: ["mainCarry", "name", "controltype", "additionalcss"], outputs: ["controlclick"] }, { type: i3.FormItemComponent, selector: "d-form-item", inputs: ["dFeedbackType", "dHasFeedback"] }, { type: i3.FormControlComponent, selector: "d-form-control", inputs: ["extraInfo", "feedbackStatus", "suffixTemplate"] }], directives: [{ type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i4.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormDividerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'form-divider', template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n<ng-template #detail>\r\n      <d-form-item style=\"margin: 0px;\">\r\n          <d-form-control>\r\n            <div class=\"form-divider form-divider-horizontal\">\r\n                <div class=\"form-divider__text\" [ngClass]=\"data.align\">{{data.label}}</div>\r\n            </div>\r\n          </d-form-control>\r\n        </d-form-item>\r\n  </ng-template>", styles: [".form-divider{background-color:#dcdfe6;position:relative}.form-divider-horizontal{display:block;height:1px;width:100%;margin:24px 0}.form-divider__text{position:absolute;background-color:#fff;padding:0 20px;color:#303133}.form-divider__text.is-center{left:50%;transform:translate(-50%) translateY(-50%)}.form-divider__text.is-right{right:20px;transform:translateY(-50%)}.form-divider__text.is-left{left:20px;transform:translateY(-50%)}\n"] }]
        }], ctorParameters: function () { return [{ type: CommonService }]; } });

class FormInputComponent extends BaseControl {
    constructor(commonService) {
        super(commonService);
        this.commonService = commonService;
        this.control = new FormControl();
    }
    ngOnInit() {
    }
}
FormInputComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormInputComponent, deps: [{ token: CommonService }], target: i0.ɵɵFactoryTarget.Component });
FormInputComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormInputComponent, selector: "form-input", usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n  <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n<ng-template #detail>\r\n    <d-form-item>\r\n        <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n        <d-form-control>\r\n          <input \r\n          dTextInput \r\n          [formControl]=\"control\"\r\n          autocomplete=\"off\" \r\n          [(ngModel)]=\"data.defaultvalue\" \r\n          [attr.name]=\"data.controlname\" \r\n          [placeholder]=\"data.placeholder\" \r\n          [dValidateRules]=\"data.rules\" \r\n          [disabled]=\"data.disabled\" />\r\n        </d-form-control>\r\n      </d-form-item>\r\n</ng-template>", styles: [""], components: [{ type: FormBoxComponent, selector: "form-box", inputs: ["mainCarry", "name", "controltype", "additionalcss"], outputs: ["controlclick"] }, { type: i3.FormItemComponent, selector: "d-form-item", inputs: ["dFeedbackType", "dHasFeedback"] }, { type: i3.FormLabelComponent, selector: "d-form-label", inputs: ["required", "hasHelp", "helpTips"] }, { type: i3.FormControlComponent, selector: "d-form-control", inputs: ["extraInfo", "feedbackStatus", "suffixTemplate"] }], directives: [{ type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i5.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i3.TextDirective, selector: "[dTextInput]", inputs: ["error", "size"], exportAs: ["dTextInput"] }, { type: i5.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i5.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { type: i3.DFormControlRuleDirective, selector: "[dValidateRules][formControlName],[dValidateRules][ngModel],[dValidateRules][formControl]", inputs: ["dValidateRules", "dValidatePopConfig"], outputs: ["dRulesStatusChange"], exportAs: ["dValidateRules"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormInputComponent, decorators: [{
            type: Component,
            args: [{ selector: 'form-input', template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n  <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n<ng-template #detail>\r\n    <d-form-item>\r\n        <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n        <d-form-control>\r\n          <input \r\n          dTextInput \r\n          [formControl]=\"control\"\r\n          autocomplete=\"off\" \r\n          [(ngModel)]=\"data.defaultvalue\" \r\n          [attr.name]=\"data.controlname\" \r\n          [placeholder]=\"data.placeholder\" \r\n          [dValidateRules]=\"data.rules\" \r\n          [disabled]=\"data.disabled\" />\r\n        </d-form-control>\r\n      </d-form-item>\r\n</ng-template>", styles: [""] }]
        }], ctorParameters: function () { return [{ type: CommonService }]; } });

class FormLayoutComponent extends BaseControl {
    constructor(commonService) {
        super(commonService);
        this.commonService = commonService;
        this.originallayouts = new Map();
    }
    ngOnInit() {
        if (this.data.mode == "op") {
            this.commonService.formItemClickObservable.subscribe(o => {
                this.data.defaultvalue.forEach((v) => {
                    if (o == v.name) {
                        v.selected = !v.selected;
                    }
                    else {
                        v.selected = false;
                    }
                });
            });
        }
    }
    onAddrow() {
        const name = UUID.UUID();
        this.data.defaultvalue.push({ name: name, selected: "", boxInfos: [] });
        this.addTolayout(this.commonService.boxLayout, name);
    }
    onRemoverow(e) {
        for (let index = 0; index < this.data.defaultvalue.length; index++) {
            const element = this.data.defaultvalue[index];
            if (element.name == e) {
                this.data.defaultvalue.splice(index, 1);
                break;
            }
        }
        this.removelayout(this.commonService.boxLayout, e);
    }
    addTolayout(reallayouts, name) {
        for (let index = 0; index < reallayouts.length; index++) {
            const element = reallayouts[index];
            if (element.layout) {
                if (element.boxid == this.data.name) {
                    element.layout.push({ name: name, boxInfos: [] });
                    return true;
                }
                else {
                    for (let j = 0; j < element.layout.length; j++) {
                        const layout = element.layout[j];
                        if (this.addTolayout(layout.boxInfos, name)) {
                            return true;
                        }
                    }
                }
            }
        }
        return false;
    }
    removelayout(reallayouts, name) {
        for (let index = 0; index < reallayouts.length; index++) {
            const element = reallayouts[index];
            if (element.layout) {
                for (let j = 0; j < element.layout.length; j++) {
                    const layout = element.layout[j];
                    if (layout.name == name) {
                        element.layout.splice(j, 1);
                        return true;
                    }
                    else {
                        if (this.addTolayout(layout.boxInfos, name)) {
                            return true;
                        }
                    }
                }
            }
        }
        return false;
    }
}
FormLayoutComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormLayoutComponent, deps: [{ token: CommonService }], target: i0.ɵɵFactoryTarget.Component });
FormLayoutComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormLayoutComponent, selector: "form-layout", inputs: { originallayouts: "originallayouts" }, usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\" [additionalcss]=\"'add-control-area'\"></form-box>\r\n</ng-container>\r\n<ng-template #detail>\r\n  <d-row [attr.data-box-id]=\"data.name\" [dGutter]=\"[ 12, 12]\" [ngClass]=\"{'row-style':data.mode=='op'}\">\r\n    <d-col [attr.data-box-id]=\"item.name\" [dSpan]=\"12\" *ngFor=\"let item of data.defaultvalue;let index=index\">\r\n      <div [class.box]=\"data.mode == 'op'\" [attr.data-box-id]=\"item.name\" [ngClass]=\"{'selected':item.selected && data.mode=='op'}\">\r\n        <form-area [name]=\"item.name\" [mode]=\"data.mode\" [originalLayout] = \"originallayouts.get(item.name)||[]\" (onaddrow)=\"onAddrow()\" (onremoverow)=\"onRemoverow($event)\"></form-area>\r\n      </div>\r\n    </d-col>\r\n  </d-row>\r\n</ng-template>", styles: [".box{border:2px dashed var(--devui-brand-hover, #7693f5);border-radius:5px}.selected,.box:hover{border:2px solid var(--devui-brand, #5e7ce0)}.row-style{padding:10px 3px 3px}d-col:nth-child(odd)>div{margin-right:3px;margin-bottom:3px}d-col:nth-child(even)>div{margin-left:2px;margin-bottom:3px}\n"], components: [{ type: FormBoxComponent, selector: "form-box", inputs: ["mainCarry", "name", "controltype", "additionalcss"], outputs: ["controlclick"] }, { type: i3.DRowComponent, selector: "d-row", inputs: ["dCols"] }, { type: i3.DColComponent, selector: "d-col", inputs: ["dSpan", "dOffset", "dPush", "dPull"] }, { type: FormAreaComponent, selector: "form-area", inputs: ["name", "mode", "originalLayout"], outputs: ["onaddrow", "onremoverow"] }], directives: [{ type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i3.DFlexDirective, selector: "[dFlex], d-row, d-col", inputs: ["dFlex", "dFlexContainer", "dOrder", "dAlign", "dAlignSelf", "dJustify", "dFlexWrap"] }, { type: i3.DGutterDirective, selector: "[dGutter]", inputs: ["dGutter", "dGutterDirection", "dGutterNoOuter"] }, { type: i4.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i4.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormLayoutComponent, decorators: [{
            type: Component,
            args: [{ selector: 'form-layout', template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\" [additionalcss]=\"'add-control-area'\"></form-box>\r\n</ng-container>\r\n<ng-template #detail>\r\n  <d-row [attr.data-box-id]=\"data.name\" [dGutter]=\"[ 12, 12]\" [ngClass]=\"{'row-style':data.mode=='op'}\">\r\n    <d-col [attr.data-box-id]=\"item.name\" [dSpan]=\"12\" *ngFor=\"let item of data.defaultvalue;let index=index\">\r\n      <div [class.box]=\"data.mode == 'op'\" [attr.data-box-id]=\"item.name\" [ngClass]=\"{'selected':item.selected && data.mode=='op'}\">\r\n        <form-area [name]=\"item.name\" [mode]=\"data.mode\" [originalLayout] = \"originallayouts.get(item.name)||[]\" (onaddrow)=\"onAddrow()\" (onremoverow)=\"onRemoverow($event)\"></form-area>\r\n      </div>\r\n    </d-col>\r\n  </d-row>\r\n</ng-template>", styles: [".box{border:2px dashed var(--devui-brand-hover, #7693f5);border-radius:5px}.selected,.box:hover{border:2px solid var(--devui-brand, #5e7ce0)}.row-style{padding:10px 3px 3px}d-col:nth-child(odd)>div{margin-right:3px;margin-bottom:3px}d-col:nth-child(even)>div{margin-left:2px;margin-bottom:3px}\n"] }]
        }], ctorParameters: function () { return [{ type: CommonService }]; }, propDecorators: { originallayouts: [{
                type: Input,
                args: ["originallayouts"]
            }] } });

class FormRadioComponent extends BaseControl {
    constructor(commonService) {
        super(commonService);
        this.commonService = commonService;
        this.control = new FormControl();
    }
    ngOnInit() {
        this.getData();
        this.commonService.testEvent.subscribe(o => {
            if (o == this.data.name) {
                this.getData();
            }
        });
    }
    getData() {
        var _a;
        (_a = this.commonService.getTheData(this.data)) === null || _a === void 0 ? void 0 : _a.subscribe(o => {
            var res = null;
            eval("res =" + this.data.postdata.function);
            this.data.options = res(o);
        });
    }
}
FormRadioComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormRadioComponent, deps: [{ token: CommonService }], target: i0.ɵɵFactoryTarget.Component });
FormRadioComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormRadioComponent, selector: "form-radio", usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n<ng-template #detail>\r\n    <d-form-item>\r\n        <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n        <d-form-control>\r\n            <d-radio-group \r\n            [formControl]=\"control\"\r\n            [(ngModel)]=\"data.defaultvalue\" \r\n            [disabled]=\"data.disabled\" \r\n            [attr.name]=\"data.controlname\" \r\n            [values]=\"data.options\" \r\n            [direction]=\"data.direction\" \r\n            [dValidateRules]=\"data.rules\">\r\n            </d-radio-group>\r\n        </d-form-control>\r\n    </d-form-item>\r\n</ng-template>", styles: [""], components: [{ type: FormBoxComponent, selector: "form-box", inputs: ["mainCarry", "name", "controltype", "additionalcss"], outputs: ["controlclick"] }, { type: i3.FormItemComponent, selector: "d-form-item", inputs: ["dFeedbackType", "dHasFeedback"] }, { type: i3.FormLabelComponent, selector: "d-form-label", inputs: ["required", "hasHelp", "helpTips"] }, { type: i3.FormControlComponent, selector: "d-form-control", inputs: ["extraInfo", "feedbackStatus", "suffixTemplate"] }, { type: i3.RadioGroupComponent, selector: "d-radio-group", inputs: ["name", "values", "cssStyle", "direction", "disabled", "beforeChange"], outputs: ["change"] }], directives: [{ type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i5.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i5.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { type: i3.DFormControlRuleDirective, selector: "[dValidateRules][formControlName],[dValidateRules][ngModel],[dValidateRules][formControl]", inputs: ["dValidateRules", "dValidatePopConfig"], outputs: ["dRulesStatusChange"], exportAs: ["dValidateRules"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormRadioComponent, decorators: [{
            type: Component,
            args: [{ selector: 'form-radio', template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n<ng-template #detail>\r\n    <d-form-item>\r\n        <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n        <d-form-control>\r\n            <d-radio-group \r\n            [formControl]=\"control\"\r\n            [(ngModel)]=\"data.defaultvalue\" \r\n            [disabled]=\"data.disabled\" \r\n            [attr.name]=\"data.controlname\" \r\n            [values]=\"data.options\" \r\n            [direction]=\"data.direction\" \r\n            [dValidateRules]=\"data.rules\">\r\n            </d-radio-group>\r\n        </d-form-control>\r\n    </d-form-item>\r\n</ng-template>", styles: [""] }]
        }], ctorParameters: function () { return [{ type: CommonService }]; } });

class FormRateComponent extends BaseControl {
    constructor(commonService) {
        super(commonService);
        this.commonService = commonService;
        this.control = new FormControl();
    }
    ngOnInit() {
    }
}
FormRateComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormRateComponent, deps: [{ token: CommonService }], target: i0.ɵɵFactoryTarget.Component });
FormRateComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormRateComponent, selector: "form-rate", usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n<ng-template #detail>\r\n      <d-form-item>\r\n          <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n          <d-form-control>\r\n            <d-rate \r\n            [formControl]=\"control\"\r\n            [(ngModel)]=\"data.defaultvalue\" \r\n            [allowHalf]=\"data.allowhalf\" \r\n            [attr.name]=\"data.controlname\" \r\n            [disabled]=\"data.disabled\" \r\n            [dValidateRules]=\"data.rules\"></d-rate>\r\n          </d-form-control>\r\n        </d-form-item>\r\n</ng-template>", styles: [""], components: [{ type: FormBoxComponent, selector: "form-box", inputs: ["mainCarry", "name", "controltype", "additionalcss"], outputs: ["controlclick"] }, { type: i3.FormItemComponent, selector: "d-form-item", inputs: ["dFeedbackType", "dHasFeedback"] }, { type: i3.FormLabelComponent, selector: "d-form-label", inputs: ["required", "hasHelp", "helpTips"] }, { type: i3.FormControlComponent, selector: "d-form-control", inputs: ["extraInfo", "feedbackStatus", "suffixTemplate"] }, { type: i3.RateComponent, selector: "d-rate", inputs: ["read", "readonly", "count", "color", "icon", "character", "type", "allowHalf"] }], directives: [{ type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i5.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i5.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { type: i3.DFormControlRuleDirective, selector: "[dValidateRules][formControlName],[dValidateRules][ngModel],[dValidateRules][formControl]", inputs: ["dValidateRules", "dValidatePopConfig"], outputs: ["dRulesStatusChange"], exportAs: ["dValidateRules"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormRateComponent, decorators: [{
            type: Component,
            args: [{ selector: 'form-rate', template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n<ng-template #detail>\r\n      <d-form-item>\r\n          <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n          <d-form-control>\r\n            <d-rate \r\n            [formControl]=\"control\"\r\n            [(ngModel)]=\"data.defaultvalue\" \r\n            [allowHalf]=\"data.allowhalf\" \r\n            [attr.name]=\"data.controlname\" \r\n            [disabled]=\"data.disabled\" \r\n            [dValidateRules]=\"data.rules\"></d-rate>\r\n          </d-form-control>\r\n        </d-form-item>\r\n</ng-template>", styles: [""] }]
        }], ctorParameters: function () { return [{ type: CommonService }]; } });

class FormRichinputComponent extends BaseControl {
    constructor(commonService, document) {
        super(commonService);
        this.commonService = commonService;
        this.document = document;
        this.editor = ClassicEditor;
        this.canvasInfo = CANVASDEFAULT;
    }
    ngOnInit() {
        this.commonService.changeFormLayout.subscribe(o => {
            this.canvasInfo = o;
        });
    }
}
FormRichinputComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormRichinputComponent, deps: [{ token: CommonService }, { token: DOCUMENT }], target: i0.ɵɵFactoryTarget.Component });
FormRichinputComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormRichinputComponent, selector: "form-richinput", usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n  <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n<ng-template #detail>\r\n    <d-form-item>\r\n        <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n        <d-form-control style=\"flex: 1;\" [ngStyle]=\"{'width':canvasInfo.layout=='horizontal'?'0px':'100%'}\">\r\n          <div class=\"mianrichinput\">\r\n            <ckeditor [editor]=\"editor\" [(ngModel)]=\"data.defaultvalue\"></ckeditor>\r\n          </div>\r\n        </d-form-control>\r\n      </d-form-item>\r\n</ng-template>", styles: [":host ::ng-deep .ck-editor__editable_inline{height:200px!important}\n"], components: [{ type: FormBoxComponent, selector: "form-box", inputs: ["mainCarry", "name", "controltype", "additionalcss"], outputs: ["controlclick"] }, { type: i3.FormItemComponent, selector: "d-form-item", inputs: ["dFeedbackType", "dHasFeedback"] }, { type: i3.FormLabelComponent, selector: "d-form-label", inputs: ["required", "hasHelp", "helpTips"] }, { type: i3.FormControlComponent, selector: "d-form-control", inputs: ["extraInfo", "feedbackStatus", "suffixTemplate"] }, { type: i4$1.CKEditorComponent, selector: "ckeditor", inputs: ["config", "data", "tagName", "disabled", "editor", "watchdog"], outputs: ["ready", "change", "blur", "focus", "error"] }], directives: [{ type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i4.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { type: i5.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i5.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormRichinputComponent, decorators: [{
            type: Component,
            args: [{ selector: 'form-richinput', template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n  <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n<ng-template #detail>\r\n    <d-form-item>\r\n        <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n        <d-form-control style=\"flex: 1;\" [ngStyle]=\"{'width':canvasInfo.layout=='horizontal'?'0px':'100%'}\">\r\n          <div class=\"mianrichinput\">\r\n            <ckeditor [editor]=\"editor\" [(ngModel)]=\"data.defaultvalue\"></ckeditor>\r\n          </div>\r\n        </d-form-control>\r\n      </d-form-item>\r\n</ng-template>", styles: [":host ::ng-deep .ck-editor__editable_inline{height:200px!important}\n"] }]
        }], ctorParameters: function () {
        return [{ type: CommonService }, { type: Document, decorators: [{
                        type: Inject,
                        args: [DOCUMENT]
                    }] }];
    } });

class FormSelectComponent extends BaseControl {
    constructor(commonService) {
        super(commonService);
        this.commonService = commonService;
        this.control = new FormControl();
    }
    ngOnInit() {
        this.getData();
        this.commonService.testEvent.subscribe(o => {
            if (o == this.data.name) {
                this.getData();
            }
        });
    }
    getData() {
        var _a;
        (_a = this.commonService.getTheData(this.data)) === null || _a === void 0 ? void 0 : _a.subscribe(o => {
            var res = null;
            eval("res =" + this.data.postdata.function);
            this.data.options = res(o);
        });
    }
    maxOptions(num) {
        return (val) => {
            return !val || val.length <= num;
        };
    }
    minOptions(num) {
        return (val) => {
            return !val || val.length >= num;
        };
    }
}
FormSelectComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormSelectComponent, deps: [{ token: CommonService }], target: i0.ɵɵFactoryTarget.Component });
FormSelectComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormSelectComponent, selector: "form-select", usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n  </ng-container>\r\n  <ng-template #detail>\r\n      <d-form-item>\r\n          <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n          <d-form-control>\r\n            <div>\r\n                <d-select \r\n                [formControl]=\"control\"\r\n                [attr.name]=\"data.controlname\" \r\n                [multiple]=\"data.multiple\" \r\n                [options]=\"data.options\" \r\n                [filterKey]=\"data.filter\" \r\n                [placeholder]=\"data.placeholder\" \r\n                [(ngModel)]=\"data.defaultvalue\"\r\n                [extraConfig]=\"{\r\n                  labelization: { enable: true, overflow: 'multiple-line' }\r\n                }\"\r\n                [dValidateRules]=\"data.rules\"\r\n                [disabled]=\"data.disabled\"></d-select>\r\n            </div>\r\n          </d-form-control>\r\n        </d-form-item>\r\n  </ng-template>", styles: [""], components: [{ type: FormBoxComponent, selector: "form-box", inputs: ["mainCarry", "name", "controltype", "additionalcss"], outputs: ["controlclick"] }, { type: i3.FormItemComponent, selector: "d-form-item", inputs: ["dFeedbackType", "dHasFeedback"] }, { type: i3.FormLabelComponent, selector: "d-form-label", inputs: ["required", "hasHelp", "helpTips"] }, { type: i3.FormControlComponent, selector: "d-form-control", inputs: ["extraInfo", "feedbackStatus", "suffixTemplate"] }, { type: i3.SelectComponent, selector: "d-select", inputs: ["options", "isSearch", "toggleOnFocus", "scrollHight", "highlightItemClass", "filterKey", "multiple", "isSelectAll", "readonly", "size", "appendToBody", "appendToBodyDirections", "width", "templateItemSize", "disabled", "placeholder", "searchPlaceholder", "searchFn", "valueParser", "formatter", "direction", "overview", "allowClear", "color", "enableLazyLoad", "virtualScroll", "inputItemTemplate", "extraConfig", "optionDisabledKey", "optionImmutableKey", "noResultItemTemplate", "keepMultipleOrder", "customViewTemplate", "customViewDirection", "autoFocus", "notAutoScroll", "loadingTemplateRef", "showAnimation"], outputs: ["valueChange", "toggleChange", "loadMore"], exportAs: ["select"] }], directives: [{ type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i5.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i5.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { type: i3.DFormControlRuleDirective, selector: "[dValidateRules][formControlName],[dValidateRules][ngModel],[dValidateRules][formControl]", inputs: ["dValidateRules", "dValidatePopConfig"], outputs: ["dRulesStatusChange"], exportAs: ["dValidateRules"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormSelectComponent, decorators: [{
            type: Component,
            args: [{ selector: 'form-select', template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n  </ng-container>\r\n  <ng-template #detail>\r\n      <d-form-item>\r\n          <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n          <d-form-control>\r\n            <div>\r\n                <d-select \r\n                [formControl]=\"control\"\r\n                [attr.name]=\"data.controlname\" \r\n                [multiple]=\"data.multiple\" \r\n                [options]=\"data.options\" \r\n                [filterKey]=\"data.filter\" \r\n                [placeholder]=\"data.placeholder\" \r\n                [(ngModel)]=\"data.defaultvalue\"\r\n                [extraConfig]=\"{\r\n                  labelization: { enable: true, overflow: 'multiple-line' }\r\n                }\"\r\n                [dValidateRules]=\"data.rules\"\r\n                [disabled]=\"data.disabled\"></d-select>\r\n            </div>\r\n          </d-form-control>\r\n        </d-form-item>\r\n  </ng-template>", styles: [""] }]
        }], ctorParameters: function () { return [{ type: CommonService }]; } });

class FormSliderComponent extends BaseControl {
    constructor(commonService) {
        super(commonService);
        this.commonService = commonService;
    }
    ngOnInit() {
    }
}
FormSliderComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormSliderComponent, deps: [{ token: CommonService }], target: i0.ɵɵFactoryTarget.Component });
FormSliderComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormSliderComponent, selector: "form-slider", usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n<ng-template #detail>\r\n    <d-form-item>\r\n        <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n        <d-form-control>\r\n            <div class=\"slider-wrapper\">\r\n                <d-slider \r\n                [attr.name]=\"data.controlname\" \r\n                [(ngModel)]=\"data.defaultvalue\" \r\n                [min]=\"data.min\" \r\n                [max]=\"data.max\" \r\n                [step]=\"data.step\" \r\n                [dValidateRules]=\"data.rules\" \r\n                [disabled]=\"data.disabled\"\r\n                class=\"slider\"></d-slider>\r\n                <span>{{ data.min }}</span>\r\n                <span>{{ data.max }}</span>\r\n            </div>\r\n        </d-form-control>\r\n    </d-form-item>\r\n</ng-template>", styles: [".slider-wrapper{position:relative}.slider-wrapper span{position:absolute;top:15px}.slider-wrapper span:last-child{right:0}\n"], components: [{ type: FormBoxComponent, selector: "form-box", inputs: ["mainCarry", "name", "controltype", "additionalcss"], outputs: ["controlclick"] }, { type: i3.FormItemComponent, selector: "d-form-item", inputs: ["dFeedbackType", "dHasFeedback"] }, { type: i3.FormLabelComponent, selector: "d-form-label", inputs: ["required", "hasHelp", "helpTips"] }, { type: i3.FormControlComponent, selector: "d-form-control", inputs: ["extraInfo", "feedbackStatus", "suffixTemplate"] }, { type: i3.SliderComponent, selector: "d-slider", inputs: ["max", "min", "step", "disabled", "tipsRenderer"], outputs: ["afterChange"] }], directives: [{ type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i5.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i5.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { type: i3.DFormControlRuleDirective, selector: "[dValidateRules][formControlName],[dValidateRules][ngModel],[dValidateRules][formControl]", inputs: ["dValidateRules", "dValidatePopConfig"], outputs: ["dRulesStatusChange"], exportAs: ["dValidateRules"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormSliderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'form-slider', template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n<ng-template #detail>\r\n    <d-form-item>\r\n        <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n        <d-form-control>\r\n            <div class=\"slider-wrapper\">\r\n                <d-slider \r\n                [attr.name]=\"data.controlname\" \r\n                [(ngModel)]=\"data.defaultvalue\" \r\n                [min]=\"data.min\" \r\n                [max]=\"data.max\" \r\n                [step]=\"data.step\" \r\n                [dValidateRules]=\"data.rules\" \r\n                [disabled]=\"data.disabled\"\r\n                class=\"slider\"></d-slider>\r\n                <span>{{ data.min }}</span>\r\n                <span>{{ data.max }}</span>\r\n            </div>\r\n        </d-form-control>\r\n    </d-form-item>\r\n</ng-template>", styles: [".slider-wrapper{position:relative}.slider-wrapper span{position:absolute;top:15px}.slider-wrapper span:last-child{right:0}\n"] }]
        }], ctorParameters: function () { return [{ type: CommonService }]; } });

class FormSpaceComponent extends BaseControl {
    constructor(commonService) {
        super(commonService);
        this.commonService = commonService;
    }
    ngOnInit() {
    }
}
FormSpaceComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormSpaceComponent, deps: [{ token: CommonService }], target: i0.ɵɵFactoryTarget.Component });
FormSpaceComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormSpaceComponent, selector: "form-space", usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n<ng-template #detail>\r\n      <d-form-item>\r\n          <d-form-control>\r\n            <div [style]=\"{'height':data.height+'px'}\">\r\n            </div>\r\n          </d-form-control>\r\n        </d-form-item>\r\n  </ng-template>", styles: [""], components: [{ type: FormBoxComponent, selector: "form-box", inputs: ["mainCarry", "name", "controltype", "additionalcss"], outputs: ["controlclick"] }, { type: i3.FormItemComponent, selector: "d-form-item", inputs: ["dFeedbackType", "dHasFeedback"] }, { type: i3.FormControlComponent, selector: "d-form-control", inputs: ["extraInfo", "feedbackStatus", "suffixTemplate"] }], directives: [{ type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormSpaceComponent, decorators: [{
            type: Component,
            args: [{ selector: 'form-space', template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n<ng-template #detail>\r\n      <d-form-item>\r\n          <d-form-control>\r\n            <div [style]=\"{'height':data.height+'px'}\">\r\n            </div>\r\n          </d-form-control>\r\n        </d-form-item>\r\n  </ng-template>", styles: [""] }]
        }], ctorParameters: function () { return [{ type: CommonService }]; } });

class FormTimeComponent extends BaseControl {
    constructor(commonService) {
        super(commonService);
        this.commonService = commonService;
        this.control = new FormControl();
    }
    ngOnInit() {
    }
}
FormTimeComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormTimeComponent, deps: [{ token: CommonService }], target: i0.ɵɵFactoryTarget.Component });
FormTimeComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormTimeComponent, selector: "form-time", usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n  <ng-template #detail>\r\n      <d-form-item>\r\n          <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n          <d-form-control>\r\n            <div class=\"devui-input-group devui-dropdown-origin\">\r\n                <input\r\n                  class=\"devui-input devui-form-control\"\r\n                  [formControl]=\"control\"\r\n                  [attr.name]=\"data.controlname\" \r\n                  [placeholder]=\"data.placeholder\"\r\n                  autocomplete=\"off\"\r\n                  dTimePicker\r\n                  [(ngModel)]=\"data.defaultvalue\"\r\n                  (click)=\"timePicker.toggle()\"\r\n                  #timePicker=\"timePicker\"\r\n                  [format]=\"data.format\"\r\n                  [dValidateRules]=\"data.rules\"\r\n                />\r\n                <div *ngIf=\"data.defaultvalue\" class=\"devui-input-group-addon close-icon-wrapper\" (click)=\"timePicker.clearAll()\">\r\n                  <i class=\"icon icon-close\"></i>\r\n                </div>\r\n                <div class=\"devui-input-group-addon\" (click)=\"timePicker.toggle()\">\r\n                  <i class=\"icon fc-icon icon-time\"></i>\r\n                </div>\r\n              </div>\r\n          </d-form-control>\r\n        </d-form-item>\r\n  </ng-template>", styles: [".devui-input-group{width:260px}.devui-input-group-addon{cursor:pointer;vertical-align:middle}.devui-input-group-addon .icon{vertical-align:middle}.close-icon-wrapper{padding:0}\n"], components: [{ type: FormBoxComponent, selector: "form-box", inputs: ["mainCarry", "name", "controltype", "additionalcss"], outputs: ["controlclick"] }, { type: i3.FormItemComponent, selector: "d-form-item", inputs: ["dFeedbackType", "dHasFeedback"] }, { type: i3.FormLabelComponent, selector: "d-form-label", inputs: ["required", "hasHelp", "helpTips"] }, { type: i3.FormControlComponent, selector: "d-form-control", inputs: ["extraInfo", "feedbackStatus", "suffixTemplate"] }, { type: i3.TimePickerComponent, selector: "[dTimePicker]", inputs: ["appendToBodyDirections", "disabled", "customViewTemplate", "autoOpen", "showAnimation", "minTime", "maxTime", "format", "timePickerWidth"], outputs: ["selectedTimeChange"], exportAs: ["timePicker"] }], directives: [{ type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i5.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i5.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i5.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { type: i3.DFormControlRuleDirective, selector: "[dValidateRules][formControlName],[dValidateRules][ngModel],[dValidateRules][formControl]", inputs: ["dValidateRules", "dValidatePopConfig"], outputs: ["dRulesStatusChange"], exportAs: ["dValidateRules"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormTimeComponent, decorators: [{
            type: Component,
            args: [{ selector: 'form-time', template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n  <ng-template #detail>\r\n      <d-form-item>\r\n          <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n          <d-form-control>\r\n            <div class=\"devui-input-group devui-dropdown-origin\">\r\n                <input\r\n                  class=\"devui-input devui-form-control\"\r\n                  [formControl]=\"control\"\r\n                  [attr.name]=\"data.controlname\" \r\n                  [placeholder]=\"data.placeholder\"\r\n                  autocomplete=\"off\"\r\n                  dTimePicker\r\n                  [(ngModel)]=\"data.defaultvalue\"\r\n                  (click)=\"timePicker.toggle()\"\r\n                  #timePicker=\"timePicker\"\r\n                  [format]=\"data.format\"\r\n                  [dValidateRules]=\"data.rules\"\r\n                />\r\n                <div *ngIf=\"data.defaultvalue\" class=\"devui-input-group-addon close-icon-wrapper\" (click)=\"timePicker.clearAll()\">\r\n                  <i class=\"icon icon-close\"></i>\r\n                </div>\r\n                <div class=\"devui-input-group-addon\" (click)=\"timePicker.toggle()\">\r\n                  <i class=\"icon fc-icon icon-time\"></i>\r\n                </div>\r\n              </div>\r\n          </d-form-control>\r\n        </d-form-item>\r\n  </ng-template>", styles: [".devui-input-group{width:260px}.devui-input-group-addon{cursor:pointer;vertical-align:middle}.devui-input-group-addon .icon{vertical-align:middle}.close-icon-wrapper{padding:0}\n"] }]
        }], ctorParameters: function () { return [{ type: CommonService }]; } });

class FormToggleComponent extends BaseControl {
    constructor(commonService) {
        super(commonService);
        this.commonService = commonService;
    }
    ngOnInit() {
    }
}
FormToggleComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormToggleComponent, deps: [{ token: CommonService }], target: i0.ɵɵFactoryTarget.Component });
FormToggleComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormToggleComponent, selector: "form-toggle", usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n<ng-template #detail>\r\n    <d-form-item>\r\n        <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n        <d-form-control>\r\n            <div>\r\n                <d-toggle [attr.name]=\"data.controlname\" [(ngModel)] = \"data.defaultvalue\" [disabled]=\"data.disabled\"></d-toggle>\r\n            </div>\r\n        </d-form-control>\r\n    </d-form-item>\r\n</ng-template>", styles: [""], components: [{ type: FormBoxComponent, selector: "form-box", inputs: ["mainCarry", "name", "controltype", "additionalcss"], outputs: ["controlclick"] }, { type: i3.FormItemComponent, selector: "d-form-item", inputs: ["dFeedbackType", "dHasFeedback"] }, { type: i3.FormLabelComponent, selector: "d-form-label", inputs: ["required", "hasHelp", "helpTips"] }, { type: i3.FormControlComponent, selector: "d-form-control", inputs: ["extraInfo", "feedbackStatus", "suffixTemplate"] }, { type: i3.ToggleComponent, selector: "d-toggle", inputs: ["size", "color", "beforeChange", "checkedContent", "uncheckedContent", "checked", "disabled"], outputs: ["change"], exportAs: ["toggle"] }], directives: [{ type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i5.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i5.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormToggleComponent, decorators: [{
            type: Component,
            args: [{ selector: 'form-toggle', template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n</ng-container>\r\n<ng-template #detail>\r\n    <d-form-item>\r\n        <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n        <d-form-control>\r\n            <div>\r\n                <d-toggle [attr.name]=\"data.controlname\" [(ngModel)] = \"data.defaultvalue\" [disabled]=\"data.disabled\"></d-toggle>\r\n            </div>\r\n        </d-form-control>\r\n    </d-form-item>\r\n</ng-template>", styles: [""] }]
        }], ctorParameters: function () { return [{ type: CommonService }]; } });

class FormTransferComponent extends BaseControl {
    constructor(commonService) {
        super(commonService);
        this.commonService = commonService;
    }
    ngOnInit() {
        this.getData();
        this.commonService.testEvent.subscribe(o => {
            if (o == this.data.name) {
                this.getData();
            }
        });
    }
    getData() {
        var _a;
        (_a = this.commonService.getTheData(this.data)) === null || _a === void 0 ? void 0 : _a.subscribe(o => {
            var res = null;
            eval("res =" + this.data.postdata.function);
            this.data.options = res(o);
        });
    }
}
FormTransferComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormTransferComponent, deps: [{ token: CommonService }], target: i0.ɵɵFactoryTarget.Component });
FormTransferComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormTransferComponent, selector: "form-transfer", usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n  </ng-container>\r\n  <ng-template #detail>\r\n      <d-form-item>\r\n          <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n          <d-form-control>\r\n            <d-transfer\r\n                [attr.name]=\"data.controlname\" \r\n                [disabled]=\"data.disabled\"\r\n                [sourceOption]=\"data.options\"\r\n                [targetOption]=\"data.defaultvalue\"\r\n                [titles]=\"{ source: data.source, target: data.target }\"\r\n            >\r\n            </d-transfer>\r\n          </d-form-control>\r\n        </d-form-item>\r\n  </ng-template>", styles: [""], components: [{ type: FormBoxComponent, selector: "form-box", inputs: ["mainCarry", "name", "controltype", "additionalcss"], outputs: ["controlclick"] }, { type: i3.FormItemComponent, selector: "d-form-item", inputs: ["dFeedbackType", "dHasFeedback"] }, { type: i3.FormLabelComponent, selector: "d-form-label", inputs: ["required", "hasHelp", "helpTips"] }, { type: i3.FormControlComponent, selector: "d-form-control", inputs: ["extraInfo", "feedbackStatus", "suffixTemplate"] }, { type: i3.TransferComponent, selector: "d-transfer", inputs: ["sourceOption", "targetOption", "titles", "height", "isSearch", "disabled", "isSourceDroppable", "isTargetDroppable", "showOptionTitle", "beforeTransfer", "virtualScroll", "customSourceCheckedLen", "customTargetCheckedLen"], outputs: ["transferToTarget", "transferToSource", "searching", "transferring", "afterTransfer"] }], directives: [{ type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormTransferComponent, decorators: [{
            type: Component,
            args: [{ selector: 'form-transfer', template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n  </ng-container>\r\n  <ng-template #detail>\r\n      <d-form-item>\r\n          <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n          <d-form-control>\r\n            <d-transfer\r\n                [attr.name]=\"data.controlname\" \r\n                [disabled]=\"data.disabled\"\r\n                [sourceOption]=\"data.options\"\r\n                [targetOption]=\"data.defaultvalue\"\r\n                [titles]=\"{ source: data.source, target: data.target }\"\r\n            >\r\n            </d-transfer>\r\n          </d-form-control>\r\n        </d-form-item>\r\n  </ng-template>", styles: [""] }]
        }], ctorParameters: function () { return [{ type: CommonService }]; } });

class FormTreeComponent extends BaseControl {
    constructor(commonService) {
        super(commonService);
        this.commonService = commonService;
    }
    ngAfterViewInit() {
        if (this.data.postdata.url != "") {
            this.childtree.loadChildrenFn = (value) => {
                return this.commonService.getTheData(this.data, value.value);
            };
        }
    }
    ngOnInit() {
        this.getData();
    }
    getData() {
        var _a;
        (_a = this.commonService.getTheData(this.data)) === null || _a === void 0 ? void 0 : _a.subscribe(o => {
            this.data.options = o;
        });
    }
}
FormTreeComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormTreeComponent, deps: [{ token: CommonService }], target: i0.ɵɵFactoryTarget.Component });
FormTreeComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormTreeComponent, selector: "form-tree", viewQueries: [{ propertyName: "childtree", first: true, predicate: CascaderComponent, descendants: true }], usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n  </ng-container>\r\n  <ng-template #detail>\r\n      <d-form-item>\r\n          <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n          <d-form-control>\r\n            <d-cascader\r\n                [disabled]=\"data.disabled\"\r\n                [attr.name]=\"data.controlname\" \r\n                [options]=\"data.options\"\r\n                [placeholder]=\"data.placeholder\"\r\n                [(ngModel)]=\"data.defaultvalue\"\r\n                [trigger]=\"'click'\"\r\n                [showPath]=\"true\"\r\n                [allowClear]=\"true\"\r\n                style=\"width:100%;\"\r\n                ></d-cascader>\r\n          </d-form-control>\r\n        </d-form-item>\r\n  </ng-template>", styles: [":host ::ng-deep d-cascader>div{width:100%!important}\n"], components: [{ type: FormBoxComponent, selector: "form-box", inputs: ["mainCarry", "name", "controltype", "additionalcss"], outputs: ["controlclick"] }, { type: i3.FormItemComponent, selector: "d-form-item", inputs: ["dFeedbackType", "dHasFeedback"] }, { type: i3.FormLabelComponent, selector: "d-form-label", inputs: ["required", "hasHelp", "helpTips"] }, { type: i3.FormControlComponent, selector: "d-form-control", inputs: ["extraInfo", "feedbackStatus", "suffixTemplate"] }, { type: i3.CascaderComponent, selector: "d-cascader", inputs: ["options", "width", "dropdownWidth", "placeholder", "trigger", "disabled", "multiple", "showPath", "allowClear", "allowSearch", "canSelectParent", "checkboxRelation", "dropDownItemTemplate", "dropdownHeaderTemplate", "dropdownPanelClass", "appendToBody", "showAnimation", "loadChildrenFn"], outputs: ["toggleEvent"] }], directives: [{ type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i5.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i5.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormTreeComponent, decorators: [{
            type: Component,
            args: [{ selector: 'form-tree', template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n  </ng-container>\r\n  <ng-template #detail>\r\n      <d-form-item>\r\n          <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n          <d-form-control>\r\n            <d-cascader\r\n                [disabled]=\"data.disabled\"\r\n                [attr.name]=\"data.controlname\" \r\n                [options]=\"data.options\"\r\n                [placeholder]=\"data.placeholder\"\r\n                [(ngModel)]=\"data.defaultvalue\"\r\n                [trigger]=\"'click'\"\r\n                [showPath]=\"true\"\r\n                [allowClear]=\"true\"\r\n                style=\"width:100%;\"\r\n                ></d-cascader>\r\n          </d-form-control>\r\n        </d-form-item>\r\n  </ng-template>", styles: [":host ::ng-deep d-cascader>div{width:100%!important}\n"] }]
        }], ctorParameters: function () { return [{ type: CommonService }]; }, propDecorators: { childtree: [{
                type: ViewChild,
                args: [CascaderComponent, { static: false }]
            }] } });

class FormUploadComponent extends BaseControl {
    constructor(commonService) {
        super(commonService);
        this.commonService = commonService;
        this.fileUploaders = [];
        this.message = [];
        this.isDropOver = false;
        this.UPLOADED = '上传成功';
        this.CANCELUPLOAD = '取消上传';
    }
    ngOnInit() {
    }
    fileDrop(files) {
        this.isDropOver = false;
        console.log(files);
    }
    fileOver(event) {
        this.isDropOver = event;
        console.log(event);
    }
    alertMsg(event) {
        this.message = event;
    }
    deleteFile(currFile) {
        this.fileUploaders = this.fileUploaders.filter((fileUploader) => {
            return currFile !== fileUploader;
        });
    }
}
FormUploadComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormUploadComponent, deps: [{ token: CommonService }], target: i0.ɵɵFactoryTarget.Component });
FormUploadComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormUploadComponent, selector: "form-upload", usesInheritance: true, ngImport: i0, template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n  </ng-container>\r\n  <ng-template #detail>\r\n      <d-form-item>\r\n        <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n        <d-form-control>\r\n            <ng-container *ngIf=\"fileUploaders.length > 0\">\r\n              <div *ngFor=\"let fileUploader of fileUploaders\" class=\"devui-add-images\">\r\n                <div\r\n                  class=\"devui-add-items {{ fileUploader.status === 3 ? 'devui-upload-failed' : '' }} \r\n                  {{ fileUploader.status === 2 ? 'devui-upload-success' : '' }}\"\r\n                >\r\n                  <span class=\"filename\">{{ fileUploader.file.name }}</span>\r\n                  <div *ngIf=\"fileUploader.status === 1\" class=\"devui-loading\">\r\n                    <d-progress [percentage]=\"fileUploader.percentage\" [height]=\"'5px'\" [barbgcolor]=\"'#50D4AB'\"></d-progress>\r\n                    <span (click)=\"deleteFile(fileUploader)\" class=\"devui-cancel-upload\">{{ CANCELUPLOAD }}</span>\r\n                  </div>\r\n                  <span *ngIf=\"fileUploader.status === 2 || fileUploader.status === 3\" class=\"icon-file\"></span>\r\n                </div>\r\n                <span class=\"icon fc-icon icon-delete {{ fileUploader.status === 3 ? 'devui-failed-icon' : '' }}\" (click)=\"deleteFile(fileUploader)\"></span>\r\n                <span *ngIf=\"fileUploader.status === 3\" class=\"icon icon-running\" (click)=\"dUpload.uploadFiles()\"></span>\r\n              </div>\r\n            </ng-container>\r\n            <div\r\n              dUpload\r\n              #dUpload=\"dUpload\"\r\n              [attr.name] = \"data.controlname\"\r\n              class=\"devui-add-images devui-upload {{ isDropOver ? 'devui-upload-dropover' : '' }}\"\r\n              [enableDrop]=\"true\"\r\n              [fileOptions]=\"data.fileOptions\"\r\n              [uploadOptions]=\"data.uploadOptions\"\r\n              [uploadedFiles]=\"data.uploadedFiles\"\r\n              [fileUploaders]=\"fileUploaders\"\r\n              (alertMsgEvent)=\"alertMsg($event)\"\r\n              (fileDrop)=\"fileDrop($event)\"\r\n              (fileOver)=\"fileOver($event)\"\r\n            >\r\n              <span class=\"icon-op-add\"></span>\r\n            </div>\r\n        <d-toast [value]=\"message\"></d-toast>\r\n      </d-form-control>\r\n    </d-form-item>\r\n  </ng-template>", styles: [".devui-add-images{width:80px;height:80px;cursor:pointer;position:relative;display:inline-block;margin-right:8px;margin-bottom:8px}.devui-add-images.devui-upload{border:1px dashed var(--devui-line, #adb0b8);border-radius:2px}.devui-add-images.devui-upload:hover{border-color:var(--devui-brand, #5e7ce0)}.devui-add-images.devui-upload:hover .icon-op-add{color:var(--devui-icon-fill-active, #5e7ce0)}.devui-add-images.devui-upload.devui-upload-dropover{border-color:var(--devui-brand, #5e7ce0)}.devui-add-images.devui-upload .icon-op-add{font-size:16px;color:var(--devui-icon-fill, #71757f);position:absolute;left:50%;top:50%;transform:translate(-50%,-50%)}.devui-add-images .devui-add-items{background-color:var(--devui-default-bg, #f7f8fa);width:100%;height:100%;border-radius:2px;border:1px solid var(--devui-line, #adb0b8);color:var(--devui-text, #252b3a)}.devui-add-images .devui-add-items>*{position:absolute;width:80%;left:50%;transform:translate(-50%)}.devui-add-images .devui-add-items span{text-align:center}.devui-add-images .devui-add-items .devui-cancel-upload{display:block;margin-top:8px}.devui-add-images .devui-add-items .devui-cancel-upload:hover{color:var(--devui-link, #526ecc)}.devui-add-images .devui-add-items .filename{overflow:hidden;white-space:nowrap;text-overflow:ellipsis;top:20%}.devui-add-images .devui-add-items .devui-loading{top:60%}.devui-add-images .devui-add-items .icon-file{top:20%;font-size:32px}.devui-add-images .devui-add-items.devui-upload-failed,.devui-add-images .devui-add-items.devui-upload-success{background-color:var(--devui-global-bg-normal, #ffffff)}.devui-add-images .devui-add-items.devui-upload-failed .filename,.devui-add-images .devui-add-items.devui-upload-success .filename{top:70%}.devui-add-images .devui-add-items.devui-upload-failed{border-color:var(--devui-danger-line, #f66f6a);color:var(--devui-danger, #f66f6a)}.devui-add-images .devui-add-items.devui-upload-failed .icon-file{color:var(--devui-danger-line, #f66f6a)}.devui-add-images .devui-add-items.devui-upload-success{border-color:var(--devui-success-line, #50d4ab);color:var(--devui-success, #50d4ab)}.devui-add-images .devui-add-items.devui-upload-success .icon-file{color:var(--devui-success-line, #50d4ab)}.devui-add-images .icon{font-size:18px;color:var(--devui-icon-bg, #ffffff);display:none;position:absolute;left:50%;top:50%;transform:translate(-50%,-50%)}.devui-add-images .icon.icon-running{left:35%}.devui-add-images .icon.devui-failed-icon{left:60%}.devui-add-images:hover .devui-upload-failed:before,.devui-add-images:hover .devui-upload-success:before{position:absolute;content:\"\";left:0;top:0;width:100%;height:100%;border:1px solid transparent;border-radius:2px;background-color:#000;opacity:.4;z-index:1}.devui-add-images:hover .devui-upload-failed+.icon-delete,.devui-add-images:hover .devui-upload-success+.icon-delete{display:block;z-index:2}.devui-add-images:hover .devui-upload-failed+.icon-delete+.icon-running,.devui-add-images:hover .devui-upload-success+.icon-delete+.icon-running{display:block;z-index:2}\n"], components: [{ type: FormBoxComponent, selector: "form-box", inputs: ["mainCarry", "name", "controltype", "additionalcss"], outputs: ["controlclick"] }, { type: i3.FormItemComponent, selector: "d-form-item", inputs: ["dFeedbackType", "dHasFeedback"] }, { type: i3.FormLabelComponent, selector: "d-form-label", inputs: ["required", "hasHelp", "helpTips"] }, { type: i3.FormControlComponent, selector: "d-form-control", inputs: ["extraInfo", "feedbackStatus", "suffixTemplate"] }, { type: i3.ProgressComponent, selector: "d-progress", inputs: ["percentage", "percentageText", "barbgcolor", "strokeColor", "height", "strokeWidth", "isCircle", "type", "showContent"] }, { type: i3.ToastComponent, selector: "d-toast", inputs: ["sticky", "life", "style", "styleClass", "lifeMode", "value"], outputs: ["closeEvent", "valueChange"] }], directives: [{ type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i4.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i3.UploadDirective, selector: "[dUpload]", inputs: ["uploadOptions", "fileOptions", "uploadedFiles", "fileUploaders", "enableDrop", "dynamicUploadOptionsFn", "beforeUpload"], outputs: ["fileOver", "fileDrop", "successEvent", "errorEvent", "alertMsgEvent", "fileSelect"], exportAs: ["dUpload"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormUploadComponent, decorators: [{
            type: Component,
            args: [{ selector: 'form-upload', template: "<ng-container *ngIf=\"data.mode=='op'; else detail\">\r\n    <form-box #box [mainCarry]=\"detail\" [name]=\"data.name\" [controltype]=\"data.controltype\" (controlclick)=\"onClick($event)\"></form-box>\r\n  </ng-container>\r\n  <ng-template #detail>\r\n      <d-form-item>\r\n        <d-form-label [required]=\"data.required\" [hasHelp]=\"data.help\" [helpTips]=\"data.helptip||''\">{{data.label}}</d-form-label>\r\n        <d-form-control>\r\n            <ng-container *ngIf=\"fileUploaders.length > 0\">\r\n              <div *ngFor=\"let fileUploader of fileUploaders\" class=\"devui-add-images\">\r\n                <div\r\n                  class=\"devui-add-items {{ fileUploader.status === 3 ? 'devui-upload-failed' : '' }} \r\n                  {{ fileUploader.status === 2 ? 'devui-upload-success' : '' }}\"\r\n                >\r\n                  <span class=\"filename\">{{ fileUploader.file.name }}</span>\r\n                  <div *ngIf=\"fileUploader.status === 1\" class=\"devui-loading\">\r\n                    <d-progress [percentage]=\"fileUploader.percentage\" [height]=\"'5px'\" [barbgcolor]=\"'#50D4AB'\"></d-progress>\r\n                    <span (click)=\"deleteFile(fileUploader)\" class=\"devui-cancel-upload\">{{ CANCELUPLOAD }}</span>\r\n                  </div>\r\n                  <span *ngIf=\"fileUploader.status === 2 || fileUploader.status === 3\" class=\"icon-file\"></span>\r\n                </div>\r\n                <span class=\"icon fc-icon icon-delete {{ fileUploader.status === 3 ? 'devui-failed-icon' : '' }}\" (click)=\"deleteFile(fileUploader)\"></span>\r\n                <span *ngIf=\"fileUploader.status === 3\" class=\"icon icon-running\" (click)=\"dUpload.uploadFiles()\"></span>\r\n              </div>\r\n            </ng-container>\r\n            <div\r\n              dUpload\r\n              #dUpload=\"dUpload\"\r\n              [attr.name] = \"data.controlname\"\r\n              class=\"devui-add-images devui-upload {{ isDropOver ? 'devui-upload-dropover' : '' }}\"\r\n              [enableDrop]=\"true\"\r\n              [fileOptions]=\"data.fileOptions\"\r\n              [uploadOptions]=\"data.uploadOptions\"\r\n              [uploadedFiles]=\"data.uploadedFiles\"\r\n              [fileUploaders]=\"fileUploaders\"\r\n              (alertMsgEvent)=\"alertMsg($event)\"\r\n              (fileDrop)=\"fileDrop($event)\"\r\n              (fileOver)=\"fileOver($event)\"\r\n            >\r\n              <span class=\"icon-op-add\"></span>\r\n            </div>\r\n        <d-toast [value]=\"message\"></d-toast>\r\n      </d-form-control>\r\n    </d-form-item>\r\n  </ng-template>", styles: [".devui-add-images{width:80px;height:80px;cursor:pointer;position:relative;display:inline-block;margin-right:8px;margin-bottom:8px}.devui-add-images.devui-upload{border:1px dashed var(--devui-line, #adb0b8);border-radius:2px}.devui-add-images.devui-upload:hover{border-color:var(--devui-brand, #5e7ce0)}.devui-add-images.devui-upload:hover .icon-op-add{color:var(--devui-icon-fill-active, #5e7ce0)}.devui-add-images.devui-upload.devui-upload-dropover{border-color:var(--devui-brand, #5e7ce0)}.devui-add-images.devui-upload .icon-op-add{font-size:16px;color:var(--devui-icon-fill, #71757f);position:absolute;left:50%;top:50%;transform:translate(-50%,-50%)}.devui-add-images .devui-add-items{background-color:var(--devui-default-bg, #f7f8fa);width:100%;height:100%;border-radius:2px;border:1px solid var(--devui-line, #adb0b8);color:var(--devui-text, #252b3a)}.devui-add-images .devui-add-items>*{position:absolute;width:80%;left:50%;transform:translate(-50%)}.devui-add-images .devui-add-items span{text-align:center}.devui-add-images .devui-add-items .devui-cancel-upload{display:block;margin-top:8px}.devui-add-images .devui-add-items .devui-cancel-upload:hover{color:var(--devui-link, #526ecc)}.devui-add-images .devui-add-items .filename{overflow:hidden;white-space:nowrap;text-overflow:ellipsis;top:20%}.devui-add-images .devui-add-items .devui-loading{top:60%}.devui-add-images .devui-add-items .icon-file{top:20%;font-size:32px}.devui-add-images .devui-add-items.devui-upload-failed,.devui-add-images .devui-add-items.devui-upload-success{background-color:var(--devui-global-bg-normal, #ffffff)}.devui-add-images .devui-add-items.devui-upload-failed .filename,.devui-add-images .devui-add-items.devui-upload-success .filename{top:70%}.devui-add-images .devui-add-items.devui-upload-failed{border-color:var(--devui-danger-line, #f66f6a);color:var(--devui-danger, #f66f6a)}.devui-add-images .devui-add-items.devui-upload-failed .icon-file{color:var(--devui-danger-line, #f66f6a)}.devui-add-images .devui-add-items.devui-upload-success{border-color:var(--devui-success-line, #50d4ab);color:var(--devui-success, #50d4ab)}.devui-add-images .devui-add-items.devui-upload-success .icon-file{color:var(--devui-success-line, #50d4ab)}.devui-add-images .icon{font-size:18px;color:var(--devui-icon-bg, #ffffff);display:none;position:absolute;left:50%;top:50%;transform:translate(-50%,-50%)}.devui-add-images .icon.icon-running{left:35%}.devui-add-images .icon.devui-failed-icon{left:60%}.devui-add-images:hover .devui-upload-failed:before,.devui-add-images:hover .devui-upload-success:before{position:absolute;content:\"\";left:0;top:0;width:100%;height:100%;border:1px solid transparent;border-radius:2px;background-color:#000;opacity:.4;z-index:1}.devui-add-images:hover .devui-upload-failed+.icon-delete,.devui-add-images:hover .devui-upload-success+.icon-delete{display:block;z-index:2}.devui-add-images:hover .devui-upload-failed+.icon-delete+.icon-running,.devui-add-images:hover .devui-upload-success+.icon-delete+.icon-running{display:block;z-index:2}\n"] }]
        }], ctorParameters: function () { return [{ type: CommonService }]; } });

window.JSHINT = JSHINT;
class FormCodeEditorComponent {
    constructor(elr) {
        this.elr = elr;
        this.options = {
            gutters: ['CodeMirror-lint-markers'],
            lineNumbers: true,
            lint: true,
            line: true,
            tabSize: 2,
            lineWrapping: true,
            theme: 'material',
            mode: 'application/json'
        };
        this.widgets = [];
    }
    ngOnInit() {
        this.content = js_beautify(this.data.code);
        this.parent = this.elr.nativeElement.parentElement;
    }
    close(e) {
        if (JSHINT(this.content)) {
            this.data.change(this.content);
            this.data.onClose(e);
        }
        else {
            this.showToast();
        }
    }
    showToast() {
        var output = "Check format error:\n\n";
        for (var i in JSHINT.errors) {
            var err = JSHINT.errors[i];
            if (null != err) {
                output += err.line + '[' + err.character + ']: ' + err.reason + '\n';
            }
            else {
                output += "Check format unknown error:\n";
            }
        }
        this.data.showerror([{ severity: 'warn', content: output }]);
    }
    cancel(e) {
        this.data.onClose(e);
    }
}
FormCodeEditorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormCodeEditorComponent, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component });
FormCodeEditorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormCodeEditorComponent, selector: "app-form-code-editor", inputs: { data: "data" }, viewQueries: [{ propertyName: "codeEditor", first: true, predicate: ["editor"], descendants: true }], ngImport: i0, template: "\r\n<div [dMovable]=\"true\" [handle]=\"header\" [moveEl]=\"parent\">\r\n  <div class=\"modal-header\" #header>\u7F16\u8F91\u6570\u636E</div>\r\n  <div class=\"modal-body\">\r\n    <ngx-codemirror #editor [(ngModel)]=\"content\" [options]=\"options\"></ngx-codemirror>\r\n  </div>\r\n  <div class=\"modal-footer\">\r\n    <d-button (click)=\"close($event)\" bsStyle=\"primary\" circled=\"true\">\u786E\u5B9A</d-button>\r\n    <d-button (click)=\"cancel($event)\" bsStyle=\"primary\" circled=\"true\">\u53D6\u6D88</d-button>\r\n  </div>\r\n  <i class=\"icon-close\" (click)=\"cancel($event)\"></i>\r\n</div>", styles: [".modal-header{line-height:30px;padding:20px 32px 0;font-size:var(--devui-font-size-modal-title, 18px);font-weight:700}.icon-close{position:absolute;top:20px;right:20px;font-size:var(--devui-font-size-icon, 16px);cursor:pointer}.icon-close:hover{background-color:var(--devui-list-item-hover-bg, #f2f5fc);color:var(--devui-icon-fill-active, #5e7ce0)}\n"], components: [{ type: i1$1.CodemirrorComponent, selector: "ngx-codemirror", inputs: ["className", "name", "autoFocus", "options", "preserveScrollPosition"], outputs: ["cursorActivity", "focusChange", "scroll", "drop"] }, { type: i3.ButtonComponent, selector: "d-button", inputs: ["id", "type", "bsStyle", "bsSize", "bsPosition", "bordered", "icon", "disabled", "showLoading", "width", "autofocus", "loadingTemplateRef"], outputs: ["btnClick"] }], directives: [{ type: i3.MovableDirective, selector: "[dMovable]", inputs: ["handle", "moveEl", "dMovable"] }, { type: i5.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i5.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormCodeEditorComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-form-code-editor', template: "\r\n<div [dMovable]=\"true\" [handle]=\"header\" [moveEl]=\"parent\">\r\n  <div class=\"modal-header\" #header>\u7F16\u8F91\u6570\u636E</div>\r\n  <div class=\"modal-body\">\r\n    <ngx-codemirror #editor [(ngModel)]=\"content\" [options]=\"options\"></ngx-codemirror>\r\n  </div>\r\n  <div class=\"modal-footer\">\r\n    <d-button (click)=\"close($event)\" bsStyle=\"primary\" circled=\"true\">\u786E\u5B9A</d-button>\r\n    <d-button (click)=\"cancel($event)\" bsStyle=\"primary\" circled=\"true\">\u53D6\u6D88</d-button>\r\n  </div>\r\n  <i class=\"icon-close\" (click)=\"cancel($event)\"></i>\r\n</div>", styles: [".modal-header{line-height:30px;padding:20px 32px 0;font-size:var(--devui-font-size-modal-title, 18px);font-weight:700}.icon-close{position:absolute;top:20px;right:20px;font-size:var(--devui-font-size-icon, 16px);cursor:pointer}.icon-close:hover{background-color:var(--devui-list-item-hover-bg, #f2f5fc);color:var(--devui-icon-fill-active, #5e7ce0)}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { data: [{
                type: Input
            }], codeEditor: [{
                type: ViewChild,
                args: ["editor", { static: false }]
            }] } });

class FormAttributeComponent {
    constructor(commonService, modalService) {
        this.commonService = commonService;
        this.modalService = modalService;
        this.controlType = ControlType;
        this.tab1acticeID = 'tab2';
        this.isDisable = true;
        this.layoutDirection = FormLayout.Vertical;
        this.alerttype = ["success", "danger", "warning", "info"];
        this.direction = ["row", "column"];
        this.datetype = ["date", "range"];
        this.dateFormat = ["y/MM/dd", 'y/MM/dd HH:mm:ss', 'y-MM-dd HH:mm:ss', 'yy.MM.dd HH:mm', 'MM/dd/y HH:mm:ss', 'MM/dd/yy HH:mm'];
        this.timeFormat = ['hh:mm:ss', 'mm:HH:SS', 'hh:mm', 'MM:ss'];
        this.alignFormat = [{ label: "居中", value: "is-center" }, { label: "居左", value: "is-left" }, { label: "居右", value: "is-right" }];
        this.responseType = ["arraybuffer", "blob", "json", "text"];
        this.validatorType = ["请选择", "required", "minlength", "maxlength", "min", "max", "email", "pattern", "whitespace"];
        this.validators = [];
        this.msgs = [];
        this.layoutOptions = [
            {
                value: "horizontal",
                name: "水平布局"
            },
            {
                value: "vertical",
                name: "垂直布局"
            },
            {
                value: "columns",
                name: "纵列布局"
            },
        ];
        this.labelSizeOptions = [
            {
                value: "sm",
                name: "小号"
            },
            {
                value: "",
                name: "中等"
            },
            {
                value: "lg",
                name: "大号"
            },
        ];
        this.labelAlignOptions = [
            {
                value: "start",
                name: "左对齐"
            },
            {
                value: "center",
                name: "居中"
            },
            {
                value: "end",
                name: "右对齐"
            },
        ];
        this.methodtype = ["GET", "POST", "PUT", "DELETE"];
        this.canvasInfo = {
            layout: this.layoutOptions[1],
            labelSize: this.labelSizeOptions[1],
            labelAlign: this.labelAlignOptions[0]
        };
    }
    ngOnInit() {
        this.commonService.attiEvent.subscribe(o => {
            this.formData = o;
            this.validators = [];
            if (o && o.itemselected && o.controltype != ControlType.Row) {
                this.tab1acticeID = "tab1";
                this.isDisable = false;
                this.activeLayout = o.controltype;
                const rules = o.rules;
                if (rules && rules.validators && rules.validators.length > 0) {
                    for (let index = 0; index < rules.validators.length; index++) {
                        const key = Object.keys(rules.validators[index])[0];
                        const value = Object.values(rules.validators[index])[0];
                        this.validators.push({
                            validatortype: { label: key, disabled: false },
                            oldvalidatortype: "请选择",
                            value: value,
                            validatorOptions: this.validatorType.filter(x => this.showOptions(x)).map(x => {
                                return { label: x, disabled: false };
                            })
                        });
                    }
                }
                else {
                    this.validators.push({
                        validatortype: { label: "请选择", disabled: false }, oldvalidatortype: "请选择", validatorOptions: this.validatorType.filter(x => this.showOptions(x)).map(o => {
                            return { label: o, disabled: false };
                        })
                    });
                }
            }
            else {
                this.tab1acticeID = "tab2";
                this.activeLayout = null;
                this.isDisable = true;
            }
        });
        this.commonService.removeItemClickObservable.subscribe(() => {
            this.activeLayout = null;
            this.tab1acticeID = "tab2";
            this.isDisable = true;
        });
    }
    onchange() {
        this.commonService.changeFormLayout.emit({
            layout: this.canvasInfo.layout.value,
            labelSize: this.canvasInfo.labelSize.value,
            labelAlign: this.canvasInfo.labelAlign.value
        });
    }
    showCodeEditor(setValue, type) {
        const results = this.modalService.open({
            id: 'dialog-service',
            width: '650px',
            component: FormCodeEditorComponent,
            backdropCloseable: true,
            data: {
                code: JSON.stringify(setValue),
                onClose: (event) => {
                    results.modalInstance.hide();
                },
                showerror: (o) => { this.msgs = o; },
                change: (o) => {
                    switch (type) {
                        case "options":
                            this.formData.options = JSON.parse(o);
                            break;
                        case "postdata.data":
                            this.formData.postdata.data = JSON.parse(o);
                            break;
                        case "postdata.head":
                            this.formData.postdata.head = JSON.parse(o);
                            break;
                        case "uploadOptions.additionalParameter":
                            this.formData.uploadOptions.additionalParameter = JSON.parse(o);
                            break;
                        case "uploadOptions.headers":
                            this.formData.uploadOptions.headers = JSON.parse(o);
                            break;
                        default:
                            break;
                    }
                }
            }
        });
    }
    onTestData(e) {
        this.commonService.testEvent.emit(e);
    }
    onChangeDateTypeOrFormat() {
        if (this.formData.datetype == "date") {
            this.formData.placeholder = this.formData.dateFormat;
        }
        else {
            this.formData.placeholder = this.formData.dateFormat + " - " + this.formData.dateFormat;
        }
        this.formData.defaultvalue = "";
    }
    onChangeTimeFormat() {
        this.formData.placeholder = this.formData.format;
    }
    onChangeAlignFormat(e) {
        this.formData.align = e.value;
    }
    onAddValidationRule() {
        var options = this.validatorType.filter(x => this.showOptions(x)).map(o => {
            var isDisabled = false;
            for (let index = 0; index < this.validators.length; index++) {
                const element = this.validators[index].validatortype;
                if (element.label == o && element.label != "请选择") {
                    isDisabled = true;
                    break;
                }
            }
            return { label: o, disabled: isDisabled };
        });
        this.validators.push({ validatortype: { label: "请选择", disabled: false }, oldvalidatortype: "请选择", validatorOptions: options });
    }
    onRemoveRule(value) {
        const rule = this.validators.splice(value, 1);
        if (rule[0].validatortype.label != "请选择") {
            this.changeOption(o => {
                var returnValue = false;
                if (o.label == rule[0].validatortype.label) {
                    o.disabled = false;
                    returnValue = true;
                }
                return returnValue;
            });
        }
    }
    onChangeItem(value, item) {
        switch (value.label) {
            case "required":
            case "email":
            case "whitespace":
                item["value"] = true;
                break;
            case "minlength":
            case "maxlength":
            case "min":
            case "max":
                item["value"] = 0;
                break;
            default:
                item["value"] = "";
                break;
        }
        this.changeTheValidateRules(item, value.label);
        this.changeOption(o => {
            if (o.label == value.label && o.label != "请选择") {
                o.disabled = true;
            }
            if (o.label == item["oldvalidatortype"]) {
                o.disabled = false;
            }
            return false;
        });
        item["oldvalidatortype"] = value.label;
    }
    onChangeValidateValue(item) {
        this.changeTheValidateRules(item, item.validatortype.label);
    }
    changeOption(fn) {
        for (let i = 0; i < this.validators.length; i++) {
            const options = this.validators[i].validatorOptions;
            for (let j = 0; j < options.length; j++) {
                const element = options[j];
                if (fn(element)) {
                    break;
                }
            }
        }
    }
    changeTheValidateRules(item, value) {
        const rules = this.formData.rules.validators;
        if (item["oldvalidatortype"] != "请选择" && value != "请选择") {
            const rule = this.findRule(item);
            delete rule[item["oldvalidatortype"]];
            if (value == "pattern") {
                rule[value] = new RegExp(item["value"]);
            }
            else {
                rule[value] = item["value"];
            }
        }
        else if (value != "请选择" && item["oldvalidatortype"] == "请选择") {
            var obj = Object.create(null);
            if (value == "pattern") {
                obj[value] = new RegExp(item["value"]);
            }
            else {
                obj[value] = item["value"];
            }
            rules.push(obj);
        }
        else {
            var index = 0;
            this.findRule(item, o => {
                index = o;
            });
            if (index == 0) {
                rules.splice(-1, 1);
            }
            else {
                rules.splice(index, 1);
            }
        }
    }
    showOptions(option) {
        switch (this.activeLayout) {
            case ControlType.Input:
                return true;
            case ControlType.Select:
                return option == "required" || option == "min" || option == "max" || option == "请选择";
            default:
                return option == "required" || option == "请选择";
        }
    }
    findRule(item, fn = null) {
        const rules = this.formData.rules.validators;
        var rule = {};
        for (let index = 0; index < rules.length; index++) {
            const element = rules[index];
            if (Object.hasOwnProperty.bind(element)(item["oldvalidatortype"])) {
                rule = element;
                if (fn != null) {
                    fn(index);
                }
                break;
            }
        }
        return rule;
    }
}
FormAttributeComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormAttributeComponent, deps: [{ token: CommonService }, { token: i3.ModalService }], target: i0.ɵɵFactoryTarget.Component });
FormAttributeComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormAttributeComponent, selector: " form-attribute", ngImport: i0, template: "<section class=\"space\">\r\n    <d-toast [value]=\"msgs\"></d-toast>\r\n    <d-tabs [(activeTab)]=\"tab1acticeID\"  class=\"tabcenter\">\r\n        <d-tab id=\"tab1\" title=\"\u63A7\u4EF6\u5C5E\u6027\" tabId=\"tab1\" [disabled]=\"isDisable\">\r\n          <ng-template dTabContent>\r\n            <ng-container [ngSwitch]=\"activeLayout\">\r\n              <ng-container *ngSwitchCase=\"controlType.Input\" [ngTemplateOutlet]=\"input\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.RichIput\" [ngTemplateOutlet]=\"richinput\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Counter\" [ngTemplateOutlet]=\"counter\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Toggle\" [ngTemplateOutlet]=\"toggle\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Select\" [ngTemplateOutlet]=\"select\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Alert\" [ngTemplateOutlet]=\"alert\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Check\" [ngTemplateOutlet]=\"check\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Radio\" [ngTemplateOutlet]=\"radio\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Date\" [ngTemplateOutlet]=\"date\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Time\" [ngTemplateOutlet]=\"time\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Rate\" [ngTemplateOutlet]=\"rate\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Space\" [ngTemplateOutlet]=\"space\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Divider\" [ngTemplateOutlet]=\"divider\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Upload\" [ngTemplateOutlet]=\"upload\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Slide\" [ngTemplateOutlet]=\"slide\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Transfer\" [ngTemplateOutlet]=\"transfer\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Tree\" [ngTemplateOutlet]=\"tree\"></ng-container>\r\n              <ng-container *ngSwitchDefault></ng-container>\r\n            </ng-container>\r\n          </ng-template>\r\n        </d-tab>\r\n    \r\n        <d-tab id=\"tab2\" title=\"\u8868\u5355\u5C5E\u6027\" tabId=\"tab2\">\r\n          <ng-template dTabContent>\r\n            <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n              <d-form-item>\r\n                <d-form-label>\u8868\u5355\u5E03\u5C40</d-form-label>\r\n                <d-form-control>\r\n                  <d-select [options]=\"layoutOptions\" name=\"layout\" [filterKey]=\"'name'\" [(ngModel)]=\"canvasInfo.layout\" (valueChange)=\"onchange()\"></d-select>\r\n                </d-form-control>\r\n              </d-form-item>\r\n              <d-form-item>\r\n                <d-form-label>label\u5360\u5BBD</d-form-label>\r\n                <d-form-control>\r\n                  <d-select [options]=\"labelSizeOptions\" name=\"labelSize\" [filterKey]=\"'name'\" [(ngModel)]=\"canvasInfo.labelSize\" (valueChange)=\"onchange()\"></d-select>\r\n                </d-form-control>\r\n              </d-form-item>\r\n              <d-form-item>\r\n                <d-form-label>label\u5BF9\u9F50</d-form-label>\r\n                <d-form-control>\r\n                  <d-select [options]=\"labelAlignOptions\" name=\"labelAlign\" [filterKey]=\"'name'\" [(ngModel)]=\"canvasInfo.labelAlign\" (valueChange)=\"onchange()\"></d-select>\r\n                </d-form-control>\r\n              </d-form-item>\r\n            </form>\r\n          </ng-template>\r\n        </d-tab>\r\n    </d-tabs>\r\n</section>\r\n<ng-template #common>\r\n  <d-form-item>\r\n    <d-form-label>\u6807\u7B7E\u540D</d-form-label>\r\n    <d-form-control>\r\n      <input dTextInput name=\"labelName\" [(ngModel)]=\"formData.label\"/>\r\n    </d-form-control>\r\n  </d-form-item>\r\n  <d-form-item>\r\n    <d-form-label>\u63A7\u4EF6\u540D\u79F0</d-form-label>\r\n    <d-form-control>\r\n      <input dTextInput name=\"controlName\" [(ngModel)]=\"formData.controlname\"/>\r\n    </d-form-control>\r\n  </d-form-item>\r\n  <d-form-item>\r\n    <d-row>\r\n      <d-col [dSpan]=\"12\">\r\n        <d-form-label>\u662F\u5426\u7981\u7528</d-form-label>\r\n      <d-form-control>\r\n        <d-toggle name=\"disabled\" [(ngModel)]=\"formData.disabled\"></d-toggle>\r\n      </d-form-control>\r\n      </d-col>\r\n      <d-col [dSpan]=\"12\">\r\n        <d-form-label>\u662F\u5426\u5FC5\u586B</d-form-label>\r\n        <d-form-control>\r\n          <d-toggle name=\"required\" [(ngModel)]=\"formData.required\"></d-toggle>\r\n        </d-form-control>\r\n      </d-col>\r\n    </d-row>\r\n  </d-form-item>\r\n  <d-form-item>\r\n    <d-form-label>\u662F\u5426\u5E2E\u52A9</d-form-label>\r\n    <d-form-control>\r\n      <d-toggle name=\"help\" [(ngModel)]=\"formData.help\"></d-toggle>\r\n    </d-form-control>\r\n  </d-form-item>\r\n  <d-form-item *ngIf=\"formData.help\">\r\n    <d-form-label>\u5E2E\u52A9\u6587\u672C</d-form-label>\r\n    <d-form-control>\r\n      <input dTextInput name=\"helptip\" [(ngModel)]=\"formData.helptip\" />\r\n    </d-form-control>\r\n  </d-form-item>\r\n</ng-template>\r\n\r\n<ng-template #input>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <d-form-item>\r\n      <d-form-label>\u9ED8\u8BA4\u503C</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"defaultName\" [(ngModel)]=\"formData.defaultvalue\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u5360\u4F4D\u6587\u672C</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"placeholder\" [(ngModel)]=\"formData.placeholder\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n    <ng-container [ngTemplateOutlet]=\"validator\">\r\n    </ng-container>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #transfer>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <d-form-item>\r\n      <d-form-label>\u6E90\u5934\u6807\u9898</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"source\" [(ngModel)]=\"formData.source\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u76EE\u6807\u6807\u9898</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"target\" [(ngModel)]=\"formData.target\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n    <ng-container [ngTemplateOutlet]=\"data\">\r\n    </ng-container>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #tree>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <d-form-item>\r\n      <d-form-label>\u5360\u4F4D\u6587\u672C</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"placeholder\" [(ngModel)]=\"formData.placeholder\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n    <ng-container [ngTemplateOutlet]=\"data\">\r\n    </ng-container>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #richinput>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <d-form-item>\r\n      <d-form-label>\u9ED8\u8BA4\u503C</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"defaultName\" [(ngModel)]=\"formData.defaultvalue\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #counter>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <d-form-item>\r\n      <d-form-label>\u9ED8\u8BA4\u503C</d-form-label>\r\n      <d-form-control>\r\n        <d-input-number name=\"defaultName\" [step]=\"1\" [(ngModel)]=\"formData.defaultvalue\"></d-input-number>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n    <d-form-item>\r\n      <d-row>\r\n        <d-col [dSpan]=\"12\">\r\n          <d-form-label>\u6700\u5C0F\u503C</d-form-label>\r\n          <d-form-control>\r\n            <d-input-number name=\"min\" [step]=\"1\" [(ngModel)]=\"formData.min\"></d-input-number>\r\n          </d-form-control>\r\n        </d-col>\r\n        <d-col [dSpan]=\"12\">\r\n          <d-form-label>\u6700\u5927\u503C</d-form-label>\r\n            <d-form-control>\r\n            <d-input-number name=\"max\" [step]=\"1\" [(ngModel)]=\"formData.max\"></d-input-number>\r\n          </d-form-control>\r\n        </d-col>\r\n      </d-row>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-row>\r\n        <d-col [dSpan]=\"12\">\r\n          <d-form-label>\u6B65\u957F</d-form-label>\r\n          <d-form-control>\r\n            <d-input-number name=\"step\" [step]=\"1\" [(ngModel)]=\"formData.step\"></d-input-number>\r\n          </d-form-control>\r\n        </d-col>\r\n        <d-col [dSpan]=\"12\">\r\n          <d-form-label>\u5355\u4F4D</d-form-label>\r\n          <d-form-control>\r\n            <input dTextInput name=\"unit\" [(ngModel)]=\"formData.unit\"/>\r\n          </d-form-control>\r\n        </d-col>\r\n      </d-row>\r\n    </d-form-item>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #toggle>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <d-form-item>\r\n      <d-form-label>\u9ED8\u8BA4\u503C</d-form-label>\r\n      <d-form-control>\r\n        <d-toggle name=\"defaultName\" [(ngModel)]=\"formData.defaultvalue\"></d-toggle>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #select>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <!-- <d-form-item>\r\n      <d-form-label>\u9ED8\u8BA4\u503C</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"defaultName\" [(ngModel)]=\"formData.defaultvalue\" />\r\n      </d-form-control>\r\n    </d-form-item> -->\r\n    <d-form-item>\r\n      <d-form-label>\u5360\u4F4D\u6587\u672C</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"placeholder\" [(ngModel)]=\"formData.placeholder\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n    <d-form-item>\r\n      <d-form-label>\u663E\u793A\u5B57\u6BB5</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"filter\" [(ngModel)]=\"formData.filter\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"data\">\r\n    </ng-container>\r\n    <d-form-item>\r\n      <d-form-label>\u662F\u5426\u591A\u9009</d-form-label>\r\n      <d-form-control>\r\n        <d-toggle name=\"multiple\" [(ngModel)]=\"formData.multiple\"></d-toggle>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"validator\">\r\n    </ng-container>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #data>\r\n  <d-form-item>\r\n    <d-form-label>\u6570\u636E\u9009\u9879</d-form-label>\r\n    <d-form-control>\r\n      <d-tabs [(activeTab)]=\"formData.dataType\" type=\"options\" customWidth=\"100px\">\r\n        <d-tab [id]=\"'static'\" title=\"\u9759\u6001\u6570\u636E\">\r\n          <ng-template dTabContent>\r\n            <d-button bsStyle=\"common\" style=\"margin-right: 8px;width: 100%;\" width=\"100%\" (btnClick)=\"showCodeEditor(formData.options,'options')\" >\u7F16\u8F91\u6570\u636E</d-button>\r\n          </ng-template>\r\n        </d-tab>\r\n        <d-tab [id]=\"'interface'\" title=\"\u63A5\u53E3\u6570\u636E\">\r\n          <ng-template dTabContent>\r\n            <div class=\"tabshow\">\r\n              <d-form-item>\r\n                <d-form-label>\u63A5\u53E3</d-form-label>\r\n                <d-form-control>\r\n                  <input dTextInput name=\"url\" [(ngModel)]=\"formData.postdata.url\" />\r\n                </d-form-control>\r\n              </d-form-item>\r\n              <d-form-item>\r\n                <d-form-label>\u8BF7\u6C42\u65B9\u5F0F</d-form-label>\r\n                <d-form-control>\r\n                  <d-select name=\"method\" [placeholder]=\"'\u8BF7\u9009\u62E9'\" [options]=\"methodtype\" [(ngModel)]=\"formData.postdata.method\"></d-select>\r\n                </d-form-control>\r\n              </d-form-item>\r\n              <d-form-item>\r\n                <d-form-label>\u9644\u5E26\u6570\u636E</d-form-label>\r\n                <d-form-control>\r\n                  <d-button bsStyle=\"common\" style=\"margin-right: 8px;width: 100%;\" width=\"100%\" (btnClick)=\"showCodeEditor(formData.postdata.data,'postdata.data')\" >\u7F16\u8F91\u6570\u636E</d-button>\r\n                </d-form-control>\r\n              </d-form-item>\r\n              <d-form-item>\r\n                <d-form-label>\u5934\u90E8\u4FE1\u606F</d-form-label>\r\n                <d-form-control>\r\n                  <d-button bsStyle=\"common\" style=\"margin-right: 8px;width: 100%;\" width=\"100%\" (btnClick)=\"showCodeEditor(formData.postdata.head,'postdata.head')\" >\u7F16\u8F91\u6570\u636E</d-button>\r\n                </d-form-control>\r\n              </d-form-item>\r\n              <d-form-item *ngIf=\"formData.controltype != controlType.Tree\">\r\n                <d-form-label>\u89E3\u6790\u51FD\u6570</d-form-label>\r\n                <d-form-control>\r\n                  <textarea dTextarea placeholder=\"\u8BF7\u8F93\u5165\" name=\"function\" [(ngModel)]=\"formData.postdata.function\"></textarea>\r\n                </d-form-control>\r\n              </d-form-item>\r\n              <d-form-item>\r\n                <d-form-control>\r\n                  <d-button bsStyle=\"common\" style=\"margin-right: 8px;width: 100%;\" width=\"100%\" (btnClick)=\"onTestData(formData.name)\">\u8F7D\u5165\u6570\u636E</d-button>\r\n                </d-form-control>\r\n              </d-form-item>\r\n            </div>\r\n          </ng-template>\r\n        </d-tab>\r\n      </d-tabs>\r\n    </d-form-control>\r\n  </d-form-item>\r\n</ng-template>\r\n\r\n<ng-template #alert>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <d-form-item>\r\n      <d-form-label>\u663E\u793A\u503C</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"label\" [(ngModel)]=\"formData.label\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u8B66\u544A\u7C7B\u578B</d-form-label>\r\n      <d-form-control>\r\n        <d-select [options]=\"alerttype\" name=\"alerttype\" [(ngModel)]=\"formData.alerttype\"></d-select>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u662F\u5426\u5173\u95ED</d-form-label>\r\n      <d-form-control>\r\n        <d-toggle name=\"closeable\" [(ngModel)]=\"formData.closeable\"></d-toggle>\r\n      </d-form-control>\r\n    </d-form-item>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #check>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n    <d-form-item>\r\n      <d-form-label>\u663E\u793A\u65B9\u5411</d-form-label>\r\n      <d-form-control>\r\n        <d-select [options]=\"direction\" name=\"direction\" [(ngModel)]=\"formData.direction\"></d-select>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u663E\u793A\u6807\u9898</d-form-label>\r\n      <d-form-control>\r\n        <d-toggle name=\"isshowtitle\" [(ngModel)]=\"formData.isshowtitle\"></d-toggle>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u663E\u793A\u5B57\u6BB5</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"filter\" [(ngModel)]=\"formData.filter\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"data\">\r\n    </ng-container>\r\n    <ng-container [ngTemplateOutlet]=\"validator\">\r\n    </ng-container>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #radio>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n    <d-form-item>\r\n      <d-form-label>\u663E\u793A\u65B9\u5411</d-form-label>\r\n      <d-form-control>\r\n        <d-select [options]=\"direction\" name=\"direction\" [(ngModel)]=\"formData.direction\"></d-select>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"data\">\r\n    </ng-container>\r\n    <ng-container [ngTemplateOutlet]=\"validator\">\r\n    </ng-container>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #date>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n    <d-form-item>\r\n      <d-form-label>\u65E5\u671F\u7C7B\u578B</d-form-label>\r\n      <d-form-control>\r\n        <d-select [options]=\"datetype\" name=\"datetype\" [(ngModel)]=\"formData.datetype\" (valueChange)=\"onChangeDateTypeOrFormat()\"></d-select>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u65E5\u671F\u683C\u5F0F</d-form-label>\r\n      <d-form-control>\r\n        <d-select [options]=\"dateFormat\" name=\"dateFormat\" [(ngModel)]=\"formData.dateFormat\" (valueChange)=\"onChangeDateTypeOrFormat()\"></d-select>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u662F\u5426\u663E\u793A\u65F6\u95F4</d-form-label>\r\n      <d-form-control>\r\n        <d-toggle name=\"showtime\" [(ngModel)]=\"formData.showtime\"></d-toggle>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"validator\">\r\n    </ng-container>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #time>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n    <d-form-item>\r\n      <d-form-label>\u65E5\u671F\u683C\u5F0F</d-form-label>\r\n      <d-form-control>\r\n        <d-select [options]=\"timeFormat\" name=\"format\" [(ngModel)]=\"formData.format\" (valueChange)=\"onChangeTimeFormat()\"></d-select>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"validator\">\r\n    </ng-container>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #rate>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <d-form-item>\r\n      <d-form-label>\u9ED8\u8BA4\u503C</d-form-label>\r\n      <d-form-control>\r\n        <d-input-number name=\"defaultName\" [step]=\"1\" [(ngModel)]=\"formData.defaultvalue\"></d-input-number>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n    <d-form-item>\r\n      <d-form-label>\u662F\u5426\u534A\u503C</d-form-label>\r\n      <d-form-control>\r\n        <d-toggle name=\"allowhalf\" [(ngModel)]=\"formData.allowhalf\"></d-toggle>\r\n      </d-form-control>\r\n    </d-form-item>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #space>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <d-form-item>\r\n      <d-form-label>\u9AD8\u5EA6</d-form-label>\r\n      <d-form-control>\r\n        <d-input-number name=\"height\" [step]=\"1\" [(ngModel)]=\"formData.height\"></d-input-number>\r\n      </d-form-control>\r\n    </d-form-item>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #divider>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <d-form-item>\r\n      <d-form-label>\u663E\u793A\u6587\u672C</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"label\" [(ngModel)]=\"formData.label\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u6587\u672C\u4F4D\u7F6E</d-form-label>\r\n      <d-form-control>\r\n        <d-select [options]=\"alignFormat\"[(ngModel)]=\"formData.alignvalue\" name=\"align\" [filterKey]=\"'label'\" (valueChange)=\"onChangeAlignFormat($event)\"></d-select>\r\n      </d-form-control>\r\n    </d-form-item>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #upload>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n    <d-form-item>\r\n      <d-form-label>\u63A5\u53E3</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"url\" [(ngModel)]=\"formData.uploadOptions.uri\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u8BF7\u6C42\u65B9\u5F0F</d-form-label>\r\n      <d-form-control>\r\n        <d-select name=\"method\" [placeholder]=\"'\u8BF7\u9009\u62E9'\" [options]=\"methodtype\" [(ngModel)]=\"formData.uploadOptions.method\"></d-select>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u9644\u5E26\u6570\u636E</d-form-label>\r\n      <d-form-control>\r\n        <d-button bsStyle=\"common\" style=\"margin-right: 8px;width: 100%;\" width=\"100%\" (btnClick)=\"showCodeEditor(formData.uploadOptions.additionalParameter,'uploadOptions.additionalParameter')\" >\u7F16\u8F91\u6570\u636E</d-button>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u5934\u90E8\u4FE1\u606F</d-form-label>\r\n      <d-form-control>\r\n        <d-button bsStyle=\"common\" style=\"margin-right: 8px;width: 100%;\" width=\"100%\" (btnClick)=\"showCodeEditor(formData.uploadOptions.headers,'uploadOptions.headers')\" >\u7F16\u8F91\u6570\u636E</d-button>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u4E0A\u4F20\u6587\u4EF6\u5927\u5C0F\u9650\u5236</d-form-label>\r\n      <d-form-control>\r\n        <d-input-number name=\"maximumSize\" [step]=\"1\" [(ngModel)]=\"formData.uploadOptions.maximumSize\"></d-input-number>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u6587\u4EF6\u540D\u79F0</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"fileFieldName\" [(ngModel)]=\"formData.uploadOptions.fileFieldName\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u8FD4\u56DE\u6570\u636E\u7C7B\u578B</d-form-label>\r\n      <d-form-control>\r\n        <d-select [options]=\"responseType\" name=\"responseType\" [(ngModel)]=\"formData.uploadOptions.responseType\"></d-select>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u6587\u4EF6\u7C7B\u578B</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"accept\" [(ngModel)]=\"formData.fileOptions.accept\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u53EF\u9009\u62E9\u591A\u4E2A\u503C</d-form-label>\r\n      <d-form-control>\r\n        <d-toggle name=\"multiple\" [(ngModel)]=\"formData.fileOptions.multiple\"></d-toggle>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"validator\">\r\n    </ng-container>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #validator>\r\n  <d-form-item style=\"margin: 0px;\">\r\n    <d-form-control>\r\n      <div class=\"form-divider form-divider-horizontal\">\r\n          <div class=\"form-divider__text is-center\">\u63A7\u4EF6\u9A8C\u8BC1</div>\r\n      </div>\r\n    </d-form-control>\r\n  </d-form-item>\r\n  <d-form-item>\r\n    <d-row *ngFor=\"let validator of validators;index as i;\">\r\n      <d-col [dSpan]=\"8\" style=\"padding-right: 3px;\">\r\n        <d-form-label>\u9A8C\u8BC1\u7C7B\u578B</d-form-label>\r\n        <d-form-control>\r\n          <d-select name=\"validatortype\" \r\n          (valueChange)=\"onChangeItem($event,validator)\" \r\n          [placeholder]=\"'\u8BF7\u9009\u62E9'\" \r\n          [filterKey]=\"'label'\" \r\n          [optionDisabledKey]=\"'disabled'\" \r\n          [options]=\"validator.validatorOptions\" \r\n          [(ngModel)]=\"validator.validatortype\"></d-select>\r\n        </d-form-control>\r\n      </d-col>\r\n      <d-col [dSpan]=\"12\">\r\n        <d-form-label>\u503C</d-form-label>\r\n        <d-form-control>\r\n          <ng-container [ngSwitch]=\"validator.validatortype.label\">\r\n            <ng-container *ngSwitchCase=\"'required'\" [ngTemplateOutlet]=\"required\"></ng-container>\r\n            <ng-container *ngSwitchCase=\"'email'\" [ngTemplateOutlet]=\"required\"></ng-container>\r\n            <ng-container *ngSwitchCase=\"'whitespace'\" [ngTemplateOutlet]=\"required\"></ng-container>\r\n            <ng-container *ngSwitchCase=\"'pattern'\" [ngTemplateOutlet]=\"pattern\"></ng-container>\r\n            <ng-container *ngSwitchCase=\"'minlength'\">\r\n              <ng-container *ngTemplateOutlet=\"num; context:{$implicit:5,max:128};\">\r\n              </ng-container>\r\n            </ng-container>\r\n            <ng-container *ngSwitchCase=\"'maxlength'\">\r\n              <ng-container *ngTemplateOutlet=\"num; context:{$implicit:5,max:128};\">\r\n              </ng-container>\r\n            </ng-container>\r\n            <ng-container *ngSwitchCase=\"'min'\">\r\n              <ng-container *ngTemplateOutlet=\"num; context:{$implicit:0,max:100};\">\r\n              </ng-container>\r\n            </ng-container>\r\n            <ng-container *ngSwitchCase=\"'max'\">\r\n              <ng-container *ngTemplateOutlet=\"num; context:{$implicit:0,max:100};\">\r\n              </ng-container>\r\n            </ng-container>\r\n            <ng-container *ngSwitchDefault></ng-container>\r\n          </ng-container>\r\n          <ng-template #pattern>\r\n            <input dTextInput name=\"value\" [(ngModel)]=\"validator.value\" (change)=\"onChangeValidateValue(validator)\"/>\r\n          </ng-template>\r\n          <ng-template #required>\r\n            <div style=\"padding-top: 3px;\">\r\n              <d-toggle [color]=\"'#50D4AB'\" [disabled]=\"true\"  [(ngModel)]=\"validator.value\" [checkedContent]=\"iconCheckedContent\" [uncheckedContent]=\"iconUncheckedContent\"></d-toggle>\r\n              <ng-template #iconCheckedContent>\r\n                <div class=\"toggle-inner\">\r\n                  <i class=\"icon-right\"></i>\r\n                </div>\r\n              </ng-template>\r\n              <ng-template #iconUncheckedContent>\r\n                <div class=\"toggle-inner\">\r\n                  <i class=\"icon-error\"></i>\r\n                </div>\r\n              </ng-template>\r\n            </div>\r\n          </ng-template>\r\n          <ng-template #num let-min let-max =\"max\">\r\n            <d-input-number name=\"height\" [min]=\"min\" [max]=\"max\" [step]=\"1\" style=\"width: 100%;\" [(ngModel)]=\"validator.value\" (ngModelChange)=\"onChangeValidateValue(validator)\"></d-input-number>\r\n          </ng-template>\r\n        </d-form-control>\r\n      </d-col>\r\n      <d-col [dSpan]=\"4\">\r\n        <div class=\"btn-group\">\r\n          <d-button icon=\"fc-icon icon-add icon-font\" bsStyle=\"text-dark\" title=\"\u6DFB\u52A0\" width=\"21px\" (btnClick)=\"onAddValidationRule()\"></d-button>\r\n          <d-button icon=\"fc-icon icon-delete icon-font\" bsStyle=\"text-dark\" [disabled]=\"validators.length==1\" title=\"\u5220\u9664\" width=\"22px\" (btnClick)=\"onRemoveRule(i)\"></d-button>\r\n        </div>\r\n      </d-col>\r\n    </d-row>\r\n  </d-form-item>\r\n</ng-template>\r\n\r\n<ng-template #slide>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <d-form-item>\r\n      <d-form-label>\u9ED8\u8BA4\u503C</d-form-label>\r\n      <d-form-control>\r\n        <d-input-number name=\"defaultName\" [step]=\"1\" [(ngModel)]=\"formData.defaultvalue\"></d-input-number>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n    <d-form-item>\r\n      <d-row>\r\n        <d-col [dSpan]=\"12\">\r\n          <d-form-label>\u6700\u5C0F\u503C</d-form-label>\r\n          <d-form-control>\r\n            <d-input-number name=\"min\" [step]=\"1\" [(ngModel)]=\"formData.min\"></d-input-number>\r\n          </d-form-control>\r\n        </d-col>\r\n        <d-col [dSpan]=\"12\">\r\n          <d-form-label>\u6700\u5927\u503C</d-form-label>\r\n            <d-form-control>\r\n            <d-input-number name=\"max\" [step]=\"1\" [(ngModel)]=\"formData.max\"></d-input-number>\r\n          </d-form-control>\r\n        </d-col>\r\n      </d-row>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u6B65\u957F</d-form-label>\r\n      <d-form-control>\r\n        <d-input-number name=\"step\" [step]=\"1\" [(ngModel)]=\"formData.step\"></d-input-number>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"validator\">\r\n    </ng-container>\r\n  </form>\r\n</ng-template>", styles: [".space{width:100%;padding:0 10px 10px}:host form{width:330px;padding:0 10px}.tabshow{border:2px solid var(--devui-brand, #5e7ce0);padding:5px}:host ::ng-deep section>d-tabs>ul{position:sticky;padding-top:10px;background:#fff!important;top:0;z-index:16}:host ::ng-deep .btn-group d-button .icon-font{font-size:16px}.btn-group{margin-top:18px}.form-divider{background-color:#dcdfe6;position:relative}.form-divider-horizontal{display:block;height:1px;width:100%;margin:24px 0}.form-divider__text{position:absolute;background-color:#fff;padding:0 20px;color:#303133}.form-divider__text.is-center{left:50%;transform:translate(-50%) translateY(-50%)}\n"], components: [{ type: i3.ToastComponent, selector: "d-toast", inputs: ["sticky", "life", "style", "styleClass", "lifeMode", "value"], outputs: ["closeEvent", "valueChange"] }, { type: i3.TabsComponent, selector: "d-tabs", inputs: ["type", "showContent", "activeTab", "vertical", "cssClass", "customWidth", "beforeChange", "reactivable"], outputs: ["activeTabChange"], exportAs: ["tabs"] }, { type: i3.TabComponent, selector: "d-tab", inputs: ["tabId", "id", "title", "disabled"] }, { type: i3.FormItemComponent, selector: "d-form-item", inputs: ["dFeedbackType", "dHasFeedback"] }, { type: i3.FormLabelComponent, selector: "d-form-label", inputs: ["required", "hasHelp", "helpTips"] }, { type: i3.FormControlComponent, selector: "d-form-control", inputs: ["extraInfo", "feedbackStatus", "suffixTemplate"] }, { type: i3.SelectComponent, selector: "d-select", inputs: ["options", "isSearch", "toggleOnFocus", "scrollHight", "highlightItemClass", "filterKey", "multiple", "isSelectAll", "readonly", "size", "appendToBody", "appendToBodyDirections", "width", "templateItemSize", "disabled", "placeholder", "searchPlaceholder", "searchFn", "valueParser", "formatter", "direction", "overview", "allowClear", "color", "enableLazyLoad", "virtualScroll", "inputItemTemplate", "extraConfig", "optionDisabledKey", "optionImmutableKey", "noResultItemTemplate", "keepMultipleOrder", "customViewTemplate", "customViewDirection", "autoFocus", "notAutoScroll", "loadingTemplateRef", "showAnimation"], outputs: ["valueChange", "toggleChange", "loadMore"], exportAs: ["select"] }, { type: i3.DRowComponent, selector: "d-row", inputs: ["dCols"] }, { type: i3.DColComponent, selector: "d-col", inputs: ["dSpan", "dOffset", "dPush", "dPull"] }, { type: i3.ToggleComponent, selector: "d-toggle", inputs: ["size", "color", "beforeChange", "checkedContent", "uncheckedContent", "checked", "disabled"], outputs: ["change"], exportAs: ["toggle"] }, { type: i3.InputNumberComponent, selector: "d-input-number", inputs: ["step", "disabled", "size", "decimalLimit", "autoFocus", "allowEmpty", "placeholder", "maxLength", "reg", "min", "max"], outputs: ["afterValueChanged", "whileValueChanging"] }, { type: i3.ButtonComponent, selector: "d-button", inputs: ["id", "type", "bsStyle", "bsSize", "bsPosition", "bordered", "icon", "disabled", "showLoading", "width", "autofocus", "loadingTemplateRef"], outputs: ["btnClick"] }], directives: [{ type: i3.TabContentDirective, selector: "[dTabContent]" }, { type: i4.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { type: i4.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { type: i4.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i4.NgSwitchDefault, selector: "[ngSwitchDefault]" }, { type: i5.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { type: i5.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i5.NgForm, selector: "form:not([ngNoForm]):not([formGroup]),ng-form,[ngForm]", inputs: ["ngFormOptions"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i3.FormDirective, selector: "[dForm]", inputs: ["layout", "labelSize", "labelAlign", "dFeedbackType", "dHasFeedback"], outputs: ["dSubmit"], exportAs: ["dForm"] }, { type: i5.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { type: i5.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { type: i5.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { type: i3.TextDirective, selector: "[dTextInput]", inputs: ["error", "size"], exportAs: ["dTextInput"] }, { type: i3.DFlexDirective, selector: "[dFlex], d-row, d-col", inputs: ["dFlex", "dFlexContainer", "dOrder", "dAlign", "dAlignSelf", "dJustify", "dFlexWrap"] }, { type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i3.TextareaDirective, selector: "[dTextarea]", inputs: ["resize", "error"], exportAs: ["dTextarea"] }, { type: i4.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormAttributeComponent, decorators: [{
            type: Component,
            args: [{ selector: ' form-attribute', template: "<section class=\"space\">\r\n    <d-toast [value]=\"msgs\"></d-toast>\r\n    <d-tabs [(activeTab)]=\"tab1acticeID\"  class=\"tabcenter\">\r\n        <d-tab id=\"tab1\" title=\"\u63A7\u4EF6\u5C5E\u6027\" tabId=\"tab1\" [disabled]=\"isDisable\">\r\n          <ng-template dTabContent>\r\n            <ng-container [ngSwitch]=\"activeLayout\">\r\n              <ng-container *ngSwitchCase=\"controlType.Input\" [ngTemplateOutlet]=\"input\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.RichIput\" [ngTemplateOutlet]=\"richinput\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Counter\" [ngTemplateOutlet]=\"counter\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Toggle\" [ngTemplateOutlet]=\"toggle\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Select\" [ngTemplateOutlet]=\"select\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Alert\" [ngTemplateOutlet]=\"alert\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Check\" [ngTemplateOutlet]=\"check\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Radio\" [ngTemplateOutlet]=\"radio\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Date\" [ngTemplateOutlet]=\"date\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Time\" [ngTemplateOutlet]=\"time\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Rate\" [ngTemplateOutlet]=\"rate\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Space\" [ngTemplateOutlet]=\"space\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Divider\" [ngTemplateOutlet]=\"divider\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Upload\" [ngTemplateOutlet]=\"upload\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Slide\" [ngTemplateOutlet]=\"slide\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Transfer\" [ngTemplateOutlet]=\"transfer\"></ng-container>\r\n              <ng-container *ngSwitchCase=\"controlType.Tree\" [ngTemplateOutlet]=\"tree\"></ng-container>\r\n              <ng-container *ngSwitchDefault></ng-container>\r\n            </ng-container>\r\n          </ng-template>\r\n        </d-tab>\r\n    \r\n        <d-tab id=\"tab2\" title=\"\u8868\u5355\u5C5E\u6027\" tabId=\"tab2\">\r\n          <ng-template dTabContent>\r\n            <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n              <d-form-item>\r\n                <d-form-label>\u8868\u5355\u5E03\u5C40</d-form-label>\r\n                <d-form-control>\r\n                  <d-select [options]=\"layoutOptions\" name=\"layout\" [filterKey]=\"'name'\" [(ngModel)]=\"canvasInfo.layout\" (valueChange)=\"onchange()\"></d-select>\r\n                </d-form-control>\r\n              </d-form-item>\r\n              <d-form-item>\r\n                <d-form-label>label\u5360\u5BBD</d-form-label>\r\n                <d-form-control>\r\n                  <d-select [options]=\"labelSizeOptions\" name=\"labelSize\" [filterKey]=\"'name'\" [(ngModel)]=\"canvasInfo.labelSize\" (valueChange)=\"onchange()\"></d-select>\r\n                </d-form-control>\r\n              </d-form-item>\r\n              <d-form-item>\r\n                <d-form-label>label\u5BF9\u9F50</d-form-label>\r\n                <d-form-control>\r\n                  <d-select [options]=\"labelAlignOptions\" name=\"labelAlign\" [filterKey]=\"'name'\" [(ngModel)]=\"canvasInfo.labelAlign\" (valueChange)=\"onchange()\"></d-select>\r\n                </d-form-control>\r\n              </d-form-item>\r\n            </form>\r\n          </ng-template>\r\n        </d-tab>\r\n    </d-tabs>\r\n</section>\r\n<ng-template #common>\r\n  <d-form-item>\r\n    <d-form-label>\u6807\u7B7E\u540D</d-form-label>\r\n    <d-form-control>\r\n      <input dTextInput name=\"labelName\" [(ngModel)]=\"formData.label\"/>\r\n    </d-form-control>\r\n  </d-form-item>\r\n  <d-form-item>\r\n    <d-form-label>\u63A7\u4EF6\u540D\u79F0</d-form-label>\r\n    <d-form-control>\r\n      <input dTextInput name=\"controlName\" [(ngModel)]=\"formData.controlname\"/>\r\n    </d-form-control>\r\n  </d-form-item>\r\n  <d-form-item>\r\n    <d-row>\r\n      <d-col [dSpan]=\"12\">\r\n        <d-form-label>\u662F\u5426\u7981\u7528</d-form-label>\r\n      <d-form-control>\r\n        <d-toggle name=\"disabled\" [(ngModel)]=\"formData.disabled\"></d-toggle>\r\n      </d-form-control>\r\n      </d-col>\r\n      <d-col [dSpan]=\"12\">\r\n        <d-form-label>\u662F\u5426\u5FC5\u586B</d-form-label>\r\n        <d-form-control>\r\n          <d-toggle name=\"required\" [(ngModel)]=\"formData.required\"></d-toggle>\r\n        </d-form-control>\r\n      </d-col>\r\n    </d-row>\r\n  </d-form-item>\r\n  <d-form-item>\r\n    <d-form-label>\u662F\u5426\u5E2E\u52A9</d-form-label>\r\n    <d-form-control>\r\n      <d-toggle name=\"help\" [(ngModel)]=\"formData.help\"></d-toggle>\r\n    </d-form-control>\r\n  </d-form-item>\r\n  <d-form-item *ngIf=\"formData.help\">\r\n    <d-form-label>\u5E2E\u52A9\u6587\u672C</d-form-label>\r\n    <d-form-control>\r\n      <input dTextInput name=\"helptip\" [(ngModel)]=\"formData.helptip\" />\r\n    </d-form-control>\r\n  </d-form-item>\r\n</ng-template>\r\n\r\n<ng-template #input>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <d-form-item>\r\n      <d-form-label>\u9ED8\u8BA4\u503C</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"defaultName\" [(ngModel)]=\"formData.defaultvalue\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u5360\u4F4D\u6587\u672C</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"placeholder\" [(ngModel)]=\"formData.placeholder\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n    <ng-container [ngTemplateOutlet]=\"validator\">\r\n    </ng-container>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #transfer>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <d-form-item>\r\n      <d-form-label>\u6E90\u5934\u6807\u9898</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"source\" [(ngModel)]=\"formData.source\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u76EE\u6807\u6807\u9898</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"target\" [(ngModel)]=\"formData.target\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n    <ng-container [ngTemplateOutlet]=\"data\">\r\n    </ng-container>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #tree>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <d-form-item>\r\n      <d-form-label>\u5360\u4F4D\u6587\u672C</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"placeholder\" [(ngModel)]=\"formData.placeholder\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n    <ng-container [ngTemplateOutlet]=\"data\">\r\n    </ng-container>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #richinput>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <d-form-item>\r\n      <d-form-label>\u9ED8\u8BA4\u503C</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"defaultName\" [(ngModel)]=\"formData.defaultvalue\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #counter>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <d-form-item>\r\n      <d-form-label>\u9ED8\u8BA4\u503C</d-form-label>\r\n      <d-form-control>\r\n        <d-input-number name=\"defaultName\" [step]=\"1\" [(ngModel)]=\"formData.defaultvalue\"></d-input-number>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n    <d-form-item>\r\n      <d-row>\r\n        <d-col [dSpan]=\"12\">\r\n          <d-form-label>\u6700\u5C0F\u503C</d-form-label>\r\n          <d-form-control>\r\n            <d-input-number name=\"min\" [step]=\"1\" [(ngModel)]=\"formData.min\"></d-input-number>\r\n          </d-form-control>\r\n        </d-col>\r\n        <d-col [dSpan]=\"12\">\r\n          <d-form-label>\u6700\u5927\u503C</d-form-label>\r\n            <d-form-control>\r\n            <d-input-number name=\"max\" [step]=\"1\" [(ngModel)]=\"formData.max\"></d-input-number>\r\n          </d-form-control>\r\n        </d-col>\r\n      </d-row>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-row>\r\n        <d-col [dSpan]=\"12\">\r\n          <d-form-label>\u6B65\u957F</d-form-label>\r\n          <d-form-control>\r\n            <d-input-number name=\"step\" [step]=\"1\" [(ngModel)]=\"formData.step\"></d-input-number>\r\n          </d-form-control>\r\n        </d-col>\r\n        <d-col [dSpan]=\"12\">\r\n          <d-form-label>\u5355\u4F4D</d-form-label>\r\n          <d-form-control>\r\n            <input dTextInput name=\"unit\" [(ngModel)]=\"formData.unit\"/>\r\n          </d-form-control>\r\n        </d-col>\r\n      </d-row>\r\n    </d-form-item>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #toggle>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <d-form-item>\r\n      <d-form-label>\u9ED8\u8BA4\u503C</d-form-label>\r\n      <d-form-control>\r\n        <d-toggle name=\"defaultName\" [(ngModel)]=\"formData.defaultvalue\"></d-toggle>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #select>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <!-- <d-form-item>\r\n      <d-form-label>\u9ED8\u8BA4\u503C</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"defaultName\" [(ngModel)]=\"formData.defaultvalue\" />\r\n      </d-form-control>\r\n    </d-form-item> -->\r\n    <d-form-item>\r\n      <d-form-label>\u5360\u4F4D\u6587\u672C</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"placeholder\" [(ngModel)]=\"formData.placeholder\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n    <d-form-item>\r\n      <d-form-label>\u663E\u793A\u5B57\u6BB5</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"filter\" [(ngModel)]=\"formData.filter\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"data\">\r\n    </ng-container>\r\n    <d-form-item>\r\n      <d-form-label>\u662F\u5426\u591A\u9009</d-form-label>\r\n      <d-form-control>\r\n        <d-toggle name=\"multiple\" [(ngModel)]=\"formData.multiple\"></d-toggle>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"validator\">\r\n    </ng-container>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #data>\r\n  <d-form-item>\r\n    <d-form-label>\u6570\u636E\u9009\u9879</d-form-label>\r\n    <d-form-control>\r\n      <d-tabs [(activeTab)]=\"formData.dataType\" type=\"options\" customWidth=\"100px\">\r\n        <d-tab [id]=\"'static'\" title=\"\u9759\u6001\u6570\u636E\">\r\n          <ng-template dTabContent>\r\n            <d-button bsStyle=\"common\" style=\"margin-right: 8px;width: 100%;\" width=\"100%\" (btnClick)=\"showCodeEditor(formData.options,'options')\" >\u7F16\u8F91\u6570\u636E</d-button>\r\n          </ng-template>\r\n        </d-tab>\r\n        <d-tab [id]=\"'interface'\" title=\"\u63A5\u53E3\u6570\u636E\">\r\n          <ng-template dTabContent>\r\n            <div class=\"tabshow\">\r\n              <d-form-item>\r\n                <d-form-label>\u63A5\u53E3</d-form-label>\r\n                <d-form-control>\r\n                  <input dTextInput name=\"url\" [(ngModel)]=\"formData.postdata.url\" />\r\n                </d-form-control>\r\n              </d-form-item>\r\n              <d-form-item>\r\n                <d-form-label>\u8BF7\u6C42\u65B9\u5F0F</d-form-label>\r\n                <d-form-control>\r\n                  <d-select name=\"method\" [placeholder]=\"'\u8BF7\u9009\u62E9'\" [options]=\"methodtype\" [(ngModel)]=\"formData.postdata.method\"></d-select>\r\n                </d-form-control>\r\n              </d-form-item>\r\n              <d-form-item>\r\n                <d-form-label>\u9644\u5E26\u6570\u636E</d-form-label>\r\n                <d-form-control>\r\n                  <d-button bsStyle=\"common\" style=\"margin-right: 8px;width: 100%;\" width=\"100%\" (btnClick)=\"showCodeEditor(formData.postdata.data,'postdata.data')\" >\u7F16\u8F91\u6570\u636E</d-button>\r\n                </d-form-control>\r\n              </d-form-item>\r\n              <d-form-item>\r\n                <d-form-label>\u5934\u90E8\u4FE1\u606F</d-form-label>\r\n                <d-form-control>\r\n                  <d-button bsStyle=\"common\" style=\"margin-right: 8px;width: 100%;\" width=\"100%\" (btnClick)=\"showCodeEditor(formData.postdata.head,'postdata.head')\" >\u7F16\u8F91\u6570\u636E</d-button>\r\n                </d-form-control>\r\n              </d-form-item>\r\n              <d-form-item *ngIf=\"formData.controltype != controlType.Tree\">\r\n                <d-form-label>\u89E3\u6790\u51FD\u6570</d-form-label>\r\n                <d-form-control>\r\n                  <textarea dTextarea placeholder=\"\u8BF7\u8F93\u5165\" name=\"function\" [(ngModel)]=\"formData.postdata.function\"></textarea>\r\n                </d-form-control>\r\n              </d-form-item>\r\n              <d-form-item>\r\n                <d-form-control>\r\n                  <d-button bsStyle=\"common\" style=\"margin-right: 8px;width: 100%;\" width=\"100%\" (btnClick)=\"onTestData(formData.name)\">\u8F7D\u5165\u6570\u636E</d-button>\r\n                </d-form-control>\r\n              </d-form-item>\r\n            </div>\r\n          </ng-template>\r\n        </d-tab>\r\n      </d-tabs>\r\n    </d-form-control>\r\n  </d-form-item>\r\n</ng-template>\r\n\r\n<ng-template #alert>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <d-form-item>\r\n      <d-form-label>\u663E\u793A\u503C</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"label\" [(ngModel)]=\"formData.label\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u8B66\u544A\u7C7B\u578B</d-form-label>\r\n      <d-form-control>\r\n        <d-select [options]=\"alerttype\" name=\"alerttype\" [(ngModel)]=\"formData.alerttype\"></d-select>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u662F\u5426\u5173\u95ED</d-form-label>\r\n      <d-form-control>\r\n        <d-toggle name=\"closeable\" [(ngModel)]=\"formData.closeable\"></d-toggle>\r\n      </d-form-control>\r\n    </d-form-item>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #check>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n    <d-form-item>\r\n      <d-form-label>\u663E\u793A\u65B9\u5411</d-form-label>\r\n      <d-form-control>\r\n        <d-select [options]=\"direction\" name=\"direction\" [(ngModel)]=\"formData.direction\"></d-select>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u663E\u793A\u6807\u9898</d-form-label>\r\n      <d-form-control>\r\n        <d-toggle name=\"isshowtitle\" [(ngModel)]=\"formData.isshowtitle\"></d-toggle>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u663E\u793A\u5B57\u6BB5</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"filter\" [(ngModel)]=\"formData.filter\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"data\">\r\n    </ng-container>\r\n    <ng-container [ngTemplateOutlet]=\"validator\">\r\n    </ng-container>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #radio>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n    <d-form-item>\r\n      <d-form-label>\u663E\u793A\u65B9\u5411</d-form-label>\r\n      <d-form-control>\r\n        <d-select [options]=\"direction\" name=\"direction\" [(ngModel)]=\"formData.direction\"></d-select>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"data\">\r\n    </ng-container>\r\n    <ng-container [ngTemplateOutlet]=\"validator\">\r\n    </ng-container>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #date>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n    <d-form-item>\r\n      <d-form-label>\u65E5\u671F\u7C7B\u578B</d-form-label>\r\n      <d-form-control>\r\n        <d-select [options]=\"datetype\" name=\"datetype\" [(ngModel)]=\"formData.datetype\" (valueChange)=\"onChangeDateTypeOrFormat()\"></d-select>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u65E5\u671F\u683C\u5F0F</d-form-label>\r\n      <d-form-control>\r\n        <d-select [options]=\"dateFormat\" name=\"dateFormat\" [(ngModel)]=\"formData.dateFormat\" (valueChange)=\"onChangeDateTypeOrFormat()\"></d-select>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u662F\u5426\u663E\u793A\u65F6\u95F4</d-form-label>\r\n      <d-form-control>\r\n        <d-toggle name=\"showtime\" [(ngModel)]=\"formData.showtime\"></d-toggle>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"validator\">\r\n    </ng-container>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #time>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n    <d-form-item>\r\n      <d-form-label>\u65E5\u671F\u683C\u5F0F</d-form-label>\r\n      <d-form-control>\r\n        <d-select [options]=\"timeFormat\" name=\"format\" [(ngModel)]=\"formData.format\" (valueChange)=\"onChangeTimeFormat()\"></d-select>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"validator\">\r\n    </ng-container>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #rate>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <d-form-item>\r\n      <d-form-label>\u9ED8\u8BA4\u503C</d-form-label>\r\n      <d-form-control>\r\n        <d-input-number name=\"defaultName\" [step]=\"1\" [(ngModel)]=\"formData.defaultvalue\"></d-input-number>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n    <d-form-item>\r\n      <d-form-label>\u662F\u5426\u534A\u503C</d-form-label>\r\n      <d-form-control>\r\n        <d-toggle name=\"allowhalf\" [(ngModel)]=\"formData.allowhalf\"></d-toggle>\r\n      </d-form-control>\r\n    </d-form-item>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #space>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <d-form-item>\r\n      <d-form-label>\u9AD8\u5EA6</d-form-label>\r\n      <d-form-control>\r\n        <d-input-number name=\"height\" [step]=\"1\" [(ngModel)]=\"formData.height\"></d-input-number>\r\n      </d-form-control>\r\n    </d-form-item>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #divider>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <d-form-item>\r\n      <d-form-label>\u663E\u793A\u6587\u672C</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"label\" [(ngModel)]=\"formData.label\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u6587\u672C\u4F4D\u7F6E</d-form-label>\r\n      <d-form-control>\r\n        <d-select [options]=\"alignFormat\"[(ngModel)]=\"formData.alignvalue\" name=\"align\" [filterKey]=\"'label'\" (valueChange)=\"onChangeAlignFormat($event)\"></d-select>\r\n      </d-form-control>\r\n    </d-form-item>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #upload>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n    <d-form-item>\r\n      <d-form-label>\u63A5\u53E3</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"url\" [(ngModel)]=\"formData.uploadOptions.uri\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u8BF7\u6C42\u65B9\u5F0F</d-form-label>\r\n      <d-form-control>\r\n        <d-select name=\"method\" [placeholder]=\"'\u8BF7\u9009\u62E9'\" [options]=\"methodtype\" [(ngModel)]=\"formData.uploadOptions.method\"></d-select>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u9644\u5E26\u6570\u636E</d-form-label>\r\n      <d-form-control>\r\n        <d-button bsStyle=\"common\" style=\"margin-right: 8px;width: 100%;\" width=\"100%\" (btnClick)=\"showCodeEditor(formData.uploadOptions.additionalParameter,'uploadOptions.additionalParameter')\" >\u7F16\u8F91\u6570\u636E</d-button>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u5934\u90E8\u4FE1\u606F</d-form-label>\r\n      <d-form-control>\r\n        <d-button bsStyle=\"common\" style=\"margin-right: 8px;width: 100%;\" width=\"100%\" (btnClick)=\"showCodeEditor(formData.uploadOptions.headers,'uploadOptions.headers')\" >\u7F16\u8F91\u6570\u636E</d-button>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u4E0A\u4F20\u6587\u4EF6\u5927\u5C0F\u9650\u5236</d-form-label>\r\n      <d-form-control>\r\n        <d-input-number name=\"maximumSize\" [step]=\"1\" [(ngModel)]=\"formData.uploadOptions.maximumSize\"></d-input-number>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u6587\u4EF6\u540D\u79F0</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"fileFieldName\" [(ngModel)]=\"formData.uploadOptions.fileFieldName\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u8FD4\u56DE\u6570\u636E\u7C7B\u578B</d-form-label>\r\n      <d-form-control>\r\n        <d-select [options]=\"responseType\" name=\"responseType\" [(ngModel)]=\"formData.uploadOptions.responseType\"></d-select>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u6587\u4EF6\u7C7B\u578B</d-form-label>\r\n      <d-form-control>\r\n        <input dTextInput name=\"accept\" [(ngModel)]=\"formData.fileOptions.accept\" />\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u53EF\u9009\u62E9\u591A\u4E2A\u503C</d-form-label>\r\n      <d-form-control>\r\n        <d-toggle name=\"multiple\" [(ngModel)]=\"formData.fileOptions.multiple\"></d-toggle>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"validator\">\r\n    </ng-container>\r\n  </form>\r\n</ng-template>\r\n\r\n<ng-template #validator>\r\n  <d-form-item style=\"margin: 0px;\">\r\n    <d-form-control>\r\n      <div class=\"form-divider form-divider-horizontal\">\r\n          <div class=\"form-divider__text is-center\">\u63A7\u4EF6\u9A8C\u8BC1</div>\r\n      </div>\r\n    </d-form-control>\r\n  </d-form-item>\r\n  <d-form-item>\r\n    <d-row *ngFor=\"let validator of validators;index as i;\">\r\n      <d-col [dSpan]=\"8\" style=\"padding-right: 3px;\">\r\n        <d-form-label>\u9A8C\u8BC1\u7C7B\u578B</d-form-label>\r\n        <d-form-control>\r\n          <d-select name=\"validatortype\" \r\n          (valueChange)=\"onChangeItem($event,validator)\" \r\n          [placeholder]=\"'\u8BF7\u9009\u62E9'\" \r\n          [filterKey]=\"'label'\" \r\n          [optionDisabledKey]=\"'disabled'\" \r\n          [options]=\"validator.validatorOptions\" \r\n          [(ngModel)]=\"validator.validatortype\"></d-select>\r\n        </d-form-control>\r\n      </d-col>\r\n      <d-col [dSpan]=\"12\">\r\n        <d-form-label>\u503C</d-form-label>\r\n        <d-form-control>\r\n          <ng-container [ngSwitch]=\"validator.validatortype.label\">\r\n            <ng-container *ngSwitchCase=\"'required'\" [ngTemplateOutlet]=\"required\"></ng-container>\r\n            <ng-container *ngSwitchCase=\"'email'\" [ngTemplateOutlet]=\"required\"></ng-container>\r\n            <ng-container *ngSwitchCase=\"'whitespace'\" [ngTemplateOutlet]=\"required\"></ng-container>\r\n            <ng-container *ngSwitchCase=\"'pattern'\" [ngTemplateOutlet]=\"pattern\"></ng-container>\r\n            <ng-container *ngSwitchCase=\"'minlength'\">\r\n              <ng-container *ngTemplateOutlet=\"num; context:{$implicit:5,max:128};\">\r\n              </ng-container>\r\n            </ng-container>\r\n            <ng-container *ngSwitchCase=\"'maxlength'\">\r\n              <ng-container *ngTemplateOutlet=\"num; context:{$implicit:5,max:128};\">\r\n              </ng-container>\r\n            </ng-container>\r\n            <ng-container *ngSwitchCase=\"'min'\">\r\n              <ng-container *ngTemplateOutlet=\"num; context:{$implicit:0,max:100};\">\r\n              </ng-container>\r\n            </ng-container>\r\n            <ng-container *ngSwitchCase=\"'max'\">\r\n              <ng-container *ngTemplateOutlet=\"num; context:{$implicit:0,max:100};\">\r\n              </ng-container>\r\n            </ng-container>\r\n            <ng-container *ngSwitchDefault></ng-container>\r\n          </ng-container>\r\n          <ng-template #pattern>\r\n            <input dTextInput name=\"value\" [(ngModel)]=\"validator.value\" (change)=\"onChangeValidateValue(validator)\"/>\r\n          </ng-template>\r\n          <ng-template #required>\r\n            <div style=\"padding-top: 3px;\">\r\n              <d-toggle [color]=\"'#50D4AB'\" [disabled]=\"true\"  [(ngModel)]=\"validator.value\" [checkedContent]=\"iconCheckedContent\" [uncheckedContent]=\"iconUncheckedContent\"></d-toggle>\r\n              <ng-template #iconCheckedContent>\r\n                <div class=\"toggle-inner\">\r\n                  <i class=\"icon-right\"></i>\r\n                </div>\r\n              </ng-template>\r\n              <ng-template #iconUncheckedContent>\r\n                <div class=\"toggle-inner\">\r\n                  <i class=\"icon-error\"></i>\r\n                </div>\r\n              </ng-template>\r\n            </div>\r\n          </ng-template>\r\n          <ng-template #num let-min let-max =\"max\">\r\n            <d-input-number name=\"height\" [min]=\"min\" [max]=\"max\" [step]=\"1\" style=\"width: 100%;\" [(ngModel)]=\"validator.value\" (ngModelChange)=\"onChangeValidateValue(validator)\"></d-input-number>\r\n          </ng-template>\r\n        </d-form-control>\r\n      </d-col>\r\n      <d-col [dSpan]=\"4\">\r\n        <div class=\"btn-group\">\r\n          <d-button icon=\"fc-icon icon-add icon-font\" bsStyle=\"text-dark\" title=\"\u6DFB\u52A0\" width=\"21px\" (btnClick)=\"onAddValidationRule()\"></d-button>\r\n          <d-button icon=\"fc-icon icon-delete icon-font\" bsStyle=\"text-dark\" [disabled]=\"validators.length==1\" title=\"\u5220\u9664\" width=\"22px\" (btnClick)=\"onRemoveRule(i)\"></d-button>\r\n        </div>\r\n      </d-col>\r\n    </d-row>\r\n  </d-form-item>\r\n</ng-template>\r\n\r\n<ng-template #slide>\r\n  <form dForm [layout]=\"layoutDirection\" [labelSize]=\"'sm'\">\r\n    <d-form-item>\r\n      <d-form-label>\u9ED8\u8BA4\u503C</d-form-label>\r\n      <d-form-control>\r\n        <d-input-number name=\"defaultName\" [step]=\"1\" [(ngModel)]=\"formData.defaultvalue\"></d-input-number>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"common\">\r\n    </ng-container>\r\n    <d-form-item>\r\n      <d-row>\r\n        <d-col [dSpan]=\"12\">\r\n          <d-form-label>\u6700\u5C0F\u503C</d-form-label>\r\n          <d-form-control>\r\n            <d-input-number name=\"min\" [step]=\"1\" [(ngModel)]=\"formData.min\"></d-input-number>\r\n          </d-form-control>\r\n        </d-col>\r\n        <d-col [dSpan]=\"12\">\r\n          <d-form-label>\u6700\u5927\u503C</d-form-label>\r\n            <d-form-control>\r\n            <d-input-number name=\"max\" [step]=\"1\" [(ngModel)]=\"formData.max\"></d-input-number>\r\n          </d-form-control>\r\n        </d-col>\r\n      </d-row>\r\n    </d-form-item>\r\n    <d-form-item>\r\n      <d-form-label>\u6B65\u957F</d-form-label>\r\n      <d-form-control>\r\n        <d-input-number name=\"step\" [step]=\"1\" [(ngModel)]=\"formData.step\"></d-input-number>\r\n      </d-form-control>\r\n    </d-form-item>\r\n    <ng-container [ngTemplateOutlet]=\"validator\">\r\n    </ng-container>\r\n  </form>\r\n</ng-template>", styles: [".space{width:100%;padding:0 10px 10px}:host form{width:330px;padding:0 10px}.tabshow{border:2px solid var(--devui-brand, #5e7ce0);padding:5px}:host ::ng-deep section>d-tabs>ul{position:sticky;padding-top:10px;background:#fff!important;top:0;z-index:16}:host ::ng-deep .btn-group d-button .icon-font{font-size:16px}.btn-group{margin-top:18px}.form-divider{background-color:#dcdfe6;position:relative}.form-divider-horizontal{display:block;height:1px;width:100%;margin:24px 0}.form-divider__text{position:absolute;background-color:#fff;padding:0 20px;color:#303133}.form-divider__text.is-center{left:50%;transform:translate(-50%) translateY(-50%)}\n"] }]
        }], ctorParameters: function () { return [{ type: CommonService }, { type: i3.ModalService }]; } });

class FormPreviewComponent {
    constructor(commonService) {
        this.commonService = commonService;
        this.showBtn = false;
        this.userFormGroup = new FormGroup({});
    }
    ngOnInit() {
        this.commonService.formGroup = this.userFormGroup;
        this.commonService.colloctData = Object.create(null);
        this.commonService.createComponent(this.commonService.getPreviewData(), this.main, "detail");
        console.log(this.commonService.getPreviewData());
    }
    submitPlanForm(e) {
        if (e.valid) {
            var postdata = Object.create(null);
            for (const key in this.commonService.colloctData) {
                postdata[key] = this.commonService.colloctData[key].defaultvalue;
            }
            console.log(postdata);
        }
        else {
            // error tip
        }
    }
}
FormPreviewComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormPreviewComponent, deps: [{ token: CommonService }], target: i0.ɵɵFactoryTarget.Component });
FormPreviewComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormPreviewComponent, selector: "form-preview", inputs: { data: "data", showBtn: "showBtn" }, viewQueries: [{ propertyName: "main", first: true, predicate: ["main"], descendants: true, read: ViewContainerRef, static: true }], ngImport: i0, template: "<form \r\n    dForm \r\n    [formGroup]=\"userFormGroup\"\r\n    [layout]=\"data.layout\" \r\n    [labelSize]=\"data.labelSize\" \r\n    [labelAlign]=\"data.labelAlign\"\r\n    #thisform = \"dValidateRules\" \r\n    [dValidateRules]=\"{message:'check this'}\" \r\n    (dSubmit)=\"submitPlanForm($event)\" >\r\n    <ng-container #main>\r\n    </ng-container>\r\n    <d-form-operation *ngIf=\"showBtn\">\r\n        <d-button dFormSubmit bsStyle=\"primary\" class=\"mr-element-spacing\" circled=\"true\" style=\"margin-right: 4px\">\u63D0\u4EA4</d-button>\r\n        <d-button bsStyle=\"common\" circled=\"true\">\u53D6\u6D88</d-button>\r\n    </d-form-operation>\r\n</form>", styles: [""], components: [{ type: i3.FormOperationComponent, selector: "d-form-operation" }, { type: i3.ButtonComponent, selector: "d-button", inputs: ["id", "type", "bsStyle", "bsSize", "bsPosition", "bordered", "icon", "disabled", "showLoading", "width", "autofocus", "loadingTemplateRef"], outputs: ["btnClick"] }], directives: [{ type: i5.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { type: i5.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i3.DFormGroupRuleDirective, selector: "[dValidateRules][formGroupName],[dValidateRules][formArrayName],[dValidateRules][ngModelGroup],          [dValidateRules][formGroup],[dValidateRules]form:not([ngNoForm]),[dValidateRules][ngForm]", inputs: ["dValidateRules"], outputs: ["dRulesStatusChange"], exportAs: ["dValidateRules"] }, { type: i3.FormDirective, selector: "[dForm]", inputs: ["layout", "labelSize", "labelAlign", "dFeedbackType", "dHasFeedback"], outputs: ["dSubmit"], exportAs: ["dForm"] }, { type: i5.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i4.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i3.DFormSubmitDirective, selector: "[dFormSubmit]", inputs: ["dFormSubmit", "dFormSubmitData"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormPreviewComponent, decorators: [{
            type: Component,
            args: [{ selector: 'form-preview', template: "<form \r\n    dForm \r\n    [formGroup]=\"userFormGroup\"\r\n    [layout]=\"data.layout\" \r\n    [labelSize]=\"data.labelSize\" \r\n    [labelAlign]=\"data.labelAlign\"\r\n    #thisform = \"dValidateRules\" \r\n    [dValidateRules]=\"{message:'check this'}\" \r\n    (dSubmit)=\"submitPlanForm($event)\" >\r\n    <ng-container #main>\r\n    </ng-container>\r\n    <d-form-operation *ngIf=\"showBtn\">\r\n        <d-button dFormSubmit bsStyle=\"primary\" class=\"mr-element-spacing\" circled=\"true\" style=\"margin-right: 4px\">\u63D0\u4EA4</d-button>\r\n        <d-button bsStyle=\"common\" circled=\"true\">\u53D6\u6D88</d-button>\r\n    </d-form-operation>\r\n</form>", styles: [""] }]
        }], ctorParameters: function () { return [{ type: CommonService }]; }, propDecorators: { data: [{
                type: Input
            }], showBtn: [{
                type: Input
            }], main: [{
                type: ViewChild,
                args: ["main", { read: ViewContainerRef, static: true }]
            }] } });

class FormDragDirective {
    constructor(el, commonService) {
        this.el = el;
        this.commonService = commonService;
        this.areaname = "";
        this._controlinfo = {};
    }
    onMouseDown() {
        this.el.nativeElement.draggable = true;
    }
    onDragstart(e) {
        e.dataTransfer.setData("controlinfo", JSON.stringify(this._controlinfo));
        this.commonService.setShowShadows({ isshow: true, name: "" });
    }
    onDragend() {
        this.el.nativeElement.removeAttribute("draggable");
        this.commonService.cancelEvent.emit(this.areaname);
        this.commonService.setShowShadows({ isshow: false, name: "" });
    }
    ngOnInit() {
        this.commonService.followObservable.subscribe(o => {
            this.areaname = o.name;
        });
    }
    get controlInfo() {
        return this._controlinfo;
    }
    set controlInfo(prop) {
        this._controlinfo = prop;
    }
}
FormDragDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormDragDirective, deps: [{ token: i0.ElementRef }, { token: CommonService }], target: i0.ɵɵFactoryTarget.Directive });
FormDragDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.3.6", type: FormDragDirective, selector: "[formdrag]", inputs: { controlInfo: ["controlinfo", "controlInfo"] }, host: { listeners: { "mousedown": "onMouseDown()", "dragstart": "onDragstart($event)", "dragend": "onDragend()" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormDragDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[formdrag]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: CommonService }]; }, propDecorators: { onMouseDown: [{
                type: HostListener,
                args: ["mousedown"]
            }], onDragstart: [{
                type: HostListener,
                args: ["dragstart", ["$event"]]
            }], onDragend: [{
                type: HostListener,
                args: ["dragend"]
            }], controlInfo: [{
                type: Input,
                args: ["controlinfo"]
            }] } });

class FormComponentComponent {
    constructor() {
        this.formcontrollers = [
            { icon: "fc-icon icon-input", text: "输入框", controlinfo: {
                    control: ControlType.Input
                } },
            { icon: "fc-icon icon-editor", text: "富文本", controlinfo: {
                    control: ControlType.RichIput
                } },
            { icon: "fc-icon icon-select", text: "下拉框", controlinfo: {
                    control: ControlType.Select
                } },
            { icon: "fc-icon icon-number", text: "计数器", controlinfo: {
                    control: ControlType.Counter
                } },
            { icon: "fc-icon icon-checkbox", text: "多选框", controlinfo: {
                    control: ControlType.Check
                } },
            { icon: "fc-icon icon-radio", text: "单选框", controlinfo: {
                    control: ControlType.Radio
                } },
            { icon: "fc-icon icon-switch", text: "开关", controlinfo: {
                    control: ControlType.Toggle
                } },
            { icon: "fc-icon icon-date", text: "日期选择器", controlinfo: {
                    control: ControlType.Date
                } },
            { icon: "fc-icon icon-time", text: "时间选择器", controlinfo: {
                    control: ControlType.Time
                } },
            { icon: "fc-icon icon-upload", text: "上传", controlinfo: {
                    control: ControlType.Upload
                } },
            { icon: "fc-icon icon-rate", text: "评分", controlinfo: {
                    control: ControlType.Rate
                } },
            { icon: "fc-icon icon-slider", text: "滑块", controlinfo: {
                    control: ControlType.Slide
                } },
            { icon: "fc-icon icon-transfer", text: "穿梭框", controlinfo: {
                    control: ControlType.Transfer
                } },
            { icon: "fc-icon icon-cascader", text: "树形选择器", controlinfo: {
                    control: ControlType.Tree
                } }
        ];
        this.assistcontrollers = [
            { icon: "fc-icon icon-alert", text: "提示", controlinfo: {
                    control: ControlType.Alert
                } },
            // {icon:"fc-icon icon-span",text:"文字", controlinfo : {
            //   control:ControlType.Label
            // }},
            { icon: "fc-icon icon-divider", text: "分割线", controlinfo: {
                    control: ControlType.Divider
                } },
            { icon: "fc-icon icon-space", text: "间距", controlinfo: {
                    control: ControlType.Space
                } },
            { icon: "fc-icon icon-row", text: "栅格布局", controlinfo: {
                    control: ControlType.Row
                } },
        ];
    }
    ngOnInit() {
    }
}
FormComponentComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormComponentComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
FormComponentComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormComponentComponent, selector: "form-component", ngImport: i0, template: "<div class=\"compmain\">\n    <div class=\"title\">\u8868\u5355\u7EC4\u4EF6</div>\n    <div class=\"icon-box\">\n        <ul class=\"icon-list\">\n            <li *ngFor=\"let item of formcontrollers\" formdrag [controlinfo] = \"item.controlinfo\">\n                <div class=\"icon-content\">\n                    <i class=\"icon icon-size\" [class]=\"item.icon\"></i>\n                </div>\n                <span class = \"icon-name\">{{item.text}}</span>\n            </li>\n        </ul>\n    </div>\n    <div class=\"title\">\u8F85\u52A9\u7EC4\u4EF6</div>\n    <div class=\"icon-box\">\n        <ul class=\"icon-list\">\n            <li *ngFor=\"let item of assistcontrollers\" formdrag [controlinfo] = \"item.controlinfo\">\n                <div class=\"icon-content\">\n                    <i class=\"icon icon-size\" [class]=\"item.icon\"></i>\n                </div>\n                <span class = \"icon-name\">{{item.text}}</span>\n            </li>\n        </ul>\n    </div>\n</div>\n", styles: [".compmain{height:100%;width:232px;background:#fff;display:flex;flex-direction:column;overflow:auto}.title{padding:10px 0 0 10px;font-weight:700}.icon-box{overflow:hidden;margin:10px}.icon-list{overflow:hidden;padding-left:0;margin:0}.icon-list li{list-style:none;position:relative;display:block;float:left;height:70px;text-align:center;margin:0 auto;width:70px;padding:4px}.icon-list li:hover{cursor:move;background-color:#add8e6}.icon-list li .icon-content{margin-top:15px;display:inline-block}.icon-list li .icon-name{display:block;width:100%;height:20px;line-height:20px;color:#252b3a;color:var(--devui-text, #252b3a);font-size:12px;text-align:center;margin-top:4px;overflow:hidden;white-space:nowrap;text-overflow:ellipsis}.icon-size{font-size:20px;font-weight:700}\n"], directives: [{ type: i4.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: FormDragDirective, selector: "[formdrag]", inputs: ["controlinfo"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormComponentComponent, decorators: [{
            type: Component,
            args: [{ selector: 'form-component', template: "<div class=\"compmain\">\n    <div class=\"title\">\u8868\u5355\u7EC4\u4EF6</div>\n    <div class=\"icon-box\">\n        <ul class=\"icon-list\">\n            <li *ngFor=\"let item of formcontrollers\" formdrag [controlinfo] = \"item.controlinfo\">\n                <div class=\"icon-content\">\n                    <i class=\"icon icon-size\" [class]=\"item.icon\"></i>\n                </div>\n                <span class = \"icon-name\">{{item.text}}</span>\n            </li>\n        </ul>\n    </div>\n    <div class=\"title\">\u8F85\u52A9\u7EC4\u4EF6</div>\n    <div class=\"icon-box\">\n        <ul class=\"icon-list\">\n            <li *ngFor=\"let item of assistcontrollers\" formdrag [controlinfo] = \"item.controlinfo\">\n                <div class=\"icon-content\">\n                    <i class=\"icon icon-size\" [class]=\"item.icon\"></i>\n                </div>\n                <span class = \"icon-name\">{{item.text}}</span>\n            </li>\n        </ul>\n    </div>\n</div>\n", styles: [".compmain{height:100%;width:232px;background:#fff;display:flex;flex-direction:column;overflow:auto}.title{padding:10px 0 0 10px;font-weight:700}.icon-box{overflow:hidden;margin:10px}.icon-list{overflow:hidden;padding-left:0;margin:0}.icon-list li{list-style:none;position:relative;display:block;float:left;height:70px;text-align:center;margin:0 auto;width:70px;padding:4px}.icon-list li:hover{cursor:move;background-color:#add8e6}.icon-list li .icon-content{margin-top:15px;display:inline-block}.icon-list li .icon-name{display:block;width:100%;height:20px;line-height:20px;color:#252b3a;color:var(--devui-text, #252b3a);font-size:12px;text-align:center;margin-top:4px;overflow:hidden;white-space:nowrap;text-overflow:ellipsis}.icon-size{font-size:20px;font-weight:700}\n"] }]
        }], ctorParameters: function () { return []; } });

class FormCanvasComponent {
    constructor(commonService) {
        this.commonService = commonService;
        this.canvasInfo = CANVASDEFAULT;
        this.containerName = MAINCONTAINER;
    }
    ngOnInit() {
        this.commonService.changeFormLayout.subscribe(o => {
            this.canvasInfo = o;
        });
    }
}
FormCanvasComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormCanvasComponent, deps: [{ token: CommonService }], target: i0.ɵɵFactoryTarget.Component });
FormCanvasComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormCanvasComponent, selector: "form-canvas", inputs: { originalLayout: "originalLayout" }, ngImport: i0, template: "<div class=\"all-area\">\r\n    <form dForm [layout]=\"canvasInfo.layout\" [labelSize]=\"canvasInfo.labelSize\" [labelAlign]=\"canvasInfo.labelAlign\" style=\"flex:1\">\r\n        <form-area [name]=\"containerName\" [originalLayout]=\"originalLayout\"></form-area>\r\n    </form>\r\n</div>", styles: [".all-area{background:#ccc;height:100%;padding:5px;display:flex;flex-direction:column;overflow:auto}.all-area:-moz-drag-over{border:1px solid black}\n"], components: [{ type: FormAreaComponent, selector: "form-area", inputs: ["name", "mode", "originalLayout"], outputs: ["onaddrow", "onremoverow"] }], directives: [{ type: i5.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { type: i5.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { type: i5.NgForm, selector: "form:not([ngNoForm]):not([formGroup]),ng-form,[ngForm]", inputs: ["ngFormOptions"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { type: i3.FormDirective, selector: "[dForm]", inputs: ["layout", "labelSize", "labelAlign", "dFeedbackType", "dHasFeedback"], outputs: ["dSubmit"], exportAs: ["dForm"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormCanvasComponent, decorators: [{
            type: Component,
            args: [{ selector: 'form-canvas', template: "<div class=\"all-area\">\r\n    <form dForm [layout]=\"canvasInfo.layout\" [labelSize]=\"canvasInfo.labelSize\" [labelAlign]=\"canvasInfo.labelAlign\" style=\"flex:1\">\r\n        <form-area [name]=\"containerName\" [originalLayout]=\"originalLayout\"></form-area>\r\n    </form>\r\n</div>", styles: [".all-area{background:#ccc;height:100%;padding:5px;display:flex;flex-direction:column;overflow:auto}.all-area:-moz-drag-over{border:1px solid black}\n"] }]
        }], ctorParameters: function () { return [{ type: CommonService }]; }, propDecorators: { originalLayout: [{
                type: Input,
                args: ["originalLayout"]
            }] } });

class FormBuilderComponent {
    constructor(dialogService, commonService) {
        this.dialogService = dialogService;
        this.commonService = commonService;
        this.canvasInfo = CANVASDEFAULT;
        this.sendBuilderString = new EventEmitter();
    }
    get inputLayout() {
        if (this.originalLayout) {
            return JSON.parse(this.originalLayout, this.commonService.reviver);
        }
        else {
            return null;
        }
    }
    openPreview() {
        const results = this.dialogService.open({
            id: 'dialog-service',
            width: '850px',
            maxHeight: '600px',
            title: '表单预览',
            content: FormPreviewComponent,
            backdropCloseable: true,
            dialogtype: "standard",
            onClose: () => {
                console.log('on dialog closed');
            },
            buttons: [
                {
                    cssClass: 'primary',
                    text: '确定',
                    disabled: false,
                    handler: ($event) => {
                        results.modalInstance.hide();
                    },
                },
                {
                    id: 'btn-cancel',
                    cssClass: 'common',
                    text: '取消',
                    handler: ($event) => {
                        results.modalInstance.hide();
                    },
                },
            ],
            data: this.canvasInfo,
        });
    }
    sendBuilderEvent() {
        this.sendBuilderString.emit(JSON.stringify(this.commonService.getPreviewData("op"), this.commonService.replacer));
    }
}
FormBuilderComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormBuilderComponent, deps: [{ token: i3.DialogService }, { token: CommonService }], target: i0.ɵɵFactoryTarget.Component });
FormBuilderComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "13.3.6", type: FormBuilderComponent, selector: "form-builder", inputs: { originalLayout: "originalLayout" }, outputs: { sendBuilderString: "sendBuilderString" }, ngImport: i0, template: "<d-layout class=\"layout-wrapper\">\r\n    <d-header >\r\n      <div class=\"bottonbar\">\r\n        <d-button style=\"margin-right: 8px\" (btnClick)=\"sendBuilderEvent()\">\u4FDD\u5B58</d-button>\r\n        <d-button style=\"margin-right: 8px\" (btnClick)=\"openPreview()\">\u9884\u89C8</d-button>\r\n      </div>\r\n    </d-header>\r\n    <d-layout style=\"overflow: hidden;\">\r\n      <d-aside class=\"compbar\" style=\"min-width:232px\">\r\n        <form-component></form-component>\r\n      </d-aside>\r\n      <d-content style=\"overflow-y: hidden;\">\r\n        <form-canvas [originalLayout]=\"inputLayout\"></form-canvas>\r\n      </d-content>\r\n      <d-aside class=\"attributbar\">\r\n        <form-attribute></form-attribute>\r\n      </d-aside>\r\n    </d-layout>\r\n</d-layout>", styles: [".layout-wrapper{box-shadow:var(--devui-shadow-length-base, 0 1px 4px 0) var(--devui-light-shadow, rgba(37, 43, 58, .2));margin-top:36px;height:100%}.layout-wrapper:first-child{margin-top:0}d-header{line-height:40px;background-color:var(--devui-base-bg-dark, #252b3a);color:var(--devui-light-text, #ffffff)}d-aside{min-height:200px;min-width:350px;background-color:var(--devui-base-bg, #ffffff)}d-content{background-color:var(--devui-global-bg, #f7f8fa)}.bottonbar{display:flex;flex-direction:row-reverse;align-items:center;height:100%}.compbar{overflow:auto;display:flex;flex-direction:column}.attributbar{display:flex;flex-direction:column;overflow:auto}\n"], components: [{ type: i3.LayoutComponent, selector: "d-layout" }, { type: i3.HeaderComponent, selector: "d-header" }, { type: i3.ButtonComponent, selector: "d-button", inputs: ["id", "type", "bsStyle", "bsSize", "bsPosition", "bordered", "icon", "disabled", "showLoading", "width", "autofocus", "loadingTemplateRef"], outputs: ["btnClick"] }, { type: i3.AsideComponent, selector: "d-aside", exportAs: ["dAside"] }, { type: FormComponentComponent, selector: "form-component" }, { type: i3.ContentComponent, selector: "d-content" }, { type: FormCanvasComponent, selector: "form-canvas", inputs: ["originalLayout"] }, { type: FormAttributeComponent, selector: " form-attribute" }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormBuilderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'form-builder', template: "<d-layout class=\"layout-wrapper\">\r\n    <d-header >\r\n      <div class=\"bottonbar\">\r\n        <d-button style=\"margin-right: 8px\" (btnClick)=\"sendBuilderEvent()\">\u4FDD\u5B58</d-button>\r\n        <d-button style=\"margin-right: 8px\" (btnClick)=\"openPreview()\">\u9884\u89C8</d-button>\r\n      </div>\r\n    </d-header>\r\n    <d-layout style=\"overflow: hidden;\">\r\n      <d-aside class=\"compbar\" style=\"min-width:232px\">\r\n        <form-component></form-component>\r\n      </d-aside>\r\n      <d-content style=\"overflow-y: hidden;\">\r\n        <form-canvas [originalLayout]=\"inputLayout\"></form-canvas>\r\n      </d-content>\r\n      <d-aside class=\"attributbar\">\r\n        <form-attribute></form-attribute>\r\n      </d-aside>\r\n    </d-layout>\r\n</d-layout>", styles: [".layout-wrapper{box-shadow:var(--devui-shadow-length-base, 0 1px 4px 0) var(--devui-light-shadow, rgba(37, 43, 58, .2));margin-top:36px;height:100%}.layout-wrapper:first-child{margin-top:0}d-header{line-height:40px;background-color:var(--devui-base-bg-dark, #252b3a);color:var(--devui-light-text, #ffffff)}d-aside{min-height:200px;min-width:350px;background-color:var(--devui-base-bg, #ffffff)}d-content{background-color:var(--devui-global-bg, #f7f8fa)}.bottonbar{display:flex;flex-direction:row-reverse;align-items:center;height:100%}.compbar{overflow:auto;display:flex;flex-direction:column}.attributbar{display:flex;flex-direction:column;overflow:auto}\n"] }]
        }], ctorParameters: function () { return [{ type: i3.DialogService }, { type: CommonService }]; }, propDecorators: { originalLayout: [{
                type: Input,
                args: ["originalLayout"]
            }], sendBuilderString: [{
                type: Output
            }] } });

class FormbuilderModule {
}
FormbuilderModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormbuilderModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
FormbuilderModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormbuilderModule, declarations: [FormComponentComponent,
        FormCanvasComponent,
        FormAttributeComponent,
        FormBuilderComponent,
        FormDragDirective,
        FormDropDirective,
        FormBoxComponent,
        FormInputComponent,
        FormDragTemplateDirective,
        FormRichinputComponent,
        FormCounterComponent,
        FormPreviewComponent,
        FormToggleComponent,
        FormAreaComponent,
        FormLayoutComponent,
        FormSelectComponent,
        FormCodeEditorComponent,
        FormAlertComponent,
        FormRadioComponent,
        FormCheckboxComponent,
        FormUploadComponent,
        FormRateComponent,
        FormTimeComponent,
        FormDateComponent,
        FormSpaceComponent,
        FormDividerComponent,
        FormSliderComponent,
        FormTransferComponent,
        FormTreeComponent], imports: [CommonModule,
        BrowserAnimationsModule,
        BrowserModule,
        FormModule,
        TextInputModule,
        LayoutModule,
        TabsModule,
        FormsModule,
        TextareaModule,
        ToggleModule,
        SelectModule,
        CKEditorModule,
        InputNumberModule,
        ButtonModule,
        ModalModule,
        CodemirrorModule,
        HttpClientModule,
        AlertModule,
        CheckBoxModule,
        RadioModule,
        DatepickerModule,
        TimePickerModule,
        UploadModule,
        RateModule,
        ProgressModule,
        ToastModule,
        DatepickerProModule,
        SliderModule,
        ReactiveFormsModule,
        TransferModule,
        CascaderModule], exports: [FormBuilderComponent,
        FormPreviewComponent] });
FormbuilderModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormbuilderModule, providers: [
        CommonService,
        {
            provide: FORM_ALERT,
            useClass: FormAlertComponent
        },
        {
            provide: FORM_CHECKBOX,
            useClass: FormCheckboxComponent
        },
        {
            provide: FORM_COUNTER,
            useClass: FormCounterComponent
        },
        {
            provide: FORM_DATE,
            useClass: FormDateComponent
        },
        {
            provide: FORM_DIVIDER,
            useClass: FormDividerComponent
        },
        {
            provide: FORM_INPUT,
            useClass: FormInputComponent
        },
        {
            provide: FORM_LAYOUT,
            useClass: FormLayoutComponent
        },
        {
            provide: FORM_RADIO,
            useClass: FormRadioComponent
        },
        {
            provide: FORM_RATE,
            useClass: FormRateComponent
        },
        {
            provide: FORM_RICHINPUT,
            useClass: FormRichinputComponent
        },
        {
            provide: FORM_SELECT,
            useClass: FormSelectComponent
        },
        {
            provide: FORM_SLIDER,
            useClass: FormSliderComponent
        },
        {
            provide: FORM_SPACE,
            useClass: FormSpaceComponent
        },
        {
            provide: FORM_TIME,
            useClass: FormTimeComponent
        },
        {
            provide: FORM_TOGGLE,
            useClass: FormToggleComponent
        },
        {
            provide: FORM_TRANSFER,
            useClass: FormTransferComponent
        },
        {
            provide: FORM_TREE,
            useClass: FormTreeComponent
        },
        {
            provide: FORM_UPLOAD,
            useClass: FormUploadComponent
        }
    ], imports: [[
            CommonModule,
            BrowserAnimationsModule,
            BrowserModule,
            FormModule,
            TextInputModule,
            LayoutModule,
            TabsModule,
            FormsModule,
            TextareaModule,
            ToggleModule,
            SelectModule,
            CKEditorModule,
            InputNumberModule,
            ButtonModule,
            ModalModule,
            CodemirrorModule,
            HttpClientModule,
            AlertModule,
            CheckBoxModule,
            RadioModule,
            DatepickerModule,
            TimePickerModule,
            UploadModule,
            RateModule,
            ProgressModule,
            ToastModule,
            DatepickerProModule,
            SliderModule,
            ReactiveFormsModule,
            TransferModule,
            CascaderModule
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.3.6", ngImport: i0, type: FormbuilderModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        FormComponentComponent,
                        FormCanvasComponent,
                        FormAttributeComponent,
                        FormBuilderComponent,
                        FormDragDirective,
                        FormDropDirective,
                        FormBoxComponent,
                        FormInputComponent,
                        FormDragTemplateDirective,
                        FormRichinputComponent,
                        FormCounterComponent,
                        FormPreviewComponent,
                        FormToggleComponent,
                        FormAreaComponent,
                        FormLayoutComponent,
                        FormSelectComponent,
                        FormCodeEditorComponent,
                        FormAlertComponent,
                        FormRadioComponent,
                        FormCheckboxComponent,
                        FormUploadComponent,
                        FormRateComponent,
                        FormTimeComponent,
                        FormDateComponent,
                        FormSpaceComponent,
                        FormDividerComponent,
                        FormSliderComponent,
                        FormTransferComponent,
                        FormTreeComponent
                    ],
                    exports: [
                        FormBuilderComponent,
                        FormPreviewComponent
                    ],
                    imports: [
                        CommonModule,
                        BrowserAnimationsModule,
                        BrowserModule,
                        FormModule,
                        TextInputModule,
                        LayoutModule,
                        TabsModule,
                        FormsModule,
                        TextareaModule,
                        ToggleModule,
                        SelectModule,
                        CKEditorModule,
                        InputNumberModule,
                        ButtonModule,
                        ModalModule,
                        CodemirrorModule,
                        HttpClientModule,
                        AlertModule,
                        CheckBoxModule,
                        RadioModule,
                        DatepickerModule,
                        TimePickerModule,
                        UploadModule,
                        RateModule,
                        ProgressModule,
                        ToastModule,
                        DatepickerProModule,
                        SliderModule,
                        ReactiveFormsModule,
                        TransferModule,
                        CascaderModule
                    ],
                    providers: [
                        CommonService,
                        {
                            provide: FORM_ALERT,
                            useClass: FormAlertComponent
                        },
                        {
                            provide: FORM_CHECKBOX,
                            useClass: FormCheckboxComponent
                        },
                        {
                            provide: FORM_COUNTER,
                            useClass: FormCounterComponent
                        },
                        {
                            provide: FORM_DATE,
                            useClass: FormDateComponent
                        },
                        {
                            provide: FORM_DIVIDER,
                            useClass: FormDividerComponent
                        },
                        {
                            provide: FORM_INPUT,
                            useClass: FormInputComponent
                        },
                        {
                            provide: FORM_LAYOUT,
                            useClass: FormLayoutComponent
                        },
                        {
                            provide: FORM_RADIO,
                            useClass: FormRadioComponent
                        },
                        {
                            provide: FORM_RATE,
                            useClass: FormRateComponent
                        },
                        {
                            provide: FORM_RICHINPUT,
                            useClass: FormRichinputComponent
                        },
                        {
                            provide: FORM_SELECT,
                            useClass: FormSelectComponent
                        },
                        {
                            provide: FORM_SLIDER,
                            useClass: FormSliderComponent
                        },
                        {
                            provide: FORM_SPACE,
                            useClass: FormSpaceComponent
                        },
                        {
                            provide: FORM_TIME,
                            useClass: FormTimeComponent
                        },
                        {
                            provide: FORM_TOGGLE,
                            useClass: FormToggleComponent
                        },
                        {
                            provide: FORM_TRANSFER,
                            useClass: FormTransferComponent
                        },
                        {
                            provide: FORM_TREE,
                            useClass: FormTreeComponent
                        },
                        {
                            provide: FORM_UPLOAD,
                            useClass: FormUploadComponent
                        }
                    ]
                }]
        }] });

/*
 * Public API Surface of formbuilder
 */

/**
 * Generated bundle index. Do not edit.
 */

export { ALERTDEFAULT, BaseControl, CANVASDEFAULT, CHECKDEFAULT, COUNTERDEFAULT, CommonService, ControlBuilder, ControlType, DATEDEFAULT, DIVIDERDEFAULT, FORM_ALERT, FORM_CHECKBOX, FORM_COUNTER, FORM_DATE, FORM_DIVIDER, FORM_INPUT, FORM_LAYOUT, FORM_RADIO, FORM_RATE, FORM_RICHINPUT, FORM_SELECT, FORM_SLIDER, FORM_SPACE, FORM_TIME, FORM_TOGGLE, FORM_TRANSFER, FORM_TREE, FORM_UPLOAD, FormAlertComponent, FormAreaComponent, FormAttributeComponent, FormBoxComponent, FormBuilderComponent, FormCanvasComponent, FormCheckboxComponent, FormCodeEditorComponent, FormComponentComponent, FormCounterComponent, FormDateComponent, FormDividerComponent, FormDragDirective, FormDragTemplateDirective, FormDropDirective, FormInputComponent, FormLayoutComponent, FormPreviewComponent, FormRadioComponent, FormRateComponent, FormRichinputComponent, FormSelectComponent, FormSliderComponent, FormSpaceComponent, FormTimeComponent, FormToggleComponent, FormTransferComponent, FormTreeComponent, FormUploadComponent, FormbuilderModule, INPUTDEFAULT, LAYOUTDEFAULT, MAINCONTAINER, RADIODEFAULT, RATEDEFAULT, RICHINPUTDEFAULT, SELECTDEFAULT, SLIDEDEFAULT, SPACEDEFAULT, TIMEDEFAULT, TOGGLEDEFAULT, TRANSFERDEFAULT, TREEDEFAULT, UPLOADDEFAULT };
//# sourceMappingURL=tobytop-ng-formbuilder.mjs.map
